<?php
/***********************************************************
 *			admin.php
 *		    -----------------
 * Created		: Mon, Apr 19, 2004
 * Copyright		: (C) LookStrike Team
 * WebSite		: http://www.lookstrike.com
 *
 * $Id: admin.php,v 1.10 2008/02/03 21:08:22 jsgoupil Exp $
 *
 ***********************************************************/
define('IN_LS', true);
define('ADMIN', 32);
include('../modules/header.php');
include_once('../modules/class/db/db_admins.php');
include_once('../modules/class/db/db_players.php');
include_once('../modules/class/HelperDB.php');

define('NUMBER_OF_LEVEL', 6);
define('MASTER_ADMIN_ID', 1);

if (isset($_GET['new']) || isset($_GET['mod'])) {
	// Do we display the form add/edit ?
	$fDisplayForm = true;

	// Getting the ID
	$id = isset($_GET['mod']) ? $_GET['mod'] : 0;

	// Get the instance correctly filled (data from db and $_POST)
	//$admins_class = HelperDB::GetInstance('db_admins', $id, 'admin_'); // Nothing generic...
	$admins_class = HelperDB::GetInstance('db_admins', $id);
	$admins_class->setAdmin(true);

	// Specific : login
	if (isset($_POST['admin_login'])) {
		$admins_class->player_id = HelperDB::GetPlayerId($_POST['admin_login']);
		$id = $admins_class->player_id; // If we were adding but we found the same name
	}

	// Specific : level
	if (isset($_POST['admin_login'])) { // yeah check the login since the level is checkboxes
		$admins_class->level = 0; // We reset
	}
	for ($i = 0; $i < NUMBER_OF_LEVEL; $i++) {
		if (isset($_POST['admin_level'][$i]) && (bool)$_POST['admin_level'][$i] === true) {
			$admins_class->level |= pow(2, $i);
		}
	}

	// We are finished entering data
	if (isset($_POST['new_end'])) {
		// Specific : can't modify our own rights
		if (intval($session_data['player_id']) === intval($admins_class->player_id)) {
			$dobject = display_error($language['admin_nomodify'], $_SERVER['PHP_SELF'] . '?mod=' . $_GET['mod']);
			$dobject->draw();
			$fDisplayForm = false;
		} else {
			if (isset($_GET['mod'])) {
				$error = $admins_class->modify();
				$display = $language['end_modify'];
			} else {
				$error = $admins_class->insert();
				$display = $language['end_insert'];
			}
			if ($error !== db_data::ERROR_NONE) {				// An error occured
				$dobject = display_error($admins_class, $error);
				$dobject->draw();
				echo '<br />';
			} else {							// No error
				$dobject = display_updated($display, $_SERVER['PHP_SELF'], 2);
				$dobject->draw();
				$fDisplayForm = false;
			}
		}
	}

	if ($fDisplayForm === true) {						// Display Form ?
		// GLOBAL Variable used : login
		$admin_login = HelperDB::GetPlayerLogin($admins_class->player_id);

		if (isset($_GET['mod'])) {
			$language_table = $language['admin_mod'];
			echo '<form action="' . $_SERVER['PHP_SELF'] . '?mod=' . $_GET['mod'] . '" name="add_user" method="post">';
		} else {
			$language_table = $language['admin_add'];
			echo '<form action="' . $_SERVER['PHP_SELF'] . '?new=1" name="add_user" method="post">';
		}

		echo '<input type="hidden" name="new_end" value="1" />';
		$table_cols = array('player_id', 'level');
		$table = new LSTable(3, 2, '60%', $null);
		$table->setTitle($language_table);
		$table->addCellAttribute(0, 0, 'width', '30%');
		if (isset($_GET['mod'])) {
			$table->setText(0, 0, $language['common_login']);
			$table->setText(0, 1, '<input type="hidden" name="admin_login" value="' . $admin_login . '" size="20" style="width:150px" />' . $admin_login);
		} else {
			$table->setText(0, 0, $language['common_login'] . ' <font class="littletext">[ <a href="javascript:;" onclick="window.open(\'../site/search_tiny.php?search_form=add_user&amp;search_name=admin_login&amp;search_type=1\',\'search_mini\',\'toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=no,resizable=no,width=400,height=350,left=50,top=200\')">' . $language['common_search'] . '</a> ]</font>');
			$table->setText(0, 1, '<input type="text" name="admin_login" value="' . $admin_login . '" size="20" style="width:150px" />');
		}
		$table->setText(1, 0, $language['admin_level']);
		$text2display = '';
		for ($i = 0; $i < NUMBER_OF_LEVEL; $i++) {
			$text2display .= '<input type="checkbox" name="admin_level[' . $i . ']" id="admin_level' . $i . '"';
			if (intval($admins_class->level) & (1 << $i)) {
				$text2display .= ' checked="checked"';
			}
			$text2display .= ' /> <label for="admin_level' . $i . '">' . $language['admin_level' . $i] . '</label><br />';
		}
		$table->setText(1, 1, $text2display);
		$table->addCellAttribute(2, 0, 'align', 'center');
		$table->addCellAttribute(2, 0, 'colspan', '2');
		$table->setText(2, 0, '<input type="submit" value="' . $language['common_send'] . '" />');
		colorError($table, $table_cols, $admins_class->getError());
		$table->draw();
		echo '</form>';

		echo '<p><a class="blacktext" href="' . $_SERVER['PHP_SELF'] . '"><img src="../images/arrow2_left.gif" width="23" height="11" border="0" alt="&lt;" />' . $language['common_back'] . '</a></p>';
	}
} elseif (isset($_GET['del'])) {
	// Specific : prevent admin to be deleted
	if (intval($_GET['del']) === MASTER_ADMIN_ID) {
		$dobject = display_error($language['admin_deladmin'], $_SERVER['PHP_SELF']);
		$dobject->draw();
	} else {
		$admins_class = new db_admins();
		$admins_class->fill(array('player_id' => $_GET['del']));
		$error = $admins_class->delete();
		if ($error !== db_data::ERROR_NONE) {
			$dobject = display_error($admins_class, $error, $_SERVER['PHP_SELF']);
			$dobject->draw();
		} else {
			$dobject = display_updated($language['end_delete'], $_SERVER['PHP_SELF'], 2);
			$dobject->draw();
		}
	}
} else {
	$admins_class = db_data::searchForClass('db_admins', '', '', '', 'player_id');
	$line = count($admins_class);

	$table = new LSTable($line + 1, 3, '60%', $null);
	$table->setTitle($language['admin_admin']);
	for ($i = 0; $i < $line; $i++) {
		$template = array();
		$template['player_id'] = $admins_class[$i]->player_id;
		$template['nickname'] = HelperDB::GetPlayerLogin($admins_class[$i]->player_id);
		$template['level'] = $admins_class[$i]->level;

		$table->addCellAttribute($i + 1, 0, 'width', '70%');
		$table->setText($i + 1, 0, '<a href="?mod=' . $template['player_id'] . '">' . $template['nickname'] . '</a>');
		$table->addCellAttribute($i + 1, 1, 'align', 'center');
		$table->setText($i + 1, 1, $template['level']);
		$table->addCellAttribute($i + 1, 2, 'align', 'center');
		$table->addCellAttribute($i + 1, 2, 'width', '15');
		$table->setText($i + 1, 2, '<a href="' . $_SERVER['PHP_SELF'] . '?del=' . $template['player_id'] . '"><img src="../images/x.gif" width="15" height="15" border="0" alt="X" /></a>');
	}
	if($line === 0) {
		$table->addCellAttribute(0, 0, 'align','center');
		$table->addCellAttribute(0, 0, 'colspan', '3');
		$table->setText(0, 0, $language['admin_noadmins']);
	} else {
		$table->addRowAttribute(0, 'class', 'table_title');
		$table->addAllCellsInRowAttribute(0, 'align', 'center');
		$table->setText(0, 0, '<b>' . $language['common_login'] . '</b>');
		$table->setText(0, 1, '<b>' . $language['admin_level'] . '</b>');
	}
	// Impossible to have no admins...
	$table->draw();
	echo '<br /><form action="' . $_SERVER['PHP_SELF'] . '?new=1" method="post"><div align="center"><input type="submit" value="' . $language['common_add'] . '" /></div></form>';
	echo '<p><a class="blacktext" href="index.php"><img src="../images/arrow2_left.gif" width="23" height="11" border="0" alt="&lt;" />' . $language['common_back'] . '</a></p>';
}

include('../modules/footer.php');
?>