<?php
/***********************************************************
 *			match.php
 *		    -----------------
 * Created		: Sat, May 2, 2004
 * Copyright		: (C) LookStrike Team
 * WebSite		: http://www.lookstrike.com
 *
 * $Id: match.php,v 1.12 2008/02/09 20:34:55 jsgoupil Exp $
 *
 ***********************************************************/
define('IN_LS', true);
define('ADMIN', 4);
include('../modules/header.php');
include_once('../modules/class/db/db_tournaments.php');
include_once('../modules/class/db/db_games.php');
include_once('../modules/class/db/db_trees.php');
include_once('../modules/class/tournament/RuleBuilder.php');

include_once('../modules/class/HelperDB.php');

function tree_findChild($nParentId, $table, $position, $strPool, $strTree) {
	global $language;

	$whereClause = array('previous'=>$nParentId);
	if($position === 0) {
		$orderClause = 'DESC';
	} else {
		$orderClause = 'ASC';
	}
	$trees = db_data::searchForClass('db_trees', $whereClause, array('tree_id'=>$orderClause), '', 'tree_id');
	$line = count($trees);

	for($i = 0; $i < $line; $i++) {
		$final = '';
		if(intval($trees[$i]->tree_type) === 0 && intval($trees[$i]->previous) !== 0) {
			$final = ' <span class="littletext">(' . $language['match_final'] . ')</font>';
		}

		if( intval($trees[$i]->tree_type) === 0 ) {
			$languageCode = $strPool;
		} else {
			$languageCode = $strTree;
		}

		$pos = $table->numRows();
		$table->insertRows( $pos, 1 );
		$nbMatches = db_data::getCount('matches', array('tree_id'=>$trees[$i]->tree_id));
		$nbWaiting = db_data::getCount('matches', array('AND'=>array('tree_id'=>$trees[$i]->tree_id, 'end_time'=>'0000-00-00 00:00:00')));
		$table->setText($pos, 0, '<img src="../images/blank.gif" style="width: ' . ($position * 20) . 'px; height: 1px;" alt="" /><a href="' . $_SERVER['PHP_SELF'] . '?id=' . $trees[$i]->tree_id . '">' . $languageCode . ' #' . $trees[$i]->tree_id . '</a>' .  $final);
		$table->addCellAttribute($pos, 1, 'align', 'center');
		$table->addCellAttribute($pos, 1, 'class', 'nowrap');
		$table->setText($pos, 1, HelperDB::GetTournamentName( $trees[$i]->tournament_id ));
		$table->addCellAttribute($pos, 2, 'align', 'center');
		$table->setText($pos, 2, $nbWaiting);
		$table->addCellAttribute($pos, 3, 'align', 'center');
		$table->setText($pos, 3, $nbMatches);
		tree_findChild($trees[$i]->tree_id, $table, $position + 1, $strPool, $strTree);
	}
}

function getTime($seconds) {
	global $language;

	$toreturn = '';
	if(($temp = intval($seconds / (60 * 60 * 24))) >= 1) {
		$seconds -= $temp * (60 * 60 * 24);
		$toreturn .= $temp . $language['match_time']['d'] . ' ';
	}
	if(($temp = intval($seconds / (60 * 60))) >= 1) {
		$seconds -= $temp * (60 * 60);
		$toreturn .= $temp . $language['match_time']['h'] . ' ';
	}
	if(($temp = intval($seconds / (60))) >= 1) {
		$seconds -= $temp * 60;
		$toreturn .= $temp . $language['match_time']['m'] . ' ';
	}
	$toreturn .= $seconds . $language['match_time']['s'];
	return $toreturn;
}

/**
 * Return players/teams of a tournament in selectbox
 */
function getTeamBox($tournament_id, $name, $selected) {
	global $language;

	$db_tournament_teams = new db_tournament_teams();
	$tournament_teams = db_data::searchForClass('db_tournament_teams', array('tournament_id'=>$tournament_id), '', '', $db_tournament_teams->getPrimary());
	$c = count($tournament_teams);
	$toreturn = '<select name="' . $name . '" size="1" style="width:200px"><option value="0">' . $language['match_selecttp'] . '</option>';
	for($i = 0; $i < $c; $i++) {
		$toreturn .= '<option value="' . $tournament_teams[$i]->team_id . '"';
		if(intval($tournament_teams[$i]->team_id) === intval($selected)) {
			$toreturn .= ' selected="selected"';
		}
		$toreturn .= '>' . getTeamName($tournament_teams[$i]->team_id) . '</option>';
	}
	$toreturn .= '</select>';

	return $toreturn;
}

function checkDuplicate(&$table) {
	$c1 = count($table);
	for($i = 0; $i < $c1; $i++) {
		$c2 = count($table);
		for($j = $i + 1; $j < $c2; $j++) {
			if($table[$i] === $table[$j]) {
				return false;
			}
		}
	}
	return true;
}

if(isset($_GET['add']) && intval($_GET['add']) > 1 && isset($_GET['add_t']) && intval($_GET['add_t']) >= 1) {
	if(isset($_POST['add_team'])){		// On ajoute un match
		$team_temp = $_POST['add_team'];
		$team_real = array();
		$c = count($team_temp);
		for($i = 0; $i < $c; $i++) {
			if(intval($team_temp[$i]) !== 0) {
				$team_real[] = $team_temp[$i];
			}
		}
		if(count($team_real) >= 2) {	// Il faut qu'il y ait 2 quipes au moins
			if(checkDuplicate($team_real)) {
				$addcomment = (trim($_POST['add_comment']) !== '') ? '\'' . trim($_POST['add_comment']) . '\'' : NULL;
				$match = new db_matches();
				$match->tournament_id = $_GET['add_t'];
				$match->comment = $addcomment;
				$error = $match->insert();
				if( $error === db_data::ERROR_NONE ) {
					$c = count($team_real);
					for($i = 0; $i < $c; $i++) {
						$match_team = new db_match_teams();
						$match_team->match_id = $match->match_id;
						$match_team->team_id = $team_real[$i];
						$match_team->insert();
					}

					$dobject = display_updated($language['end_insert'], $_SERVER['PHP_SELF'], 2);
					$dobject->draw();
				} else {
					$dobject = display_error($match, $error);
					$dobject->draw();
				}
			} else {			// Des quipes sont dupliques
				$dobject = display_error($language['match_same'], $_SERVER['PHP_SELF'] . '?add=' . $_GET['add'] . '&amp;add_t=' . $_GET['add_t']);
				$dobject->draw();
			}
		} else {				// Il manque des quipes
			$dobject = display_error($language['match_choose2'], $_SERVER['PHP_SELF'] . '?add=' . $_GET['add'] . '&amp;add_t=' . $_GET['add_t']);
			$dobject->draw();
		}
	} else {					// On affiche les quipes qui ont le droit de jouer dans le tournoi
		$tourn_result = $db->sql_query('SELECT b.game_id,b.name FROM ' . $sys_conf['db']['table_prefix'] . 'tournaments a, ' . $sys_conf['db']['table_prefix'] . 'games b WHERE a.tournament_id=\'' . $_GET['add_t'] . '\' AND a.status=\'1\' AND a.game_id=b.game_id');
		$tourn_line = $db->sql_numrows($tourn_result);
		$tourn_data = $db->sql_fetchrow($tourn_result);
		if($tourn_line === 1) {
			echo '<form action="' . $_SERVER['PHP_SELF'] . '?add=' . $_GET['add'] . '&amp;add_t=' . $_GET['add_t'] . '" method="post">';
			$table = new LSTable($_GET['add'] + 2, 2, '60%', $null);
			$table->setTitle($language['match_addmatch'] . ' : ' . $tourn_data['name'] . ' #' . gamenumber($_GET['add_t'], $tourn_data['game_id']));
			$c = intval($_GET['add']);
			for($i = 0; $i < $c; $i++) {
				$table->setText($i, 0, $language['match_participant'] . ' #' . ($i + 1));
				$table->addCellAttribute($i, 1, 'width', '200');
				$table->setText($i, 1, getTeamBox($_GET['add_t'], 'add_team[' . $i . ']', 0));
			}
			$table->setText($i, 0, $language['common_comment']);
			$table->setText($i, 1, '<input type="text" name="add_comment" size="30" style="width:200px" />');
			$table->addCellAttribute($i + 1, 0, 'align', 'center');
			$table->addCellAttribute($i + 1, 0, 'colspan', '2');
			$table->setText($i + 1, 0, '<input type="submit" value="' . $language['common_send'] . '" />');
			$table->draw();
			echo '</form>';
		} else {
			$dobject = display_error($language['match_notourn'], $_SERVER['PHP_SELF']);
			$dobject->draw();
		}
		echo '<p><a class="blacktext" href="' . $_SERVER['PHP_SELF'] . '?id=0"><img src="../images/arrow2_left.gif" width="23" height="11" border="0" alt="&lt;" />' . $language['common_back'] . '</a></p>';
	}
} elseif(isset($_GET['match']) && intval($_GET['match']) > 0) {		// On modifie un match
	$match = new db_matches();
	$match->fill(array('match_id'=>$_GET['match']));

	$match_result = $db->sql_query('SELECT a.tournament_id,a.comment,a.start_time,a.end_time,a.tree_id,a.server_id,b.game_id,b.status,b.server_group,c.name FROM ' . $sys_conf['db']['table_prefix'] . 'matches a, ' . $sys_conf['db']['table_prefix'] . 'tournaments b, ' . $sys_conf['db']['table_prefix'] . 'games c WHERE a.tournament_id=b.tournament_id AND b.game_id=c.game_id AND a.match_id=\'' . $_GET['match'] . '\'');
	$match_line = $db->sql_numrows($match_result);
	$match_data = $db->sql_fetchrow($match_result);
	if(intval($match->match_id) !== 0) {
		$tournament = new db_tournaments();
		$tournament->fill(array('tournament_id'=>$match->tournament_id));
		$game = new db_games();
		$game->fill(array('game_id'=>$tournament->game_id));

		if(isset($_POST['match_data'])) {		// On entre les informations du match
			$matchdata = $_POST['match_data'];
			$arrTeams = array();
			$arrScores = array();
			$error = false;
			$c = count($matchdata);
			for($i = 0; $i < $c; $i++) {
				if(intval($matchdata[$i]['team']) === 0 || in_array($matchdata[$i]['team'], $arrTeams)) {
					$error = true;
				}
				$arrTeams[$i] = $matchdata[$i]['team'];
				$arrScores[$i] = $matchdata[$i]['score'];
			}
			if($error === false) {
				$score = array_unique($arrScores);
				// Score not entered?
				if(intval($score[0]) === 0 && count($score) === 1) {
					$dobject = display_error($language['match_noscore']);
					$dobject->draw();
				} else {
					$pRule = TRuleBuilder::BuildRule( $match->tree_id );
					$ret = $pRule->SaveMatch( $_GET['match'], $arrTeams, $arrScores );
					if($ret === true) {
						$pRule->draw( '..' );
						$dobject = display_updated($language['end_modify'], $_SERVER['PHP_SELF'], 2);
						$dobject->draw();
					} else {
						$dobject = display_error($language['match_errorscore']);
						$dobject->draw();
					}
				}
			} else {
				$dobject = display_error($language['match_teamerror']);
				$dobject->draw();
			}
		} else {
			if(isset($_GET['del']) && intval($_GET['del']) === 1 && intval($match_data['tree_id']) === 0) {		// Supprimer un match
				$error = $match->delete();
				if( $error === db_data::ERROR_NONE ) {
					$dobject = display_updated($language['end_delete'], $_SERVER['PHP_SELF'], 2);
					$dobject->draw();
				} else {
					$dobject = display_error($match, $error);
					$dobject->draw();
				}
			} else {
				if(isset($_POST['match_comment']) && isset($_POST['match_commserv']) && intval($_POST['match_commserv']) === 1) { // On post le commentaire
					$match->comment = $_POST['match_comment'];
					$match->modify();
				}
				if(isset($_POST['match_server']) && isset($_POST['match_commserv']) && intval($_POST['match_commserv']) === 2) {
					if(intval($_POST['match_server']) === 0) {
	/* TODO
						// On va supprimer le serveur du match
						Server::setInactive($_GET['match']);		// On desactive le serveur en cours s'il tait utilis
						// On mets le server  celui qu'on a la.
						$match_data['server_id'] = $_POST['match_server'];
	*/
					} else {
	/*
						if($match_data['end_time'] === '0000-00-00 00:00:00') {
							$ret = Server::setActive($_GET['match'], $_POST['match_server']);		// On active le nouveau serveur
							if($ret == true) {			// On mets le server  celui qu'on a la.
								$match_data['server_id'] = $_POST['match_server'];
							} else{
								$dobject = display_error($language['already_assigned'], NULL);
								$dobject->setNumRows(1);
								$dobject->draw();
							}
						}
	*/
					}
				}
				// Affichage des informations + modifier commentaire
				echo '<script language="JavaScript" type="text/javascript">function postform(form,val){form.match_commserv.value=val;form.submit();}</script>';
				echo '<form action="' . $_SERVER['PHP_SELF'] . '?match=' . $_GET['match'] . '" method="post">';
				echo '<input type="hidden" name="match_commserv" value="0" />';
				$table = new LSTable(5, 2, '80%', $null);
				$table->setTitle($language['match_info'] . ' #' . $_GET['match']);
				$table->setText(0, 0, $language['common_tournament']);
				$text2display = '';
				if(intval($tournament->status) === db_tournaments::STATUS_OVER) {
					$text2display .= ' <font class="littletext">(' . $language['match_ended'] . ')</font>';
				}
				$table->setText(0, 1, $game->name . ' #' . gamenumber($tournament->tournament_id, $tournament->game_id) . $text2display);
				$table->setText(1, 0, $language['common_comment']);
				$table->setText(1, 1, '<input type="text" name="match_comment" value="' . $match->comment . '" size="40" style="width:250px" /><input type="button" value="' . $language['match_update'] . '" onclick="postform(this.form,1);" />');
				$table->setText(2, 0, $language['match_status']);
				$text2display = '';
				if($match->end_time === '0000-00-00 00:00:00') {
					$text2display .= $language['match_startedsince'] . ' : ' . getTime(date('U') - transform_timestamp($match->start_time, 'U'));
				} else {
					$text2display .= $language['match_endedsince'] . ' : ' . getTime(date('U') - transform_timestamp($match->end_time, 'U')) . '<br />' . $language['match_lastfor'] . ' : ' . getTime(transform_timestamp($match->end_time, 'U') - transform_timestamp($match->start_time, 'U'));
				}
				$table->setText(2, 1, $text2display);
				$table->setText(3, 0, $language['match_special']);
				if(intval($match->tree_id) !== 0) {		// Si il y a un arbre associ, on l'affiche
					$tree = new db_trees();
					$tree->fill(array('tree_id'=>$match->tree_id));
					$text2display = '<a href="javascript:;" onclick="window.open(\'../site/picture.php?to=/generated/' . $match->tree_id . '.png&amp;page=1\',\'display\',\'toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=400,height=350,left=35,top=35\')">';
					$text2display .= (intval($tree->tree_type) === 0) ? $language['common_pool'] : $language['common_tree'];
					$text2display .= ' #' . $match_data['tree_id'];
					$text2display .= '</a>';
					$table->setText(3, 1, $text2display);

				} else {						// Sinon on affiche le bouton supprimer
					echo '<script language="JavaScript" type="text/javascript">';
					echo 'function del_confirm(){';
					echo 'if(confirm(\'' . $language['match_areusure'] . '\'))';
					echo 'window.location=\'' . $_SERVER['PHP_SELF'] . '?match=' . $_GET['match'] . '&del=1\';';
					echo '}';
					echo '</script>';
					$link = 'javascript:del_confirm()';
					$table->setText(3, 1, '<a href="' . $link . '"><img src="../images/x.gif" width="15" height="15" border="0" alt="X" style="vertical-align: middle;" /></a> <a href="' . $link . '">' . $language['common_delete'] . '</a>');
				}
				$table->setText(4, 0, $language['common_server']);

// TODO
				if($match_data['server_group'] === NULL) {
					$text2display = $language['match_noserverfunc'];
				} else {
					$text2display = '';
					$text2display .= '<select name="match_server" size="1" style="width:250px">';
					$server_result = $db->sql_query('SELECT server_id,ip,port FROM ' . $sys_conf['db']['table_prefix'] . 'server_ip WHERE group_id=\'1\' AND server_id NOT IN (SELECT server_id FROM ' . $sys_conf['db']['table_prefix'] . 'matches WHERE server_id IS NOT NULL AND match_id!=\'' . $_GET['match'] . '\')');

					$server_line = $db->sql_numrows($server_result);
					$server_data = $db->sql_fetchrowset($server_result);

					if($server_line > 0) {
						$text2display .= '<option value="0">' . $language['match_notalloc'] . '</option>';
					}

					for($i = 0; $i < $server_line; $i++) {
						$text2display .= '<option value="' . $server_data[$i]['server_id'] . '"';
						if(intval($match_data['server_id']) === intval($server_data[$i]['server_id'])) {
							$text2display .= ' selected="selected"';
						}
						$text2display .= '>' . $language['common_server'] . ' #' . $server_data[$i]['server_id'] . ' &lt;' . decode_ip($server_data[$i]['ip']) . ':' . $server_data[$i]['port'] . '&gt;</option>';
					}

					if($server_line === 0) {
						$text2display .= '<option value="0">' . $language['match_noserver'] . '</option>';
					}

					$text2display .= '</select>';

					if($server_line != 0) {
						$text2display .= '<input type="button" value="' . $language['match_update'] . '" onclick="postform(this.form,2);" />';
					}
				}
// END OF TODO
				$table->setText(4, 1, $text2display);
				$table->draw();
				echo '</form>';

				echo '<br />';
				echo '<form action="' . $_SERVER['PHP_SELF'] . '?match=' . $_GET['match'] . '" method="post">';
				$db_match_teams = new db_match_teams();
				$match_teams = db_data::searchForClass('db_match_teams', array('match_id'=>$_GET['match']), '', '', $db_match_teams->getPrimary());
				$c = count($match_teams);
				$table = new LSTable($c + 1, 2, '50%', $null);
				$table->setTitle($language['match_players'] . '/' . $language['match_teams']);
				for($i = 0; $i < $c; $i++) {
					$table->setText($i, 0, getTeamBox($match->tournament_id, 'match_data[' . $i . '][team]', $match_teams[$i]->team_id));
					$table->addCellAttribute($i, 1, 'align', 'center');
					$table->addCellAttribute($i, 1, 'width', '40');
					$table->setText($i, 1, '<input type="text" name="match_data[' . $i . '][score]" value="' . $match_teams[$i]->score . '" size="2" style="width:40px" tabindex="' . ($i + 1) . '" />');
				}
				$table->addCellAttribute($i, 0, 'align', 'center');
				$table->addCellAttribute($i, 0, 'colspan', '2');
				$table->setText($i, 0, '<input type="submit" value="' . $language['common_send'] . '" />');
				$table->draw();
				echo '</form>';

				echo '<p><a class="blacktext" href="' . $_SERVER['PHP_SELF'] . '"><img src="../images/arrow2_left.gif" width="23" height="11" border="0" alt="&lt;" />' . $language['common_back'] . '</a></p>';
			}
		}
	} else {
		$dobject = display_error($language['match_nomatch'], $_SERVER['PHP_SELF']);
		$dobject->draw();
	}
} else {
	if(isset($_GET['id'])) {	// Displays matches in pool/tree
		$oRule = TRuleBuilder::BuildRule( intval( $_GET['id'] ) );
		$oTree = $oRule->GetTree();
		$arrMatches = $oTree->GetMatches();
		$bAllMatches = ( isset( $_GET['all'] ) && intval( $_GET['all'] ) === 1 ) ? true : false;

		$useArrayMatches = array();
		$c1 = count( $arrMatches );
		if( !$bAllMatches ) {
			// if we are not displaying all matches, we removed them from our array
			for( $i = 0; $i < $c1; $i++ ) {
				if( $arrMatches[$i]->Get()->end_time === '0000-00-00 00:00:00' ) {
					$useArrayMatches[] = $arrMatches[$i];
				}
			}
		} else {
			$useArrayMatches = $arrMatches;
		}

		$c1 = count( $useArrayMatches );
		echo '<table width="100%" border="0" cellpadding="0" cellspacing="5">';
		for( $i = 0; $i < $c1; $i++ ) {
			if( ( ( $i + 1 ) % 3 ) === 1 ) {
				echo '<tr>';
			}

			echo '<td width="33%"><form action="' . $_SERVER['PHP_SELF'] . '?match=' . $useArrayMatches[$i]->Get()->match_id . '" method="post">';
			next_color(1);
			next_color();
			$table = new LSTable( 0, 2, '100%', $null );
			$table->setTitle( '<a href="' . $_SERVER['PHP_SELF'] . '?match=' . $useArrayMatches[$i]->Get()->match_id . '">' . $language['common_match'] . ' #' . $useArrayMatches[$i]->Get()->match_id . '</a>' );
			$arrMatchTeams = $useArrayMatches[$i]->getMatchTeams();
			$c2 = count( $arrMatchTeams ); // Number of teams
			$table->insertRows( 0, $c2 + 1 );
			for( $j = 0; $j < $c2; $j++ ) {
				$table->setText( $j, 0, HelperDB::GetTeamName( intval( $arrMatchTeams[$j]->Get()->team_id ) ) );
				$table->setText( $j, 1, '<input type="hidden" name="match_data[' . $j . '][team]" value="' . $arrMatchTeams[$j]->Get()->team_id .'" /><input type="text" name="match_data[' . $j . '][score]" value="' . $arrMatchTeams[$j]->Get()->score . '" size="2" style="width:40px" />' );
			}
			$table->addCellAttribute( $j, 0, 'align', 'right' );
			$table->addCellAttribute( $j, 0, 'colspan', '2' );
			$table->setText( $j, 0, '<input type="submit" value="' . $language['common_send'] . '" />' );
			$table->addAllCellsInColAttribute( 1, 'width', '40' );
			$table->draw();
			echo '</form></td>';

			if( ( ( $i + 1 ) % 3 ) === 0 ) {
				echo '</tr>';
			}
		}

		if( $c1 === 0 ) {
			$table = new LSTable( 1, 1, '50%', $null );
			$table->setTitle( $language['match_single'] );
			$table->addCellAttribute( 0, 0, 'align', 'center' );
			$table->setText( 0, 0, $language['match_nomatch'] );
			echo '<tr><td>';
			$table->draw();
			echo '</td></tr>';
		} else {
			if( ( ( $i + 1 ) % 3 ) !== 1 ) {
				echo '</tr>';
			}
		}
		echo '</table>';

		$text2display = '';
		if($bAllMatches === false) {
			$text2display .= $language['match_displayall'];
		} else {
			$text2display .= $language['match_displaynall'];
		}
		echo '<p align="center"><b><a href="' . $_SERVER['PHP_SELF'] . '?id=' . $_GET['id'] . '&amp;all=' . ( $bAllMatches ^ 1 ) . '" class="blacktext">' . $text2display . '</a></b></p>';

		if(intval($_GET['id']) === 0) {
			echo '<form action="' . $_SERVER['PHP_SELF'] . '" method="get">';
			$table = new LSTable(3, 2, '50%', $null);
			$table->setTitle($language['match_addmatch']);
			$table->setText(0, 0, $language['common_tournament']);
			$table->addCellAttribute(0, 1, 'align', 'center');
			$table->addCellAttribute(0, 1, 'width', '180');
			$text2display = '';
			$tourn_result = $db->sql_query('SELECT b.name,b.game_id,a.tournament_id FROM ' . $sys_conf['db']['table_prefix'] . 'tournaments a, ' . $sys_conf['db']['table_prefix'] . 'games b WHERE a.game_id=b.game_id AND a.status=\'1\' ORDER BY a.tournament_id DESC');
			$tourn_line = $db->sql_numrows($tourn_result);
			$tourn_data = $db->sql_fetchrowset($tourn_result);
			$text2display .= '<select size="1" name="add_t" style="width:180px">';
			for($i = 0; $i < $tourn_line; $i++) {
				$text2display .= '<option value="' . $tourn_data[$i]['tournament_id'] . '">' . $tourn_data[$i]['name'] . ' #' . gamenumber($tourn_data[$i]['tournament_id'], $tourn_data[$i]['game_id']) . '</option>';
			}
			$text2display .= '</select>';
			$table->setText(0, 1, $text2display);
			$table->setText(1, 0, $language['match_participant']);
			$table->addCellAttribute(1, 1, 'align', 'right');
			$table->setText(1, 1, '<input type="text" name="add" size="3" value="2" style="width:40px" />');
			$table->addCellAttribute(2, 0, 'align', 'center');
			$table->addCellAttribute(2, 0, 'colspan', '2');
			$table->setText(2, 0, '<input type="submit" value="' . $language['common_send'] . '" />');
			$table->draw();
			echo '</form>';
		}

		echo '<p><a class="blacktext" href="' . $_SERVER['PHP_SELF'] . '"><img src="../images/arrow2_left.gif" width="23" height="11" border="0" alt="&lt;" />' . $language['common_back'] . '</a></p>';
								   
	} else {
		echo '<form action="' . $_SERVER['PHP_SELF'] . '" method="get">';
		$table = new LSTable(1, 1, '50%', $null);
		$table->setTitle($language['match_goto']);
		$table->addCellAttribute(0, 0, 'align', 'center');
		$table->setText(0, 0, '<input type="text" name="match" size="5" /> <input type="submit" value="' . $language['common_send'] . '" />');
		$table->draw();
		echo '</form>';
		echo '<br />';

		// Displays pool/tree
		echo '<form action="' . $_SERVER['PHP_SELF'] . '" method="post">';
		$table = new LSTable(1, 4, '100%', $null);
		$table->setTitle($language['match_select']);
		tree_findChild(0, $table, 0, $language['common_pool'], $language['common_tree']);
		$table->addRowAttribute(0, 'class', 'table_title');
		$table->addAllCellsInRowAttribute(0,'align','center');
		$table->addCellAttribute(0, 0, 'style', 'width: 100%');
		$table->addCellAttribute(0, 1, 'class', 'nowrap');
		$table->addCellAttribute(0, 2, 'class', 'nowrap');
		$table->addCellAttribute(0, 3, 'class', 'nowrap');
		$table->setText(0, 0, '<b>' . $language['common_name'] . '</b>');
		$table->setText(0, 1, '<b>' . $language['common_tournament'] . '</b>');
		$table->setText(0, 2, '<b>' . $language['match_waiting'] . '</b>');
		$table->setText(0, 3, '<b>' . $language['match_total'] . '</b>');
		$table->insertRows( $pos = $table->numRows(), 1 );
		$table->setText($pos, 0, '<a href="' . $_SERVER['PHP_SELF'] . '?id=0">' . $language['match_single'] . '</a>');
		$table->setText($pos, 1, $language['match_mixtourn']);

		$nbMatches = db_data::getCount('matches', array('tree_id'=>0));
		$nbWaiting = db_data::getCount('matches', array('AND'=>array('tree_id'=>0, 'end_time'=>'0000-00-00 00:00:00')));

		$table->addCellAttribute($pos, 2, 'align', 'center');
		$table->addCellAttribute($pos, 3, 'align', 'center');
		$table->setText($pos, 2, $nbMatches);
		$table->setText($pos, 3, $nbWaiting);
		$table->addAllCellsInColAttribute(1, 'class', 'nowrap');
		$table->draw();
		echo '</form>';

		echo '<p><a class="blacktext" href="index.php"><img src="../images/arrow2_left.gif" width="23" height="11" border="0" alt="&lt;" />' . $language['common_back'] . '</a></p>';
	}
}

include('../modules/footer.php');
?>