<?php
/***********************************************************
 *			match_tree.php
 *		    ----------------------
 * Created		: Sat, May 2, 2004
 * Copyright		: (C) LookStrike Team
 * WebSite		: http://www.lookstrike.com
 *
 * $Id: match_tree.php,v 1.11 2008/02/09 20:34:55 jsgoupil Exp $
 *
 ***********************************************************/
define('IN_LS', true);
define('ADMIN', 4);
include('../modules/header.php');
include_once('../modules/class/db/db_tournaments.php');
include_once('../modules/class/db/db_games.php');
include_once('../modules/class/db/db_trees.php');
include_once('../modules/class/HelperDB.php');
include_once('../modules/class/ComponentHelpers.php');
include_once('../modules/class/tournament/RuleBuilder.php');
include_once('../modules/class/tournament/RulePool.php');
include_once('../modules/class/tournament/RuleTree.php');

define('TREE_POOL', 1);
define('TREE_TREE', 2);

function tree_findChild($nParentId, $table, $position, $pool, $languageCode) {
	global $language;

	$neg = '';
	if($pool === false) {
		$neg = '!';
	}

	if($position === 0) {
		$whereClause = array('AND'=>array('previous'=>$nParentId, $neg . 'tree_type'=>0));
		$orderClause = 'DESC';
	} else {
		$whereClause = array('previous'=>$nParentId);
		$orderClause = 'ASC';
	}
	$trees = db_data::searchForClass('db_trees', $whereClause, array('tree_id'=>$orderClause), '', 'tree_id');
	$line = count($trees);

	for($i = 0; $i < $line; $i++) {
		$final = '';
		if(intval($trees[$i]->tree_type) === 0 && $pool === false) {
			$final = ' <span class="littletext">(' . $language['tree_final'] . ')</font>';
		}

		$pos = $table->numRows();
		$table->insertRows( $pos, 1 );
		$nbMatches = db_data::getCount('matches', array('tree_id'=>$trees[$i]->tree_id));
		$table->addCellAttribute($pos, 0, 'align', 'center');
		$table->setText($pos, 0, '<input type="checkbox" name="matchtree_box[]" value="' . $trees[$i]->tree_id . '" />');
		$table->setText($pos, 1, '<img src="../images/blank.gif" style="width: ' . ($position * 20) . 'px; height: 1px;" alt="" /><a href="' . $_SERVER['PHP_SELF'] . '?matchtree_action=1&amp;matchtree_box[]=' . $trees[$i]->tree_id . '">' . $languageCode . ' #' . $trees[$i]->tree_id . '</a>' .  $final);
		$table->addCellAttribute($pos, 2, 'align', 'center');
		$table->addCellAttribute($pos, 2, 'class', 'nowrap');
		$table->setText($pos, 2, HelperDB::GetTournamentName( $trees[$i]->tournament_id ));
		$table->addCellAttribute($pos, 3, 'align', 'center');
		$table->setText($pos, 3, $nbMatches);
		tree_findChild($trees[$i]->tree_id, $table, $position + 1, $pool, $languageCode);
	}
}

if(isset($_POST['matchtree_newtree']) && intval($_POST['matchtree_newtree']) > 0) {
	if(isset($_POST['matchtree_type']) && (intval($_POST['matchtree_type']) === TREE_POOL || intval($_POST['matchtree_type']) === TREE_TREE)) {
		$rule = (intval($_POST['matchtree_type']) === TREE_POOL) ? new TRulePool() : new TRuleTree();
		// Automatic ?
		if(isset($_POST['matchtree_autogenerate']) && intval($_POST['matchtree_autogenerate']) === 1) {
			if( isset($_POST['matchtree_createit']) && intval($_POST['matchtree_createit']) === 1 ) {
				$rule->setFake( false );
			}

			if( isset($_POST['matchtree_random']) && intval($_POST['matchtree_random']) !== 0 ) {
				$rule->setRandom( $_POST['matchtree_random'] );
			}
			$nRandomNumber = $rule->Create( intval($_POST['matchtree_newtree']), intval($_POST['matchtree_previous']) );
			if( !is_int( $nRandomNumber ) ) {// TODO Next part never tested!
				// An error has occured
				$dobject = display_error($nRandomNumber[0], $nRandomNumber[1]);
				$dobject->draw();
			} else {
				if( isset($_POST['matchtree_createit']) && intval($_POST['matchtree_createit']) === 1 ) {
					$dobject = display_updated($language['tree_created'], $_SERVER['PHP_SELF'], 2);
					$dobject->draw();
				} else {
					$rule->getTree()->Get()->tree_id = 'temp_' . strval( $nRandomNumber ); // Just to save file
					$rule->draw( '..' );
					echo '<script type="text/javascript">';
					echo 'function actionForm( form, val ) {';
					echo '	if( val == 1 ) {';
					echo '		form.matchtree_createit.value = 0;';
					echo '		form.matchtree_random.value = 0;';
					echo '	} else {';
					echo '		form.matchtree_createit.value = 1;';
					echo '	}';
					echo '	form.submit();';
					echo '}';
					echo '</script>';
					echo '<form action="' . $_SERVER['PHP_SELF'] . '" method="post">';
					echo '<input type="hidden" name="matchtree_previous" value="' . $_POST['matchtree_previous'] . '" />';
					echo '<input type="hidden" name="matchtree_type" value="' . $_POST['matchtree_type'] . '" />';
					echo '<input type="hidden" name="matchtree_newtree" value="' . $_POST['matchtree_newtree'] . '" />';
					echo '<input type="hidden" name="matchtree_autogenerate" value="' . $_POST['matchtree_autogenerate'] . '" />';
					echo '<input type="hidden" name="matchtree_createit" value="0" />';
					echo '<input type="hidden" name="matchtree_random" value="' . $nRandomNumber . '" />';
					$table = new LSTable( 2, 2, '100%', $null );
					$table->setTitle( $language['tree_generate'] );
					$table->setText( 0, 0, $language['tree_doyouaccept'] );
					$table->addCellAttribute( 0, 1, 'align', 'center' );
					$table->setText( 0, 1, '<a href="../images/generated/temp_' . strval( $nRandomNumber ) . '.png" target="_blank"><img src="../images/generated/temp_' . strval( $nRandomNumber ) . '.png" style="width: 200px;" alt="" /></a>');
					$table->addCellAttribute( 1, 0, 'colspan', '2' );
					$table->addCellAttribute( 1, 0, 'align', 'center' );
					$table->setText( 1, 0, '<input type="button" value="' . $language['tree_createyes'] . '" onclick="actionForm(this.form, 2);" /> <input type="button" value="' . $language['tree_createno'] . '" onclick="actionForm(this.form, 1);" />' );
					$table->draw();
					echo '</form>';
				}
			}
		} else {
		// Manual ?
		/*
			$pTempTree = new db_trees();
			$pTempTree->tournament_id = intval($_POST['matchtree_newtree']);
			$pTempTree->previous = 0;
			$rule->Load( $pTempTree, true );
			var_dump($rule->GetManualPosition());
		*/
			$dobject = display_error('This feature will be available soon...');
			$dobject->draw();
		}
	} else {
		// Select pool/tree
		$table = new LSTable(4, 1, '50%', $null);
		$table->setTitle($language['tree_tournpt']);
		echo '<form action="' . $_SERVER['PHP_SELF'] . '" method="post">';
		echo '<input type="hidden" name="matchtree_newtree" value="' . $_POST['matchtree_newtree'] . '" />';
		$text2display = '<input type="radio" name="matchtree_type" id="matchtree_type_pool" value="' . TREE_POOL . '" checked="checked" /><label for="matchtree_type_pool">' . $language['common_pool'] . '</label>';
		$text2display .= '<br /><input type="radio" name="matchtree_type" id="matchtree_type_tree" value="' . TREE_TREE . '" /><label for="matchtree_type_tree">' . $language['common_tree'] . '</label>';
		$table->setText(0, 0, $text2display);
		$table->setText(1, 0, '<input type="checkbox" name="matchtree_autogenerate" id="matchtree_autogenerate" value="1" checked="checked" /><label for="matchtree_autogenerate">' . $language['tree_autogenerate'] . '</label>');
		$table->addCellAttribute(2, 0, 'align', 'center');
		$text2display = '<select name="matchtree_previous" size="1" style="width: 250px;"><option value="0">' . $language['tree_master'] . '</option>';
		$trees = db_data::searchForClass('db_trees', array(), '', '', 'tree_id');
		$c = count($trees);
		for($i = 0; $i < $c; $i++) {
			if(intval($trees[$i]->tree_type) === 0) {
				$l = $language['common_pool'];
			} else {
				$l = $language['common_tree'];
			}
			$l .= ' #'. $trees[$i]->tree_id;
			$text2display .= '<option value="' . $trees[$i]->tree_id . '">' . $l . '</option>';
		}
		$text2display .= '</select>';
		$table->setText(2, 0, $text2display);
		$table->addCellAttribute(3, 0, 'align', 'center');
		$table->setText(3, 0, '<input type="submit" value="' . $language['common_send'] . '" />');
		$table->draw();
		echo '</form>';
	}

	echo '<p><a class="blacktext" href="' . $_SERVER['PHP_SELF'] . '"><img src="../images/arrow2_left.gif" width="23" height="11" border="0" alt="&lt;" />' . $language['tree_restart'] . '</a></p>';
} else {
	if(isset($_REQUEST['matchtree_action']) && isset($_REQUEST['matchtree_box']) && intval($_REQUEST['matchtree_action']) === 1) {
		$arr = $_REQUEST['matchtree_box'];
		if(!is_array($arr)) {
			$arr = array($arr);
		}

		$text2display = '';
		$c = count($arr);
		for($i = 0; $i < $c; $i++) {
			$rule = TRuleBuilder::BuildRule( (int)$arr[$i] );
			if($rule instanceof TRule) {
				$success = $rule->draw( '..' );
				$code = ($rule instanceof TRulePool) ? $language['common_pool'] : $language['common_tree'];

				if($success === true) {
					$text2display .= '<br /> - <a href="javascript:;" onclick="window.open(\'../site/picture.php?to=/generated/' . (int)$arr[$i] . '.png&amp;page=1\',\'display\',\'toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=400,height=350,left=35,top=35\')">';
					$text2display .= $code . ' #' . $arr[$i];
					$text2display .= '</a>';
				} else {
					$text2display .= '<br /> - ' . $code . ' #' . $arr[$i] . ' (' . $language['common_error'] . ')';
				}
			}
		}
		$dobject = display_updated($language['tree_generateok'], $_SERVER['PHP_SELF'], NULL);
		$dobject->insertRows(1, 1);
		$dobject->setText(1, 0, $language['tree_visualize'] . ' : ' . $text2display);
		$dobject->draw();
	} elseif(isset($_REQUEST['matchtree_action']) && isset($_REQUEST['matchtree_box']) && intval($_REQUEST['matchtree_action']) === 2) {
		$delete_table = $_REQUEST['matchtree_box'];
		reset($delete_table);
		while (list($key, $value) = each($delete_table)) {
			$tree = new db_trees();
			$tree->fill(array('tree_id' => $value));
			$error = $tree->delete();
			// TODO Delete the image ?
		}
		$dobject = display_updated($language['end_delete'], $_SERVER['PHP_SELF'], 2);
		$dobject->draw();
	} else { /* ############ SECTION : Display current pool/tree */
		// Displays Pool
		$trees = db_data::searchForClass('db_trees', array('AND'=>array('previous'=>0, 'tree_type'=>0)), array('tree_id'=>'DESC'), '', 'tree_id');
		$line = count($trees);

		echo '<script type="text/javascript">
function setAction(form, action) {
	form.matchtree_action.value = action;
	form.submit();
}
</script>';
		echo '<form action="' . $_SERVER['PHP_SELF'] . '" method="post">
<input type="hidden" name="matchtree_action" value="0" />';
		$table = new LSTable(1, 4, '100%', $null);
		$table->setTitle($language['common_pool']);
		tree_findChild(0, $table, 0, true, $language['common_pool']);
		if($line === 0) {
			$table->addCellAttribute(0, 0, 'colspan', '4');
			$table->addCellAttribute(0, 0, 'align', 'center');
			$table->setText(0, 0, $language['tree_nopool']);
		} else {
			$table->addRowAttribute(0, 'class', 'table_title');
			$table->addAllCellsInRowAttribute(0, 'align', 'center');
			$table->addCellAttribute(0, 1, 'style', 'width: 100%');
			$table->addCellAttribute(0, 2, 'class', 'nowrap');
			$table->addCellAttribute(0, 3, 'class', 'nowrap');
			$table->setText(0, 1, '<b>' . $language['common_name'] . '</b>');
			$table->setText(0, 2, '<b>' . $language['common_tournament'] . '</b>');
			$table->setText(0, 3, '<b>' . $language['tree_matches'] . '</b>');

			$pos = $table->numRows();
			$table->insertRows($pos, 1);
			$table->addCellAttribute($pos, 0, 'colspan', '4');
			$table->setText($pos, 0, '<img src="../images/arrow.gif" alt="" /><button type="button" name="matchtree_generate" value="1" title="' . $language['tree_generate'] . '" onclick="setAction(this.form, 1);">
<img src="../images/refresh.gif" title="' . $language['tree_generate'] . '" alt="' . $language['tree_generate'] . '" width="15" height="15" style="vertical-align: top;" /> ' . $language['tree_generate'] . '
</button><img src="../images/blank.gif" style="width: 20px; height: 10px;" alt="" /><button type="button" name="matchtree_delete" value="1" title="' . $language['common_delete'] . '" onclick="setAction(this.form, 2);">
<img src="../images/x.gif" title="' . $language['common_delete'] . '" alt="' . $language['common_delete'] . '" width="15" height="15" style="vertical-align: top;" /> ' . $language['common_delete'] . '
</button>');
		}
		$table->draw();
		echo '</form>';
		echo '<br />';

		// Displays Tree
		$trees = db_data::searchForClass('db_trees', array('AND'=>array('previous'=>0, '!tree_type'=>0)), array('tree_id'=>'DESC'), '', 'tree_id');
		$line = count($trees);

		echo '<form action="' . $_SERVER['PHP_SELF'] . '" method="post">
<input type="hidden" name="matchtree_action" value="0" />';
		$table = new LSTable(1, 4, '100%', $null);
		$table->setTitle($language['common_tree']);
		tree_findChild(0, $table, 0, false, $language['common_tree']);
		if($line === 0) {
			$table->addCellAttribute(0, 0, 'colspan', '4');
			$table->addCellAttribute(0, 0, 'align', 'center');
			$table->setText(0, 0, $language['tree_notree']);
		} else {
			$table->addRowAttribute(0, 'class', 'table_title');
			$table->addAllCellsInRowAttribute(0, 'align', 'center');
			$table->addCellAttribute(0, 1, 'style', 'width: 100%');
			$table->addCellAttribute(0, 2, 'class', 'nowrap');
			$table->addCellAttribute(0, 3, 'class', 'nowrap');
			$table->setText(0, 1, '<b>' . $language['common_name'] . '</b>');
			$table->setText(0, 2, '<b>' . $language['common_tournament'] . '</b>');
			$table->setText(0, 3, '<b>' . $language['tree_matches'] . '</b>');

			$pos = $table->numRows();
			$table->insertRows($pos, 1);
			$table->addCellAttribute($pos, 0, 'colspan', '4');
			$table->setText($pos, 0, '<img src="../images/arrow.gif" alt="" /><button type="button" name="matchtree_generate" value="1" title="' . $language['tree_generate'] . '" onclick="setAction(this.form, 1);">
<img src="../images/refresh.gif" title="' . $language['tree_generate'] . '" alt="' . $language['tree_generate'] . '" width="15" height="15" style="vertical-align: top;" /> ' . $language['tree_generate'] . '
</button><img src="../images/blank.gif" style="width: 20px; height: 10px;" alt="" /><button type="button" name="matchtree_delete" value="1" title="' . $language['common_delete'] . '" onclick="setAction(this.form, 2);">
<img src="../images/x.gif" title="' . $language['common_delete'] . '" alt="' . $language['common_delete'] . '" width="15" height="15" style="vertical-align: top;" /> ' . $language['common_delete'] . '
</button>');
		}
		$table->addAllCellsInColAttribute(2, 'class', 'nowrap');
		$table->draw();
		echo '</form>';
		echo '<br />';

		$tournament_class = db_data::searchForClass('db_tournaments', array('status'=>db_tournaments::STATUS_PROGRESS), array('inserted'=>'DESC'), '', 'tournament_id');
		$line = count($tournament_class);
		$options = '';
		for ($i = 0; $i < $line; $i++) {
			$template = array();
			$template['id'] = $tournament_class[$i]->tournament_id;
			$template['name'] = HelperDB::GetTournamentName($tournament_class[$i]->tournament_id);

			$options .= '<option value="' . $template['id'] . '">' . $template['name'] . '</option>';
		}
		$disabled = '';
		if($line === 0) {
			$options .= '<option value="0">' . $language['tree_notournadd'] . '</option>';
			$disabled = ' disabled="disabled"';
		}

		echo '<form action="' . $_SERVER['PHP_SELF'] . '" method="post">';
		$table = new LSTable(1, 2, '1%', $null);
		$table->setTitle($language['tree_tournpt']);
		$table->addCellAttribute(0, 0, 'width', '100%');
		$table->setText(0, 0, '<select size="1" name="matchtree_newtree" style="width: 250px;"' . $disabled . '>' . $options . '</select>');
		$table->addCellAttribute(0, 1, 'class', 'nowrap');
		$table->setText(0, 1, '<input type="submit" value="' . $language['common_add'] . '"' . $disabled . ' />');
		$table->draw();
		echo '</form>';

		echo '<p><a class="blacktext" href="index.php"><img src="../images/arrow2_left.gif" width="23" height="11" border="0" alt="&lt;" />' . $language['common_back'] . '</a></p>';
	}
}

include('../modules/footer.php');
?>