<?php
/***********************************************************
 *			news.php
 *		    ----------------
 * Created		: Thr, Jan 1, 2004
 * Copyright		: (C) LookStrike Team
 * WebSite		: http://www.lookstrike.com
 *
 * $Id: news.php,v 1.8 2008/01/27 01:58:48 jsgoupil Exp $
 *
 ***********************************************************/
define('IN_LS', true);
define('ADMIN', 1);
include('../modules/header.php');
include_once('../modules/class/db/db_news.php');
include_once('../modules/class/db/db_players.php');
include_once('../modules/class/HelperDB.php');

// If we want to add or modify
if (isset($_GET['new']) || isset($_GET['mod'])) {
	// Do we display the form add/edit ?
	$fDisplayForm = true;

	// Getting the ID
	$id = isset($_GET['mod']) ? $_GET['mod'] : 0;

	// Get the instance correctly filled (data from db and $_POST)
	$news_class = HelperDB::GetInstance('db_news', $id, 'news_');
	$news_class->setAdmin(true);

	// We are finished entering data
	if (isset($_POST['new_end'])) {
		if (isset($_GET['mod'])) {
			$error = $news_class->modify();
			$display = $language['end_modify'];
		} else {
			$news_class->player_id = $session_data['player_id'];
			$error = $news_class->insert();
			$display = $language['end_insert'];
		}
		if ($error !== db_data::ERROR_NONE) {				// An error occured
			$dobject = display_error($news_class, $error);
			$dobject->draw();
			echo '<br />';
		} else {							// No error
			$dobject = display_updated($display, $_SERVER['PHP_SELF'], 2);
			$dobject->draw();
			$fDisplayForm = false;
		}
	}

	if ($fDisplayForm === true) {						// Display Form ?
		if (isset($_GET['mod'])) {
			$language_table = $language['news_mod'];
			echo '<form action="' . $_SERVER['PHP_SELF'] . '?mod=' . $_GET['mod'] . '" method="post">';
		} else {
			$language_table = $language['news_add'];
			echo '<form action="' . $_SERVER['PHP_SELF'] . '?new=1" method="post">';
		}

		$template = array();
		$template['subject'] = $news_class->subject;
		$template['texte'] = $news_class->texte;

		echo '<input type="hidden" name="new_end" value="1" />';
		$table_cols = array('subject', 'texte');
		$table = new LSTable(3, 2, '100%', $null);
		$table->setTitle($language_table);
		$table->addCellAttribute(0, 0, 'width', '100');
		$table->setText(0, 0, $language['news_subject']);
		$table->setText(0, 1, '<input type="text" name="news_subject" size="30" style="width:400px" value="' . $template['subject'] . '" />');
		$table->setText(1, 0, $language['news_text']);
		$table->setText(1, 1, '<textarea name="news_texte" cols="50" rows="10" style="width:400px">' . $template['texte'] . '</textarea>');
		$table->addCellAttribute(2, 0, 'align', 'center');
		$table->addCellAttribute(2, 0, 'colspan', '2');
		$table->setText(2, 0, '<input type="submit" value="' . $language['common_send'] . '" />');
		colorError($table, $table_cols, $news_class->getError());
		$table->draw();
		echo '</form>';

		echo '<p><a class="blacktext" href="' . $_SERVER['PHP_SELF'] . '"><img src="../images/arrow2_left.gif" width="23" height="11" border="0" alt="&lt;" />' . $language['common_back'] . '</a></p>';
	}
} elseif (isset($_GET['del'])) {
	$news_class = new db_news();
	$news_class->fill(array('news_id' => $_GET['del']));
	$error = $news_class->delete();
	if ($error !== db_data::ERROR_NONE) {
		$dobject = display_error($news_class, $error, $_SERVER['PHP_SELF']);
		$dobject->draw();
	} else {
		$dobject = display_updated($language['end_delete'], $_SERVER['PHP_SELF'], 2);
		$dobject->draw();
	}
} else {
	$news_class = db_data::searchForClass('db_news', '', array('inserted' => 'DESC'), '', 'news_id');
	$line = count($news_class);

	$table = new LSTable($line + 1, 4, '100%', $null);
	$table->setTitle($language['news_news']);
	for ($i = 0; $i < $line; $i++) {
		$template = array();
		$template['news_id'] = $news_class[$i]->news_id;
		$template['subject'] = $news_class[$i]->subject;
		$template['nickname'] = HelperDB::GetPlayerNickname($news_class[$i]->player_id);
		$template['inserted'] = $news_class[$i]->inserted;

		$table->setText($i + 1, 0, '<a href="' . $_SERVER['PHP_SELF'] . '?mod=' . $template['news_id'] . '">' . $template['subject'] .'</a>');
		$table->setText($i + 1, 1, $template['nickname']);
		$table->addCellAttribute($i + 1, 2, 'align', 'center');
		$table->setText($i + 1, 2, transform_timestamp($template['inserted']));
		$table->addCellAttribute($i + 1, 3, 'align', 'center');
		$table->addCellAttribute($i + 1, 3, 'width', '15');
		$table->setText($i + 1, 3, '<a href="' . $_SERVER['PHP_SELF'] . '?del=' . $template['news_id'] . '"><img src="../images/x.gif" width="15" height="15" border="0" alt="X" /></a>');
	}
	if($line === 0) {
		$table->addCellAttribute(0, 0, 'align','center');
		$table->addCellAttribute(0, 0, 'colspan', '4');
		$table->setText(0, 0, $language['news_nonews']);
	} else {
		$table->addAllCellsInRowAttribute(0, 'align', 'center');
		$table->addAllCellsInRowAttribute(0, 'class', 'table_title');
		$table->setText(0, 0, '<b>' . $language['news_subject'] . '</b>');
		$table->setText(0, 1, '<b>' . $language['news_author'] . '</b>');
		$table->addCellAttribute(0, 2, 'width', '150');
		$table->setText(0, 2, '<b>' . $language['news_time'] . '</b>');
	}
	$table->draw();
	echo '<br /><form action="' . $_SERVER['PHP_SELF'] . '?new=1" method="post"><div align="center"><input type="submit" value="' . $language['common_add'] . '" /></div></form>';
	echo '<p><a class="blacktext" href="index.php"><img src="../images/arrow2_left.gif" width="23" height="11" border="0" alt="&lt;" />' . $language['common_back'] . '</a></p>';
}

include('../modules/footer.php');
?>