<?php
/***********************************************************
 *			platform.php
 *		    --------------------
 * Created		: Wed, Dec 22, 2004
 * Copyright		: (C) LookStrike Team
 * WebSite		: http://www.lookstrike.com
 *
 * $Id: platform.php,v 1.7 2008/02/03 21:08:22 jsgoupil Exp $
 *
 ***********************************************************/
define('IN_LS', true);
define('ADMIN', 16);
include('../modules/header.php');
include('../modules/class/db/db_platform.php');
include('../modules/class/db/db_games.php');
include('../modules/class/HelperDB.php');

// If we want to add or modify
if (isset($_GET['new']) || isset($_GET['mod'])) {
	// Do we display the form add/edit ?
	$fDisplayForm = true;

	// Getting the ID
	$id = isset($_GET['mod']) ? $_GET['mod'] : 0;

	// Get the instance correctly filled (data from db and $_POST)
	$platform_class = HelperDB::GetInstance('db_platform', $id, 'platform_');
	$platform_class->setAdmin(true);

	// We are finished entering data
	if (isset($_POST['new_end'])) {
		if (isset($_GET['mod'])) {
			$error = $platform_class->modify();
			$display = $language['end_modify'];
		} else {
			$error = $platform_class->insert();
			$display = $language['end_insert'];
		}
		if ($error !== db_data::ERROR_NONE) {				// An error occured
			$dobject = display_error($platform_class, $error);
			$dobject->draw();
			echo '<br />';
		} else {							// No error
			$dobject = display_updated($display, $_SERVER['PHP_SELF'], 2);
			$dobject->draw();
			$fDisplayForm = false;
		}
	}

	if ($fDisplayForm === true) {						// Display Form ?
		if (isset($_GET['mod'])) {
			$language_table = $language['platform_mod'];
			echo '<form action="' . $_SERVER['PHP_SELF'] . '?mod=' . $_GET['mod'] . '" method="post">';
		} else {
			$language_table = $language['platform_add'];
			echo '<form action="' . $_SERVER['PHP_SELF'] . '?new=1" method="post">';
		}

		$template = array();
		$template['name'] = $platform_class->name;
		$template['tag'] = $platform_class->tag;
		$template['image'] = $platform_class->image;

		echo '<input type="hidden" name="new_end" value="1" />';
		$table_cols = array('name', 'tag', 'image');
		$table = new LSTable(4, 2, '100%', $null);
		$table->setTitle($language_table);
		$table->addCellAttribute(0, 0, 'width', '100');
		$table->setText(0, 0, $language['common_name']);
		$table->setText(0, 1, '<input type="text" name="platform_name" size="30" style="width:400px" value="' . $template['name'] . '" />');
		$table->setText(1, 0, $language['platform_tag']);
		$table->setText(1, 1, '<input type="text" name="platform_tag" size="30" style="width:400px" value="' . $template['tag'] . '" />');
		$table->setText(2, 0, $language['platform_image']);
		$table->setText(2, 1, '<input type="text" name="platform_image" size="30" style="width:400px" value="' . $template['image'] . '" />');
		$table->addCellAttribute(3, 0, 'align', 'center');
		$table->addCellAttribute(3, 0, 'colspan', '2');
		$table->setText(3, 0, '<input type="submit" value="' . $language['common_send'] . '" />');
		colorError($table, $table_cols, $platform_class->getError());
		$table->draw();
		echo '</form>';

		echo '<p><a class="blacktext" href="' . $_SERVER['PHP_SELF'] . '"><img src="../images/arrow2_left.gif" width="23" height="11" border="0" alt="&lt;" />' . $language['common_back'] . '</a></p>';
	}
} elseif (isset($_GET['del'])) {
	$platform_class = new db_platform();
	$platform_class->fill(array('platform_id' => $_GET['del']));
	$error = $platform_class->delete();
	if ($error !== db_data::ERROR_NONE) {
		$dobject = display_error($platform_class, $error, $_SERVER['PHP_SELF']);
		$dobject->draw();
	} else {
		$dobject = display_updated($language['end_delete'], $_SERVER['PHP_SELF'], 2);
		$dobject->draw();
	}
} else {
	$platform_class = db_data::searchForClass('db_platform', '', array('platform_id' => 'DESC'), '', 'platform_id');
	$line = count($platform_class);

	$table = new LSTable($line + 1, 4, '100%', $null);
	$table->setTitle($language['platform_platform']);
	for ($i = 0; $i < $line; $i++) {
		$template = array();
		$template['platform_id'] = $platform_class[$i]->platform_id;
		$template['name'] = $platform_class[$i]->name;
		$template['tag'] = $platform_class[$i]->tag;
		$template['image'] = $platform_class[$i]->image;

		$table->setText($i + 1, 0, '<a href="' . $_SERVER['PHP_SELF'] . '?mod=' . $template['platform_id'] . '">' . $template['name'] .'</a>');
		$table->setText($i + 1, 1, $template['tag']);
		$table->addCellAttribute($i + 1, 2, 'align', 'center');
		$table->setText($i + 1, 2, '<img src="../images/platform/' . $template['image'] . '" alt="' . $template['name'] . '" />');
		$table->addCellAttribute($i + 1, 3, 'align', 'center');
		$table->addCellAttribute($i + 1, 3, 'width', '15');
		$table->setText($i + 1, 3, '<a href="' . $_SERVER['PHP_SELF'] . '?del=' . $template['platform_id'] . '"><img src="../images/x.gif" width="15" height="15" border="0" alt="X" /></a>');
	}
	if($line === 0) {
		$table->addCellAttribute(0, 0, 'align','center');
		$table->addCellAttribute(0, 0, 'colspan', '4');
		$table->setText(0, 0, $language['platform_noplatform']);
	} else {
		$table->addAllCellsInRowAttribute(0, 'align', 'center');
		$table->addAllCellsInRowAttribute(0, 'class', 'table_title');
		$table->addCellAttribute(0, 0, 'width', '50%');
		$table->addCellAttribute(0, 1, 'width', '50%');
		$table->addCellAttribute(0, 2, 'class', 'table_title nowrap');
		$table->setText(0, 0, '<b>' . $language['common_name'] . '</b>');
		$table->setText(0, 1, '<b>' . $language['platform_tag'] . '</b>');
		$table->setText(0, 2, '<b>' . $language['platform_image'] . '</b>');
	}
	$table->draw();
	echo '<br /><form action="' . $_SERVER['PHP_SELF'] . '?new=1" method="post"><div align="center"><input type="submit" value="' . $language['common_add'] . '" /></div></form>';
	echo '<p><a class="blacktext" href="index.php"><img src="../images/arrow2_left.gif" width="23" height="11" border="0" alt="&lt;" />' . $language['common_back'] . '</a></p>';
}

include('../modules/footer.php');
?>