<?php
/***********************************************************
 *			player.php
 *		    ------------------
 * Created		: Mon, Feb 27, 2006
 * Copyright		: (C) LookStrike Team
 * WebSite		: http://www.lookstrike.com
 *
 * $Id: player.php,v 1.5 2008/02/09 20:34:55 jsgoupil Exp $
 *
 ***********************************************************/
define('IN_LS', true);
define('ADMIN', 8);
include('../modules/header.php');
include_once('../modules/class/db/db_players.php');
include_once('../modules/class/db/db_teams.php');
include_once('../modules/class/db/db_tournaments.php');
include_once('../modules/class/db/db_games.php');
include_once('../modules/class/db/db_team_players.php');
include_once('../modules/class/HelperDB.php');
include_once('../modules/class/ComponentHelpers.php');

define('MASTER_ADMIN_ID', 1);

if (isset($_GET['new']) || isset($_GET['mod'])) {
	// Do we display the form add/edit ?
	$fDisplayForm = true;

	// Getting the ID
	$id = isset($_GET['mod']) ? $_GET['mod'] : 0;

	// Get the instance correctly filled (data from db and $_POST)
	$players_class = HelperDB::GetInstance('db_players', $id, 'player_', isset($_POST['new_end']));
	$players_class->setAdmin(true);

	$noerror = true;
	// Specific : password
	// Reset ?
	if(isset($_POST['playerS_passwordreset']) && intval($_POST['playerS_passwordreset']) === 1) {
		$players_class->password = '';
	} elseif (isset($_POST['playerS_password1'], $_POST['playerS_password2']) && $_POST['playerS_password1'] !== $_POST['playerS_password2']) {
		// Error !
		$dobject = display_error($language['player_errorpassword'], NULL);
		$dobject->draw();
		echo '<br />';
		$noerror = false;
	} elseif (isset($_POST['playerS_password1']) && !empty($_POST['playerS_password1'])) {
		$players_class->password = $_POST['playerS_password1'];
	}
	// Specific : birthday
	if(isset($_POST['playerS_birthday_d'], $_POST['playerS_birthday_m'], $_POST['playerS_birthday_Y'])) {
		// Padding
		$_POST['playerS_birthday_d'] = str_pad($_POST['playerS_birthday_d'], 2, '0', STR_PAD_LEFT);
		$_POST['playerS_birthday_m'] = str_pad($_POST['playerS_birthday_m'], 2, '0', STR_PAD_LEFT);
		$_POST['playerS_birthday_Y'] = str_pad($_POST['playerS_birthday_Y'], 2, '0', STR_PAD_LEFT);
		if(checkdate($_POST['playerS_birthday_m'], $_POST['playerS_birthday_d'], $_POST['playerS_birthday_Y'])) {
			$players_class->birthday = $_POST['playerS_birthday_Y'] . '-' . $_POST['playerS_birthday_m'] . '-' . $_POST['playerS_birthday_d'];
		} else {
			// Error !
			$dobject = display_error($language['player_errorbirthday'], NULL);
			$dobject->draw();
			echo '<br />';
			$noerror = false;
		}
	}

	// We are finished entering data
	if (isset($_POST['new_end']) && $noerror === true) {
		if (isset($_GET['mod'])) {
			$error = $players_class->modify();
			$display = $language['end_modify'];
		} else {
			$error = $players_class->insert();
			$display = $language['end_insert'];
		}
		if ($error !== db_data::ERROR_NONE) {				// An error occured
			$dobject = display_error($players_class, $error);
			$dobject->draw();
			echo '<br />';
		} else {							// No error
			$dobject = display_updated($display, $_SERVER['PHP_SELF'], 2);
			$dobject->draw();
			$fDisplayForm = false;
		}
	}

	// ################## TEAM ##################
	if (isset($_POST['new_end2']) && intval($_POST['new_end2']) === 1 && isset($_POST['playerA_jointeam']) && intval($_POST['playerA_jointeam']) > 0) {
		$team_player = new db_team_players();
		$team_player->player_id = $id;
		$team_player->team_id = $_POST['playerA_jointeam'];
		$team_player->level = db_team_players::LEVEL_MEMBER;
		$error = $team_player->insert();
		if ($error !== db_data::ERROR_NONE) {				// An error occured
			$dobject = display_error($team_player, $error);
			$dobject->draw();
			echo '<br />';
		} else {							// No error
			$dobject = display_updated($language['player_addteam'], $_SERVER['PHP_SELF'], 2);
			$dobject->draw();
			$fDisplayForm = false;
		}
	}
	if (isset($_GET['del_end2']) && intval($_GET['del_end2']) > 0) {
		$team_player = new db_team_players();
		$team_player->fill(array('AND' => array('team_id' => $_GET['del_end2'], 'player_id' => $id)));
		$error = $team_player->delete();
		if ($error !== db_data::ERROR_NONE) {				// An error occured
			$dobject = display_error($team_player, $error);
			$dobject->draw();
			echo '<br />';
		} else {							// No error
			$dobject = display_updated($language['player_delteam'], $_SERVER['PHP_SELF'], 2);
			$dobject->draw();
			$fDisplayForm = false;
		}
	}

	// ################## TOURNAMENT ##################
	if (isset($_POST['new_end3']) && intval($_POST['new_end3']) === 1 && isset($_POST['playerA_jointourn']) && intval($_POST['playerA_jointourn']) > 0) {
		$teams = HelperDB::GetPlayerTeams($id, db_teams::TEAM_SINGLE);
		$tournament_teams = new db_tournament_teams();
		$tournament_teams->team_id = $teams[0]->team_id;
		$tournament_teams->tournament_id = $_POST['playerA_jointourn'];
		$error = $tournament_teams->insert();
		if ($error !== db_data::ERROR_NONE) {				// An error occured
			$dobject = display_error($tournament_teams, $error);
			$dobject->draw();
			echo '<br />';
		} else {							// No error
			$dobject = display_updated($language['player_addtourn'], $_SERVER['PHP_SELF'], 2);
			$dobject->draw();
			$fDisplayForm = false;
		}
	}
	if (isset($_GET['del_end3']) && intval($_GET['del_end3']) > 0) {
		$teams = HelperDB::GetPlayerTeams($id, db_teams::TEAM_SINGLE);
		$tournament_teams = new db_tournament_teams();
		$tournament_teams->fill(array('AND' => array('tournament_id' => $_GET['del_end3'], 'team_id' => $teams[0]->team_id)));
		$error = $tournament_teams->delete();
		if ($error !== db_data::ERROR_NONE) {				// An error occured
			$dobject = display_error($tournament_teams, $error);
			$dobject->draw();
			echo '<br />';
		} else {							// No error
			$dobject = display_updated($language['player_deltourn'], $_SERVER['PHP_SELF'], 2);
			$dobject->draw();
			$fDisplayForm = false;
		}
	}

	if ($fDisplayForm === true) {						// Display Form ?
		if (isset($_GET['mod'])) {
			$language_table = $language['player_mod'];
			echo '<form action="' . $_SERVER['PHP_SELF'] . '?mod=' . $_GET['mod'] . '" method="post">';
		} else {
			$language_table = $language['player_add'];
			echo '<form action="' . $_SERVER['PHP_SELF'] . '?new=1" method="post">';
		}

		$template = array();
		$template['login']		= $players_class->login;
		$template['nickname']		= $players_class->nickname;
		$template['lastname']		= $players_class->lastname;
		$template['firstname']		= $players_class->firstname;
		$template['email']		= $players_class->email;
		$template['address1']		= $players_class->address1;
		$template['address2']		= $players_class->address2;
		$template['city']		= $players_class->city;
		$template['state']		= $players_class->state;
		$template['country']		= $players_class->country;
		$template['postal_code']	= $players_class->postal_code;
		$template['phone']		= $players_class->phone;
		$template['birthday']		= $players_class->birthday;
		$template['msn']		= $players_class->msn;
		$template['warn_user']		= intval($players_class->warn_user);
		$template['allow_change']	= intval($players_class->allow_change);
		$template['checked']		= intval($players_class->checked);

		echo '<input type="hidden" name="new_end" value="1" />';
		$table_cols = array('login', 'nickname', 'password', 'password', 'lastname', 'firstname', 'email', 'address1', 'address2', 'city', 'state', 'country', 'postal_code', 'phone', 'birthday', 'msn');
		$table = new LSTable(20, 2, '100%', $null);
		$table->setTitle($language_table);
		$table->addCellAttribute(0, 0, 'width', '150');
		$table->setText(0, 0, $language['common_login']);
		$table->setText(1, 0, $language['common_nickname']);
		$table->setText(2, 0, $language['common_password']);
		$table->setText(3, 0, $language['player_confirmation']);
		$table->setText(4, 0, $language['player_lastname']);
		$table->setText(5, 0, $language['player_firstname']);
		$table->setText(6, 0, $language['player_email']);
		$table->setText(7, 0, $language['player_address1']);
		$table->setText(8, 0, $language['player_address2']);
		$table->setText(9, 0, $language['player_city']);
		$table->setText(10, 0, $language['player_state']);
		$table->setText(11, 0, $language['player_country']);
		$table->setText(12, 0, $language['player_postal_code']);
		$table->setText(13, 0, $language['player_phone']);
		$table->setText(14, 0, $language['player_birthday']);
		$table->setText(15, 0, $language['player_msn']);
		$table->setText(0, 1, '<input type="text" name="player_login" size="30" style="width:400px" value="' . $template['login'] . '" />');
		$table->setText(1, 1, '<input type="text" name="player_nickname" size="30" style="width:400px" value="' . $template['nickname'] . '" />');
		$table->setText(2, 1, '<input type="password" name="playerS_password1" size="30" style="width:400px" value="" /><br /><label for="playerS_passwordreset"><input type="checkbox" name="playerS_passwordreset" id="playerS_passwordreset" value="1" />' . $language['player_passwordreset'] . '</label>'); // Not count by HelperDB::GetInstance
		$table->setText(3, 1, '<input type="password" name="playerS_password2" size="30" style="width:400px" value="" />'); // Not count by HelperDB::GetInstance
		$table->setText(4, 1, '<input type="text" name="player_lastname" size="30" style="width:400px" value="' . $template['lastname'] . '" />');
		$table->setText(5, 1, '<input type="text" name="player_firstname" size="30" style="width:400px" value="' . $template['firstname'] . '" />');
		$table->setText(6, 1, '<input type="text" name="player_email" size="30" style="width:400px" value="' . $template['email'] . '" />');
		$table->setText(7, 1, '<input type="text" name="player_address1" size="30" style="width:400px" value="' . $template['address1'] . '" />');
		$table->setText(8, 1, '<input type="text" name="player_address2" size="30" style="width:400px" value="' . $template['address2'] . '" />');
		$table->setText(9, 1, '<input type="text" name="player_city" size="30" style="width:400px" value="' . $template['city'] . '" />');
		$table->setText(10, 1, '<input type="text" name="player_state" size="30" style="width:400px" value="' . $template['state'] . '" />');
		$table->setText(11, 1, '<input type="text" name="player_country" size="30" style="width:400px" value="' . $template['country'] . '" />');
		$table->setText(12, 1, '<input type="text" name="player_postal_code" size="30" style="width:400px" value="' . $template['postal_code'] . '" />');
		$table->setText(13, 1, '<input type="text" name="player_phone" size="30" style="width:400px" value="' . $template['phone'] . '" />');
		$table->setText(14, 1, ComponentHelpers::ComponentDate('playerS_birthday', $template['birthday'])); // Not count by HelperDB::GetInstance
		$table->setText(15, 1, '<input type="text" name="player_msn" size="30" style="width:400px" value="' . $template['msn'] . '" />');
		$table->addCellAttribute(16, 0, 'colspan', '2');
		$table->addCellAttribute(17, 0, 'colspan', '2');
		$table->addCellAttribute(18, 0, 'colspan', '2');
		$table->setText(16, 0, '<label for="player_warn_user"><input type="checkbox" name="player_warn_user" id="player_warn_user" value="1"'.(($template['warn_user'] === 1) ? ' checked="checked"' : '').' /> ' . $language['player_warn_user'] . '</label>');
		$table->setText(17, 0, '<label for="player_allow_change"><input type="checkbox" name="player_allow_change" id="player_allow_change" value="1"'.(($template['allow_change'] === 1) ? ' checked="checked"' : '').' /> ' . $language['player_allow_change'] . '</label>');
		$table->setText(18, 0, '<label for="player_checked"><input type="checkbox" name="player_checked" id="player_checked" value="1"'.(($template['checked'] === 1) ? ' checked="checked"' : '').' /> ' . $language['player_checked'] . '</label>');
		$table->addCellAttribute(19, 0, 'align', 'center');
		$table->addCellAttribute(19, 0, 'colspan', '2');
		$table->setText(19, 0, '<input type="submit" value="' . $language['common_send'] . '" />');
		colorError($table, $table_cols, $players_class->getError());
		$table->draw();
		echo '</form>';
		echo '<br />';

		if(isset($_GET['mod'])) {
			// ################## TEAM ##################
			$options = '';
			$teams = db_data::searchForClass('db_teams', array('single_user'=>db_teams::TEAM_REAL), array('name'=>'ASC'), '', 'team_id');
			$teams_player = HelperDB::GetPlayerTeams($id, db_teams::TEAM_REAL);
			$c = count($teams);
			$r = 0;
			// We don't display team in tournament
			for($i = 0; $i < $c; $i++) {
				if(!in_array_class(intval($teams[$i]->team_id), $teams_player, 'team_id', false)) {
					$tournaments = HelperDB::GetTeamTournament($teams[$i]->team_id);
					if(count($tournaments) === 0) {
						$options .= '<option value="' . $teams[$i]->team_id . '">' . $teams[$i]->name . '</option>';
						$r++;
					}
				}
			}
			$disabled = '';
			if($r === 0) {
				$options .= '<option value="0">' . $language['player_noteamadd'] . '</option>';
				$disabled = ' disabled="disabled"';
			}

			echo '<form action="' . $_SERVER['PHP_SELF'] . '?mod=' . $_GET['mod'] . '" method="post">';
			echo '<input type="hidden" name="new_end2" value="1" />';
			$table = new LSTable(1, 2, '100%', $null);
			$table->setTitle($language['player_jointeam']);
			$table->addCellAttribute(0, 0, 'width', '100%');
			$table->setText(0, 0, '<select size="1" name="playerA_jointeam" style="width: 500px;"' . $disabled . '>' . $options . '</select>');
			$table->addCellAttribute(0, 1, 'class', 'nowrap');
			$table->setText(0, 1, '<input type="submit" value="' . $language['common_send'] . '"' . $disabled . ' />');
			$table->draw();
			echo '</form>';
			echo '<br />';

			$c = count($teams_player);
			$table = new LSTable(max($c, 1), 2, '100%', $null);
			$table->setTitle($language['player_teamsub']);
			for($i = 0; $i < $c; $i++) {
				$table->setText($i, 0, '<a href="../site/info.php?t=team&amp;id=' . $teams_player[$i]->team_id . '">' . $teams_player[$i]->name . '</a>');
				$table->addCellAttribute($i, 1, 'width', '15');
				$table->setText($i, 1, '<a href="' . $_SERVER['PHP_SELF'] . '?mod=' . $id . '&amp;del_end2=' . $teams_player[$i]->team_id . '"><img src="../images/x.gif" alt="X" /></a>');
			}
			if($c === 0) {
				$table->addCellAttribute(0, 0, 'align', 'center');
				$table->addCellAttribute(0, 0, 'colspan', '2');
				$table->setText(0, 0, $language['player_noteam']);
			}
			$table->draw();
			echo '<br />';


			// ################## TOURNAMENT ##################
			$options = '';
			$tournaments = db_data::searchForClass('db_tournaments', array('AND' => array('status'=>db_tournaments::STATUS_QUEUE, 'single_user' => 1)), array('inserted'=>'DESC'), '', 'tournament_id');
			$tournament_player = HelperDB::GetPlayerTournament($id);
			$c = count($tournaments);
			$r = 0;
			for($i = 0; $i < $c; $i++) {
				if(!in_array_class(intval($tournaments[$i]->tournament_id), $tournament_player, 'tournament_id', false)) {
					$options .= '<option value="' . $tournaments[$i]->tournament_id . '">' . HelperDB::GetTournamentName($tournaments[$i]) . '</option>';
					$r++;
				}
			}
			$disabled = '';
			if($r === 0) {
				$options .= '<option value="0">' . $language['player_notournadd'] . '</option>';
				$disabled = ' disabled="disabled"';
			}
			echo '<form action="' . $_SERVER['PHP_SELF'] . '?mod=' . $_GET['mod'] . '" method="post">';
			echo '<input type="hidden" name="new_end3" value="1" />';
			$table = new LSTable(1, 2, '100%', $null);
			$table->setTitle($language['player_jointourn']);
			$table->addCellAttribute(0, 0, 'width', '100%');
			$table->setText(0, 0, '<select size="1" name="playerA_jointourn" style="width: 500px;"' . $disabled . '>' . $options . '</select>');
			$table->addCellAttribute(0, 1, 'class', 'nowrap');
			$table->setText(0, 1, '<input type="submit" value="' . $language['common_send'] . '"' . $disabled . ' />');
			$table->draw();
			echo '</form>';
			echo '<br />';

			$c = count($tournament_player);
			$table = new LSTable(max($c, 1), 2, '100%', $null);
			$table->setTitle($language['player_tournsub']);
			for($i = 0; $i < $c; $i++) {
				$table->setText($i, 0, '<a href="../site/tournament.php?id=' . $tournament_player[$i]->tournament_id . '">' . HelperDB::GetTournamentName($tournament_player[$i]) . '</a>');
				$table->addCellAttribute($i, 1, 'width', '15');
				$table->setText($i, 1, '<a href="' . $_SERVER['PHP_SELF'] . '?mod=' . $id . '&amp;del_end3=' . $tournament_player[$i]->tournament_id . '"><img src="../images/x.gif" alt="X" /></a>');
			}
			if($c === 0) {
				$table->addCellAttribute(0, 0, 'align', 'center');
				$table->addCellAttribute(0, 0, 'colspan', '2');
				$table->setText(0, 0, $language['player_notourn']);
			}
			$table->draw();
			echo '<br />';
		}

		echo '<p><a class="blacktext" href="' . $_SERVER['PHP_SELF'] . '"><img src="../images/arrow2_left.gif" width="23" height="11" border="0" alt="&lt;" />' . $language['common_back'] . '</a></p>';
	}
} elseif (isset($_GET['del'])) {
	// Specific : prevent admin to be deleted
	if (intval($_GET['del']) === MASTER_ADMIN_ID) {
		$dobject = display_error($language['player_nodelete'], $_SERVER['PHP_SELF']);
		$dobject->draw();
	} else {
		$players_class = new db_players();
		$players_class->fill(array('player_id' => $_GET['del']));
		$error = $players_class->delete();
		if ($error !== db_data::ERROR_NONE) {
			$dobject = display_error($players_class, $error, $_SERVER['PHP_SELF']);
			$dobject->draw();
		} else {
			$dobject = display_updated($language['end_delete'], $_SERVER['PHP_SELF'], 2);
			$dobject->draw();
		}
	}
} else {
	$players_class = db_data::searchForClass('db_players', '', array('login'=>'ASC'), '', 'player_id');
	$line = count($players_class);

	$table = new LSTable($line + 1, 4, '100%', $null);
	$table->setTitle($language['player_player']);
	for ($i = 0; $i < $line; $i++) {
		$template = array();
		$template['player_id'] = $players_class[$i]->player_id;
		$template['login'] = $players_class[$i]->login;
		$template['nickname'] = $players_class[$i]->nickname;

		$teams = HelperDB::GetPlayerTeams($players_class[$i]->player_id, db_teams::TEAM_REAL);
		$c = count($teams);
		$combo = '';
		for($j = 0; $j < $c; $j++) {
			$combo .= '<option>' . $teams[$j]->name . '</option>';
		}
		if($c === 0) {
			$combo .= '<option>' . $language['player_noteams'] . '</option>';
		}

		$table->addCellAttribute($i + 1, 0, 'width', '250');
		$table->setText($i + 1, 0, '<a href="?mod=' . $template['player_id'] . '">' . $template['login'] . '</a>');
		$table->setText($i + 1, 1, $template['nickname']);

		$table->addCellAttribute($i + 1, 2, 'align', 'center');
		$table->addCellAttribute($i + 1, 2, 'width', '140');
		$table->setText($i + 1, 2, '<select style="width: 140px;" size="1">' . $combo . '</select>');

		$table->addCellAttribute($i + 1, 3, 'align', 'center');
		$table->addCellAttribute($i + 1, 3, 'width', '15');
		$table->setText($i + 1, 3, '<a href="' . $_SERVER['PHP_SELF'] . '?del=' . $template['player_id'] . '"><img src="../images/x.gif" width="15" height="15" border="0" alt="X" /></a>');
	}
	if($line === 0) {
		$table->addCellAttribute(0, 0, 'align','center');
		$table->addCellAttribute(0, 0, 'colspan', '4');
		$table->setText(0, 0, $language['player_noplayers']);
	} else {
		$table->addRowAttribute(0, 'class', 'table_title');
		$table->addAllCellsInRowAttribute(0, 'align', 'center');
		$table->setText(0, 0, '<b>' . $language['common_login'] . '</b>');
		$table->setText(0, 1, '<b>' . $language['common_nickname'] . '</b>');
		$table->setText(0, 2, '<b>' . $language['player_teamsub'] . '</b>');
	}
	$table->draw();
	echo '<br /><form action="' . $_SERVER['PHP_SELF'] . '?new=1" method="post"><div align="center"><input type="submit" value="' . $language['common_add'] . '" /></div></form>';
	echo '<p><a class="blacktext" href="index.php"><img src="../images/arrow2_left.gif" width="23" height="11" border="0" alt="&lt;" />' . $language['common_back'] . '</a></p>';
}

include('../modules/footer.php');
?>