<?php
/***********************************************************
 *			server.php
 *		    ------------------
 * Created		: The, Nov 11, 2004
 * Copyright		: (C) LookStrike Team
 * WebSite		: http://www.lookstrike.com
 *
 * $Id: server.php,v 1.13 2008/02/09 20:34:55 jsgoupil Exp $
 *
 ***********************************************************/
define('IN_LS', true);
define('ADMIN', 16);
include('../modules/header.php');
include_once('../modules/class/db/db_server_ip.php');
include_once('../modules/class/db/db_server_group.php');
include_once('../modules/class/db/db_games.php');
include_once('../modules/class/db/db_tournaments.php');
include_once('../modules/class/HelperDB.php');

// If we want to add or modify
if (isset($_GET['new']) || isset($_GET['mod'])) {
	// Do we display the form add/edit ?
	$fDisplayForm = true;

	// Getting the ID
	$id = isset($_GET['mod']) ? $_GET['mod'] : 0;

	// Specific:
	if (isset($_POST['new_end'])) {
		$_POST['server_ip'] = encode_ip($_POST['server_ip1'] . '.' . $_POST['server_ip2'] . '.' . $_POST['server_ip3'] . '.' . $_POST['server_ip4']);
	}

	// Get the instance correctly filled (data from db and $_POST)
	$server_class = HelperDB::GetInstance('db_server_ip', $id, 'server_');
	$server_class->setAdmin(true);

	// We are finished entering data
	if (isset($_POST['new_end'])) {
		if (isset($_GET['mod'])) {
			$error = $server_class->modify();
			$display = $language['end_modify'];
		} else {
			$error = $server_class->insert();
			$display = $language['end_insert'];
		}
		if ($error !== db_data::ERROR_NONE) {				// An error occured
			$dobject = display_error($server_class, $error);
			$dobject->draw();
			echo '<br />';
		} else {							// No error
			$dobject = display_updated($display, $_SERVER['PHP_SELF'], 2);
			$dobject->draw();
			$fDisplayForm = false;
		}
	}

	if ($fDisplayForm === true) {						// Display Form ?
		if (isset($_GET['mod'])) {
			$language_table = $language['server_mod'];
			echo '<form action="' . $_SERVER['PHP_SELF'] . '?mod=' . $_GET['mod'] . '" method="post">';
		} else {
			$language_table = $language['server_add'];
			echo '<form action="' . $_SERVER['PHP_SELF'] . '?new=1" method="post">';
		}

		$template = array();
		$template['ip'] = decode_ip($server_class->ip);
		$template['port'] = $server_class->port;
		$template['group_id'] = $server_class->group_id;
		$group_class = new db_server_group();
		$group_class->fill(array('group_id' => $template['group_id']));
		$template['group'] = $group_class->name;
		$template['password'] = $server_class->password;

		echo '<input type="hidden" name="new_end" value="1" />';
		$table_cols = array('name', 'port', 'password', 'group_id');
		$table = new LSTable(5, 2, '100%', $null);
		$table->setTitle($language_table);
		$table->addCellAttribute(0, 0, 'width', '100');
		$table->setText(0, 0, $language['server_ip']);
		$ip = explode('.', $template['ip']);
		$table->setText(0, 1, '<input type="text" name="server_ip1" size="2" style="width:20px" value="' . $ip[0] . '" maxlength="3" /> . <input type="text" name="server_ip2" size="2" style="width:20px" value="' . $ip[1] . '" maxlength="3" /> . <input type="text" name="server_ip3" size="2" style="width:20px" value="' . $ip[2] . '" maxlength="3" /> . <input type="text" name="server_ip4" size="2" style="width:20px" value="' . $ip[3] . '" maxlength="3" />');
		$table->setText(1, 0, $language['server_port']);
		$table->setText(1, 1, '<input type="text" name="server_port" size="30" style="width:400px" value="' . $template['port'] . '" />');
		$table->setText(2, 0, $language['common_password']);
		$table->setText(2, 1, '<input type="text" name="server_password" size="30" style="width:400px" value="' . $template['password'] . '" />');
		$table->setText(3, 0, $language['server_group']);
		$group2_class = new db_server_group();
		$group2_class = db_data::searchForClass('db_server_group', '', array('group_id' => 'DESC'), '', 'group_id');
		$line = count($group2_class);
		$text2display = '<select name="server_group_id" style="width:400px;">';
		$disabled = 0;
		for ($i = 0; $i < $line; $i++) {
			$group = array();
			$group['group_id'] = $group2_class[$i]->group_id;
			$group['name'] = $group2_class[$i]->name;

			$text2display .= '<option value="' . $group['group_id'] . '"';
			if ($group['group_id'] === $template['group_id']) {
				$text2display .= ' selected="selected"';
			}
			$text2display .= '>' . $group['name'] . '</option>';
		}
		if ($line === 0) {
			$disabled = true;
			$text2display .= '<option value="">' . $language['server_nogroup'] . '</option>';
		}
		$text2display .= '</select>';
		$table->setText(3, 1, $text2display);
		$table->addCellAttribute(4, 0, 'align', 'center');
		$table->addCellAttribute(4, 0, 'colspan', '2');
		$send = '<input type="submit" value="' . $language['common_send'] . '" ';
		if ($disabled === 1) {
			$send .= 'disabled="disabled"';
		}
		$send .= '/>';
		$table->setText(4, 0, $send);
		colorError($table, $table_cols, $server_class->getError());
		$table->draw();
		echo '</form>';

		echo '<p><a class="blacktext" href="' . $_SERVER['PHP_SELF'] . '"><img src="../images/arrow2_left.gif" width="23" height="11" border="0" alt="&lt;" />' . $language['common_back'] . '</a></p>';
	}
// If we want to add or modify a group
} elseif (isset($_GET['gnew']) || isset($_GET['gmod'])) {
	// Do we display the form add/edit ?
	$fDisplayForm = true;

	// Getting the ID
	$id = isset($_GET['gmod']) ? $_GET['gmod'] : 0;

	// Get the instance correctly filled (data from db and $_POST)
	$group_class = HelperDB::GetInstance('db_server_group', $id, 'group_');
	$group_class->setAdmin(true);

	// We are finished entering data
	if (isset($_POST['new_end'])) {
		if (isset($_GET['gmod'])) {
			$error = $group_class->modify();
			$display = $language['end_gmodify'];
		} else {
			$error = $group_class->insert();
			$display = $language['end_ginsert'];
		}
		if ($error !== db_data::ERROR_NONE) {				// An error occured
			$dobject = display_error($group_class, $error);
			$dobject->draw();
			echo '<br />';
		} else {							// No error
			$dobject = display_updated($display, $_SERVER['PHP_SELF'], 2);
			$dobject->draw();
			$fDisplayForm = false;
		}
	}

	if ($fDisplayForm === true) {						// Display Form ?
		if (isset($_GET['gmod'])) {
			$language_table = $language['server_gmod'];
			echo '<form action="' . $_SERVER['PHP_SELF'] . '?gmod=' . $_GET['gmod'] . '" method="post">';
		} else {
			$language_table = $language['server_gadd'];
			echo '<form action="' . $_SERVER['PHP_SELF'] . '?gnew=1" method="post">';
		}

		$template = array();
		$template['name'] = $group_class->name;

		echo '<input type="hidden" name="new_end" value="1" />';
		$table_cols = array('name');
		$table = new LSTable(2, 2, '100%', $null);
		$table->setTitle($language_table);
		$table->addCellAttribute(0, 0, 'width', '100');
		$table->setText(0, 0, $language['common_name']);
		$table->setText(0, 1, '<input type="text" name="group_name" size="30" style="width:400px" value="' . $template['name'] . '" />');
		$table->addCellAttribute(1, 0, 'align', 'center');
		$table->addCellAttribute(1, 0, 'colspan', '2');
		$table->setText(1, 0, '<input type="submit" value="' . $language['common_send'] . '" />');
		colorError($table, $table_cols, $group_class->getError());
		$table->draw();
		echo '</form>';

		echo '<p><a class="blacktext" href="' . $_SERVER['PHP_SELF'] . '"><img src="../images/arrow2_left.gif" width="23" height="11" border="0" alt="&lt;" />' . $language['common_back'] . '</a></p>';
	}
} elseif (isset($_GET['del'])) {
	$server_class = new db_server_ip();
	$server_class->fill(array('server_id' => $_GET['del']));
	$error = $server_class->delete();
	if ($error !== db_data::ERROR_NONE) {
		$dobject = display_error($server_class, $error, $_SERVER['PHP_SELF']);
		$dobject->draw();
	} else {
		$dobject = display_updated($language['end_delete'], $_SERVER['PHP_SELF'], 2);
		$dobject->draw();
	}
} elseif (isset($_GET['gdel'])) {
	$group_class = new db_server_group();
	$group_class->fill(array('group_id' => $_GET['gdel']));
	$error = $group_class->delete();
	if ($error !== db_data::ERROR_NONE) {
		$dobject = display_error($group_class, $error, $_SERVER['PHP_SELF']);
		$dobject->draw();
	} else {
		$dobject = display_updated($language['end_gdelete'], $_SERVER['PHP_SELF'], 2);
		$dobject->draw();
	}
} elseif (isset($_GET['assign'])) {
	if (isset($_POST['assign_tournament'])) {
		echo '<form method="post" action=" ' . $_SERVER['PHP_SELF'] . '?assign=' . $_GET['assign'] . '">';
		$table = new LSTable(2, 1, '60%', $null);
		$matches = db_data::searchForClass('db_matches', array('tournament_id' => $_POST['assign_tournament']), '', '', 'match_id');
		$c = count($matches);
		$listbox = '<select name="assign_match">';
		for( $i = 0; $i < $c; $i++) {
			$listbox .= '<option value="' . $matches[$i]->match_id . '">' . $language['common_match'] . ' #'. $matches[$i]->match_id . '</option>';
		}
		$disabled = '';
		if ($c === 0) {
			$listbox .= '<option>' . $language['server_nomatch'] . '</option>';
			$disabled = ' disabled="disabled"';
		}
		$listbox .= '</select>';
		$table->addCellAttribute(0, 0, 'align', 'center');
		$table->setText(0, 0, $listbox);
		$table->addCellAttribute(1, 0, 'align', 'center');
		$table->setText(1, 0, '<input type="submit" value="' . $language['common_send'] . '" ' . $disabled . ' />');
		$table->setTitle($language['server_assign']);

		$table->draw();
		echo '</form>';
	} elseif (isset($_POST['assign_match'])) {
		$match_class = new db_matches();
		$match_class->fill(array('match_id' => $_POST['assign_match']));
		$match_class->server_id = intval($_GET['assign']);
		$error = $match_class->modify();
		if ($error !== db_data::ERROR_NONE) {				// An error occured
			$dobject = display_error($matchs_class, $error);
			$dobject->draw();
			echo '<br />';
		} else {							// No error
			$dobject = display_updated($language['end_assigned'], $_SERVER['PHP_SELF'], 2);
			$dobject->draw();
		}
	} else {
		echo '<form method="post" action="' . $_SERVER['PHP_SELF'] . '?assign=' . $_GET['assign'] . '">';
		$table = new LSTable(2, 1, '60%', $null);
		$table->setTitle($language['server_assign']);
		$table->addCellAttribute(0, 0, 'align', 'center');
		$listbox = '<select name="assign_tournament">';
		$tournaments = db_data::searchForClass('db_tournaments', array('status' => '1'), array('tournament_id' => 'DESC'), '', 'tournament_id');
		$c = count($tournaments);
		$game_class = new db_games();
		for ($i = 0; $i < $c; $i++) {
			$game_class->fill(array('game_id' => $tournaments[$i]->game_id));
			$listbox .= '<option value="' . $tournaments[$i]->tournament_id . '">' . $game_class->name . ' #' . gamenumber($tournaments[$i]->tournament_id, $tournaments[$i]->game_id) . '</option>';
		}
		$disabled = '';
		if ($c === 0) {
			$listbox .= '<option>' . $language['server_notournament'] . '</option>';
			$disabled = ' disabled="disabled"';
		}
		$listbox .= '</select>';
		$table->setText(0, 0, $listbox);
		$table->addCellAttribute(1, 0, 'align', 'center');
		$table->setText(1, 0, '<input type="submit" value="' . $language['common_send'] .'" ' . $disabled . ' />');
		$table->draw();
		echo '</form>';
	}
} else {
	$server_class = new db_server_ip();
	$server_class = db_data::searchForClass('db_server_ip', '', array('server_id' => 'DESC'), '', 'server_id');
	$line = count($server_class);

	$table = new LSTable($line + 1, 5, '100%', $null);
	$table->setTitle($language['common_server']);
	for ($i = 0; $i < $line; $i++) {
		$template = array();
		$template['server_id'] = $server_class[$i]->server_id;
		$template['group_id'] = $server_class[$i]->group_id;
		$group_class = new db_server_group();
		$group_class->fill(array('group_id' => $template['group_id']));
		$template['group_name'] = $group_class->name;
		$template['ip'] = decode_ip($server_class[$i]->ip);
		$template['port'] = $server_class[$i]->port;

		$table->setText($i + 1, 0, '<a href="' . $_SERVER['PHP_SELF'] . '?mod=' . $template['server_id'] . '">' . $template['ip'] .'</a>');
		$table->addCellAttribute($i + 1, 1, 'align', 'center');
		$table->setText($i + 1, 1, $template['port']);
		$table->addCellAttribute($i + 1, 2, 'align', 'center');
		$table->setText($i + 1, 2, $template['group_name']);
		$table->setText($i + 1, 3, '<a href="' . $_SERVER['PHP_SELF'] . '?assign=' . $template['server_id'] . '">' . $language['server_assign'] . '</a>');
		$table->addCellAttribute($i + 1, 4, 'align', 'center');
		$table->addCellAttribute($i + 1, 4, 'width', '15');
		$table->setText($i + 1, 4, '<a href="' . $_SERVER['PHP_SELF'] . '?del=' . $template['server_id'] . '"><img src="../images/x.gif" width="15" height="15" border="0" alt="X" /></a>');
	}
	if($line === 0) {
		$table->addCellAttribute(0, 0, 'align','center');
		$table->addCellAttribute(0, 0, 'colspan', '5');
		$table->setText(0, 0, $language['server_noserver']);
	} else {
		$table->addAllCellsInRowAttribute(0, 'align', 'center');
		$table->addAllCellsInRowAttribute(0, 'class', 'table_title');
		$table->addCellAttribute(0, 0, 'width', '50%');
		$table->addCellAttribute(0, 1, 'width', '50%');
		$table->addCellAttribute(0, 2, 'class', 'table_title nowrap');
		$table->setText(0, 0, '<b>' . $language['server_ip'] . '</b>');
		$table->setText(0, 1, '<b>' . $language['server_port'] . '</b>');
		$table->setText(0, 2, '<b>' . $language['server_group'] . '</b>');
	}
	$table->draw();
	echo '<br /><form action="' . $_SERVER['PHP_SELF'] . '?new=1" method="post"><div align="center"><input type="submit" value="' . $language['common_add'] . '" /></div></form><br />';
	$group_class = new db_server_group();
	$group_class = db_data::searchForClass('db_server_group', '', array('group_id' => 'DESC'), '', 'group_id');
	$line = count($group_class);

	$table = new LSTable($line + 1, 2, '100%', $null);
	$table->setTitle($language['server_group']);
	for ($i = 0; $i < $line; $i++) {
		$template = array();
		$template['group_id'] = $group_class[$i]->group_id;
		$template['group_name'] = $group_class[$i]->name;

		$table->setText($i + 1, 0, '<a href="' . $_SERVER['PHP_SELF'] . '?gmod=' . $template['group_id'] . '">' . $template['group_name'] .'</a>');
		$table->setText($i + 1, 1, '<a href="' . $_SERVER['PHP_SELF'] . '?gdel=' . $template['group_id'] . '"><img src="../images/x.gif" width="15" height="15" border="0" alt="X" /></a>');
	}
	if($line === 0) {
		$table->addCellAttribute(0, 0, 'align','center');
		$table->addCellAttribute(0, 0, 'colspan', '4');
		$table->setText(0, 0, $language['server_nogroup']);
	} else {
		$table->addAllCellsInRowAttribute(0, 'align', 'center');
		$table->addAllCellsInRowAttribute(0, 'class', 'table_title');
		$table->addCellAttribute(0, 0, 'width', '100%');
		$table->setText(0, 0, '<b>' . $language['common_name'] . '</b>');
	}
	$table->draw();
	echo '<br /><form action="' . $_SERVER['PHP_SELF'] . '?gnew=1" method="post"><div align="center"><input type="submit" value="' . $language['common_add'] . '" /></div></form>';
	echo '<p><a class="blacktext" href="index.php"><img src="../images/arrow2_left.gif" width="23" height="11" border="0" alt="&lt;" />' . $language['common_back'] . '</a></p>';
}

include('../modules/footer.php');
?>