<?php
/***********************************************************
 *			team.php
 *		    ----------------
 * Created		: Sat, Mar 4, 2006
 * Copyright		: (C) LookStrike Team
 * WebSite		: http://www.lookstrike.com
 *
 * $Id: team.php,v 1.16 2008/02/09 20:34:56 jsgoupil Exp $
 *
 ***********************************************************/
define('IN_LS', true);
define('ADMIN', 8);
include('../modules/header.php');
include_once('../modules/class/db/db_players.php');
include_once('../modules/class/db/db_teams.php');
include_once('../modules/class/db/db_tournaments.php');
include_once('../modules/class/db/db_games.php');
include_once('../modules/class/db/db_team_players.php');
include_once('../modules/class/HelperDB.php');
include_once('../modules/class/ComponentHelpers.php');

if (isset($_GET['new']) || isset($_GET['mod'])) {
	// Do we display the form add/edit ?
	$fDisplayForm = true;

	// Getting the ID
	$id = isset($_GET['mod']) ? $_GET['mod'] : 0;

	// Get the instance correctly filled (data from db and $_POST)
	$teams_class = HelperDB::GetInstance('db_teams', $id, 'team_');
	$teams_class->setAdmin(true);

	$noerror = true;
	// Specific : password
	if (isset($_POST['teamS_password1'], $_POST['teamS_password2']) && $_POST['teamS_password1'] !== $_POST['teamS_password2']) {
		// Error !
		$dobject = display_error($language['team_errorpassword'], NULL);
		$dobject->draw();
		echo '<br />';
		$noerror = false;
	} elseif (isset($_POST['teamS_password1']) && !empty($_POST['teamS_password1'])) {
		$teams_class->password = $_POST['teamS_password1'];
	}

	// We are finished entering data
	if (isset($_POST['new_end']) && $noerror === true) {
		if (isset($_GET['mod'])) {
			$error = $teams_class->modify();
			$display = $language['end_modify'];
		} else {
			$error = $teams_class->insert();
			$display = $language['end_insert'];
		}
		if ($error !== db_data::ERROR_NONE) {				// An error occured
			$dobject = display_error($teams_class, $error);
			$dobject->draw();
			echo '<br />';
		} else {							// No error
			$dobject = display_updated($display, $_SERVER['PHP_SELF'], 2);
			$dobject->draw();
			$fDisplayForm = false;
		}
	}

	// ################## MEMBER ##################
	if (isset($_POST['new_end2']) && intval($_POST['new_end2']) === 1 && isset($_POST['teamA_promote']) && intval($_POST['teamA_promote']) > 0) {
		$team_player = new db_team_players();
		$team_player->team_id = $id;
		$team_player->player_id = $_POST['teamA_promote'];
		$team_player->level = db_team_players::LEVEL_CAPTAIN;
		$error = $team_player->modify();
		if ($error !== db_data::ERROR_NONE) {				// An error occured
			$dobject = display_error($team_player, $error);
			$dobject->draw();
			echo '<br />';
		} else {							// No error
			$dobject = display_updated($language['team_promotemember'], $_SERVER['PHP_SELF'], 2);
			$dobject->draw();
			$fDisplayForm = false;
		}
	}
	if (isset($_GET['del_end2']) && intval($_GET['del_end2']) > 0) {
		$team_player = new db_team_players();
		$team_player->fill(array('AND' => array('team_id' => $id, 'player_id' => $_GET['del_end2'])));
		$error = $team_player->delete();
		if ($error !== db_data::ERROR_NONE) {				// An error occured
			$dobject = display_error($team_player, $error);
			$dobject->draw();
			echo '<br />';
		} else {							// No error
			$dobject = display_updated($language['team_delmember'], $_SERVER['PHP_SELF'], 2);
			$dobject->draw();
			$fDisplayForm = false;
		}
	}

	// ################## TOURNAMENT ##################
	if (isset($_POST['new_end3']) && intval($_POST['new_end3']) === 1 && isset($_POST['teamA_jointourn']) && intval($_POST['teamA_jointourn']) > 0) {
		$tournament_teams = new db_tournament_teams();
		$tournament_teams->team_id = $id;
		$tournament_teams->tournament_id = $_POST['teamA_jointourn'];
		$error = $tournament_teams->insert();
		if ($error !== db_data::ERROR_NONE) {				// An error occured
			$dobject = display_error($tournament_teams, $error);
			$dobject->draw();
			echo '<br />';
		} else {							// No error
			$dobject = display_updated($language['team_addtourn'], $_SERVER['PHP_SELF'], 2);
			$dobject->draw();
			$fDisplayForm = false;
		}
	}
	if (isset($_GET['del_end3']) && intval($_GET['del_end3']) > 0) {
		$tournament_teams = new db_tournament_teams();
		$tournament_teams->fill(array('AND' => array('tournament_id' => $_GET['del_end3'], 'team_id' => $id)));
		$error = $tournament_teams->delete();
		if ($error !== db_data::ERROR_NONE) {				// An error occured
			$dobject = display_error($tournament_teams, $error);
			$dobject->draw();
			echo '<br />';
		} else {							// No error
			$dobject = display_updated($language['team_deltourn'], $_SERVER['PHP_SELF'], 2);
			$dobject->draw();
			$fDisplayForm = false;
		}
	}

	if ($fDisplayForm === true) {						// Display Form ?
		if (isset($_GET['mod'])) {
			$language_table = $language['team_mod'];
			echo '<form action="' . $_SERVER['PHP_SELF'] . '?mod=' . $_GET['mod'] . '" method="post">';
		} else {
			$language_table = $language['team_add'];
			echo '<form action="' . $_SERVER['PHP_SELF'] . '?new=1" method="post">';
		}

		$template = array();
		$template['name'] 		= $teams_class->name;

		echo '<input type="hidden" name="new_end" value="1" />';
		$table_cols = array('name', 'password', 'password');
		$table = new LSTable(4, 2, '100%', $null);
		$table->setTitle($language_table);
		$table->addCellAttribute(0, 0, 'width', '150');
		$table->setText(0, 0, $language['team_name']);
		$table->setText(1, 0, $language['common_password']);
		$table->setText(2, 0, $language['team_confirmation']);
		$table->setText(0, 1, '<input type="text" name="team_name" size="30" style="width:400px" value="' . $template['name'] . '" />');
		$table->setText(1, 1, '<input type="password" name="teamS_password1" size="30" style="width:400px" value="" />'); // Not count by HelperDB::GetInstance
		$table->setText(2, 1, '<input type="password" name="teamS_password2" size="30" style="width:400px" value="" />'); // Not count by HelperDB::GetInstance
		$table->addCellAttribute(3, 0, 'align', 'center');
		$table->addCellAttribute(3, 0, 'colspan', '2');
		$table->setText(3, 0, '<input type="submit" value="' . $language['common_send'] . '" />');
		colorError($table, $table_cols, $teams_class->getError());
		$table->draw();
		echo '</form>';
		echo '<br />';

		if(isset($_GET['mod'])) {
			// ################## MEMBERS ##################
			$options = '';
			$disabled = '';
			$players = HelperDB::GetTeamPlayers($id);
			$leader = new db_team_players();
			$leader->fill(array('AND'=>array('level'=>db_team_players::LEVEL_CAPTAIN, 'team_id'=>$id)));
			$leader = intval($leader->player_id);
			$c = count($players);
			$table = new LSTable(max($c, 1), 2, '100%', $null);
			$table->setTitle($language['team_membersub']);
			for($i = 0; $i < $c; $i++) {
				$display = '<a href="../site/info.php?t=player&amp;id=' . $players[$i]->player_id . '"';
				if($leader === intval($players[$i]->player_id)) {
					$display .= ' style="color: #06ee00;"';
				}
				$display .= '>' . $players[$i]->nickname . '</a>';
				$table->setText($i, 0, $display);
				$table->addCellAttribute($i, 1, 'width', '15');
				$table->setText($i, 1, '<a href="' . $_SERVER['PHP_SELF'] . '?mod=' . $id . '&amp;del_end2=' . $players[$i]->player_id . '"><img src="../images/x.gif" alt="X" /></a>');
				$options .= '<option value="' . $players[$i]->player_id . '"';
				if($leader === intval($players[$i]->player_id)) {
					$options .= ' selected="selected"';
				}
				$options .= '>' . $players[$i]->nickname . '</option>';
			}
			if($c === 0) {
				$table->addCellAttribute(0, 0, 'align', 'center');
				$table->addCellAttribute(0, 0, 'colspan', '2');
				$table->setText(0, 0, $language['team_noplayer']);
				$options .= '<option value="0">' . $language['team_noplayer'] . '</option>';
				$disabled = ' disabled="disabled"';
			}
			$table->draw();
			echo '<br />';

			echo '<form action="' . $_SERVER['PHP_SELF'] . '?mod=' . $_GET['mod'] . '" method="post">';
			echo '<input type="hidden" name="new_end2" value="1" />';
			$table = new LSTable(1, 2, '100%', $null);
			$table->setTitle($language['team_promote']);
			$table->addCellAttribute(0, 0, 'width', '100%');
			$table->setText(0, 0, '<select size="1" name="teamA_promote" style="width: 500px;"' . $disabled . '>' . $options . '</select>');
			$table->addCellAttribute(0, 1, 'class', 'nowrap');
			$table->setText(0, 1, '<input type="submit" value="' . $language['common_send'] . '"' . $disabled . ' />');
			$table->draw();
			echo '</form>';
			echo '<br />';

			// ################## TOURNAMENT ##################
			$options = '';
			$tournaments = db_data::searchForClass('db_tournaments', array('AND' => array('status'=>db_tournaments::STATUS_QUEUE, 'single_user' => 0)), array('inserted'=>'DESC'), '', 'tournament_id');
			$tournament_team = HelperDB::GetTeamTournament($id);
			$c = count($tournaments);
			$r = 0;
			for($i = 0; $i < $c; $i++) {
				if(!in_array_class(intval($tournaments[$i]->tournament_id), $tournament_team, 'tournament_id', false)) {
					$options .= '<option value="' . $tournaments[$i]->tournament_id . '">' . HelperDB::GetTournamentName($tournaments[$i]) . '</option>';
					$r++;
				}
			}
			$disabled = '';
			if($r === 0) {
				$options .= '<option value="0">' . $language['team_notournadd'] . '</option>';
				$disabled = ' disabled="disabled"';
			}
			echo '<form action="' . $_SERVER['PHP_SELF'] . '?mod=' . $_GET['mod'] . '" method="post">';
			echo '<input type="hidden" name="new_end3" value="1" />';
			$table = new LSTable(1, 2, '100%', $null);
			$table->setTitle($language['team_jointourn']);
			$table->addCellAttribute(0, 0, 'width', '100%');
			$table->setText(0, 0, '<select size="1" name="teamA_jointourn" style="width: 500px;"' . $disabled . '>' . $options . '</select>');
			$table->addCellAttribute(0, 1, 'class', 'nowrap');
			$table->setText(0, 1, '<input type="submit" value="' . $language['common_send'] . '"' . $disabled . ' />');
			$table->draw();
			echo '</form>';
			echo '<br />';

			$c = count($tournament_team);
			$table = new LSTable(max($c, 1), 2, '100%', $null);
			$table->setTitle($language['team_tournsub']);
			for($i = 0; $i < $c; $i++) {
				$table->setText($i, 0, '<a href="../site/tournament.php?id=' . $tournament_team[$i]->tournament_id . '">' . HelperDB::GetTournamentName($tournament_team[$i]) . '</a>');
				$table->addCellAttribute($i, 1, 'width', '15');
				$table->setText($i, 1, '<a href="' . $_SERVER['PHP_SELF'] . '?mod=' . $id . '&amp;del_end3=' . $tournament_team[$i]->tournament_id . '"><img src="../images/x.gif" alt="X" /></a>');
			}
			if($c === 0) {
				$table->addCellAttribute(0, 0, 'align', 'center');
				$table->addCellAttribute(0, 0, 'colspan', '2');
				$table->setText(0, 0, $language['team_notourn']);
			}
			$table->draw();
			echo '<br />';
		}

		echo '<p><a class="blacktext" href="' . $_SERVER['PHP_SELF'] . '"><img src="../images/arrow2_left.gif" width="23" height="11" border="0" alt="&lt;" />' . $language['common_back'] . '</a></p>';
	}
} elseif (isset($_GET['del'])) {
	$teams_class = new db_teams();
	$teams_class->fill(array('team_id' => $_GET['del']));
	$error = $teams_class->delete();
	if ($error !== db_data::ERROR_NONE) {
		$dobject = display_error($teams_class, $error, $_SERVER['PHP_SELF']);
		$dobject->draw();
	} else {
		$dobject = display_updated($language['end_delete'], $_SERVER['PHP_SELF'], 2);
		$dobject->draw();
	}
} else {
	$teams_class = db_data::searchForClass('db_teams', array('single_user'=>0), array('name'=>'ASC'), '', 'team_id');
	$line = count($teams_class);

	$table = new LSTable($line + 1, 4, '100%', $null);
	$table->setTitle($language['team_team']);
	for ($i = 0; $i < $line; $i++) {
		$template = array();
		$template['team_id'] = $teams_class[$i]->team_id;
		$template['name'] = $teams_class[$i]->name;
		$template['date'] = transform_timestamp($teams_class[$i]->subscribed, 'd-m-Y H:i');

		$tournaments = HelperDB::GetTeamTournament($teams_class[$i]->team_id);
		$c = count($tournaments);
		$combo = '';
		for($j = 0; $j < $c; $j++) {
			$combo .= '<option>' . HelperDB::GetTournamentName($tournaments[$j]) . '</option>';
		}
		if($c === 0) {
			$combo .= '<option>' . $language['team_notournaments'] . '</option>';
		}

		$table->addCellAttribute($i + 1, 0, 'style', 'width: 100%;');
		$table->setText($i + 1, 0, '<a href="?mod=' . $template['team_id'] . '">' . $template['name'] . '</a>');
		$table->addCellAttribute($i + 1, 1, 'class', 'nowrap');
		$table->setText($i + 1, 1, $template['date']);

		$table->addCellAttribute($i + 1, 2, 'align', 'center');
		$table->addCellAttribute($i + 1, 2, 'width', '165');
		$table->setText($i + 1, 2, '<select style="width: 165px;" size="1">' . $combo . '</select>');

		$table->addCellAttribute($i + 1, 3, 'align', 'center');
		$table->addCellAttribute($i + 1, 3, 'width', '15');
		$table->setText($i + 1, 3, '<a href="' . $_SERVER['PHP_SELF'] . '?del=' . $template['team_id'] . '"><img src="../images/x.gif" width="15" height="15" border="0" alt="X" /></a>');
	}
	if($line === 0) {
		$table->addCellAttribute(0, 0, 'align','center');
		$table->addCellAttribute(0, 0, 'colspan', '4');
		$table->setText(0, 0, $language['team_noteams']);
	} else {
		$table->addRowAttribute(0, 'class', 'table_title');
		$table->addAllCellsInRowAttribute(0, 'align', 'center');
		$table->setText(0, 0, '<b>' . $language['team_name'] . '</b>');
		$table->setText(0, 1, '<b>' . $language['common_date'] . '</b>');
		$table->setText(0, 2, '<b>' . $language['team_subscribed'] . '</b>');
	}
	$table->draw();
	echo '<br /><form action="' . $_SERVER['PHP_SELF'] . '?new=1" method="post"><div align="center"><input type="submit" value="' . $language['common_add'] . '" /></div></form>';
	echo '<p><a class="blacktext" href="index.php"><img src="../images/arrow2_left.gif" width="23" height="11" border="0" alt="&lt;" />' . $language['common_back'] . '</a></p>';
}

include('../modules/footer.php');
?>