<?php
/***********************************************************
 *			tournament.php
 *		    ----------------------
 * Created		: Fri, Feb 27, 2004
 * Copyright		: (C) LookStrike Team
 * WebSite		: http://www.lookstrike.com
 *
 * $Id: tournament.php,v 1.14 2008/02/09 20:34:56 jsgoupil Exp $
 *
 ***********************************************************/
define('IN_LS', true);
define('ADMIN', 2);
include('../modules/header.php');
include_once('../modules/class/db/db_tournaments.php');
include_once('../modules/class/db/db_tournament_teams.php');
include_once('../modules/class/db/db_games.php');
include_once('../modules/class/db/db_teams.php');
include_once('../modules/class/db/db_players.php');
include_once('../modules/class/HelperDB.php');

// Put all GET fields in integer
if(is_array($_GET) === true) {
	foreach($_GET as $key => $value) {
		$_GET[$key] = intval($value);
	}
}

if (isset($_GET['new']) || isset($_GET['mod'])) {
	// Do we display the form add/edit ?
	$fDisplayForm = true;

	// Getting the ID
	$id = isset($_GET['mod']) ? $_GET['mod'] : 0;

	// Get the instance correctly filled (data from db and $_POST)
	$tournaments_class = HelperDB::GetInstance('db_tournaments', $id, 'tournament_', isset($_POST['new_end']));
	$tournaments_class->setAdmin(true);

	// We are finished entering data
	if (isset($_POST['new_end'])) {
		if (isset($_GET['mod'])) {
			$error = $tournaments_class->modify();
			$display = $language['end_modify'];
		} else {
			$error = $tournaments_class->insert();
			$display = $language['end_insert'];
		}
		if ($error !== db_data::ERROR_NONE) {				// An error occured
			$dobject = display_error($tournaments_class, $error);
			$dobject->draw();
			echo '<br />';
		} else {							// No error
			$dobject = display_updated($display, $_SERVER['PHP_SELF'], 2);
			$dobject->draw();
			$fDisplayForm = false;
		}
	}

	// ################## TEAM ##################
	if (isset($_POST['new_end2']) && intval($_POST['new_end2']) === 1 && isset($_POST['tournamentA_jointeam']) && intval($_POST['tournamentA_jointeam']) > 0) {
		$tournament_teams = new db_tournament_teams();
		$tournament_teams->team_id = $_POST['tournamentA_jointeam'];
		$tournament_teams->tournament_id = $id;
		$error = $tournament_teams->insert();
		if ($error !== db_data::ERROR_NONE) {				// An error occured
			$dobject = display_error($tournament_teams, $error);
			$dobject->draw();
			echo '<br />';
		} else {							// No error
			$dobject = display_updated($language['tournament_addteam'], $_SERVER['PHP_SELF'], 2);
			$dobject->draw();
			$fDisplayForm = false;
		}
	}
	if (isset($_GET['del_end2']) && intval($_GET['del_end2']) > 0) {
		$tournament_teams = new db_tournament_teams();
		$tournament_teams->fill(array('AND' => array('team_id' => $_GET['del_end2'], 'tournament_id' => $id)));
		$error = $tournament_teams->delete();
		if ($error !== db_data::ERROR_NONE) {				// An error occured
			$dobject = display_error($tournament_teams, $error);
			$dobject->draw();
			echo '<br />';
		} else {							// No error
			$dobject = display_updated($language['tournament_delteam'], $_SERVER['PHP_SELF'], 2);
			$dobject->draw();
			$fDisplayForm = false;
		}
	}

	if ($fDisplayForm === true) {						// Display Form ?
		if (isset($_GET['mod'])) {
			$language_table = $language['tournament_mod'];
			echo '<form action="' . $_SERVER['PHP_SELF'] . '?mod=' . $_GET['mod'] . '" method="post">';
		} else {
			$language_table = $language['tournament_add'];
			echo '<form action="' . $_SERVER['PHP_SELF'] . '?new=1" method="post">';
		}

		$template = array();
		$template['game_id']		= $tournaments_class->game_id;
		$template['description']	= $tournaments_class->description;
		$template['price']		= $tournaments_class->price;
		$template['minimal_player']	= $tournaments_class->minimal_player;
		$template['status']		= $tournaments_class->status;
		$template['single_user']	= (int)$tournaments_class->single_user;
		$template['itselfsub']		= (int)$tournaments_class->itselfsub;

		echo '<script type="text/javascript">';
		echo 'function single_user(form){';
		echo '  if(form.tournament_single_user.checked==true){';
		echo '    form.tournament_minimal_player.disabled=true;';
		echo '    form.tournament_minimal_player.value="0";';
		echo '  }';
		echo '  else';
		echo '    form.tournament_minimal_player.disabled=false;';
		echo '}';
		echo 'function status_tournament(form){';
		echo '  if(form.tournament_status.value != ' . $template['status'] . '){';
		echo '    if(confirm("' . $language['tournament_areusure'] . '"))';
		echo '      form.submit();';
		echo '  }';
		echo '  else';
		echo '    form.submit();';
		echo '}';
		echo '</script>';
		echo '<input type="hidden" name="new_end" value="1" />';
		$table_cols = array('game', 'description', 'price', 'minimal_player');
		$table = new LSTable(8, 2, '100%', $null);
		$table->setTitle($language_table);
		$table->addCellAttribute(0, 0, 'width', '150');
		$table->setText(0, 0, $language['common_game']);
		$table->setText(1, 0, $language['common_description']);
		$table->setText(2, 0, $language['tournament_price']);
		$table->setText(3, 0, $language['tournament_minplayer']);
		$table->setText(4, 0, $language['tournament_status']);
		$table->setText(5, 0, $language['tournament_singleuser']);
		$table->setText(6, 0, $language['tournament_itselfsub']);
		$text2display = '<select name="tournament_game_id" style="width:400px">';
		$game_class = new db_games();
		$games = $game_class->searchForClass('db_games', '', array('name' => 'ASC'), '', $game_class->getPrimary());
		foreach ($games as $game) {
			$text2display .= '<option value="' . $game->game_id .'"';
			if ($game->game_id === $template['game_id']) {
				$text2display .= ' selected="selected"';
			}
			$text2display .= '>' . $game->name . '</option>';
		}
		$text2display .= '</select>';
		$table->setText(0, 1, $text2display);
		$table->setText(1, 1, '<textarea name="tournament_description" cols="50" rows="10" style="width:400px">' . $template['description'] . '</textarea>');
		$table->setText(2, 1, '<input type="text" name="tournament_price" size="30" style="width:400px" value="' . $template['price'] . '" />');
		$table->setText(3, 1, '<input type="text" name="tournament_minimal_player" size="30" style="width:400px" value="' . $template['minimal_player'] . '" />');
		$text2display = '<select name="tournament_status" style="width:400px">';
		$c = count($language['tournament_statust']);
		for($i = $template['status']; $i < $c; $i++) {
			$text2display .= '<option value="' . $i .'"';
			if ((int)$i === (int)$template['status']) {
				$text2display .= ' selected="selected"';
			}
			$text2display .= '>' . $language['tournament_statust'][$i] . '</option>';
		}
		$text2display .= '</select>';
		$table->setText(4, 1, $text2display);
		$table->addCellAttribute(5, 0, 'colspan', '2');
		$table->setText(5, 0, '<label for="tournament_single_user"><input type="checkbox" name="tournament_single_user" id="tournament_single_user" value="1" onclick="single_user(this.form);"'.(($template['single_user'] === 1) ? ' checked="checked"' : '').''.(((int)$id !== 0) ? ' disabled="disabled"' : '').' /> ' . $language['tournament_singleuser'] . '</label>');
		$table->addCellAttribute(6, 0, 'colspan', '2');
		$table->setText(6, 0, '<label for="tournament_itselfsub"><input type="checkbox" name="tournament_itselfsub" id="tournament_itselfsub" value="1"'.(($template['itselfsub'] === 1) ? ' checked="checked"' : '').' /> ' . $language['tournament_itselfsub'] . '</label>');
		$table->addCellAttribute(7, 0, 'align', 'center');
		$table->addCellAttribute(7, 0, 'colspan', '2');
		$table->setText(7, 0, '<input type="button" value="' . $language['common_send'] . '" onclick="status_tournament(this.form);" />');
		colorError($table, $table_cols, $tournaments_class->getError());
		$table->draw();
		echo '</form>';
		echo '<br />';

		if(isset($_GET['mod'])) {
			// ################## TEAM ##################
			$options = '';
			$teams = db_data::searchForClass('db_teams', array('single_user'=>$template['single_user']), array('name'=>'ASC'), '', 'team_id'); // Problem for ordering players
			$tournament_team = HelperDB::GetTournamentTeam($id);
			$c = count($teams);
			$r = 0;
			for($i = 0; $i < $c; $i++) {
				if(!in_array_class(intval($teams[$i]->team_id), $tournament_team, 'team_id', false)) {
					$options .= '<option value="' . $teams[$i]->team_id . '">' . HelperDB::GetTeamName($teams[$i]) . '</option>';
					$r++;
				}
			}
			$disabled = '';
			if($r === 0) {
				$options .= '<option value="0">' . $language['tournament_noteamadd'] . '</option>';
				$disabled = ' disabled="disabled"';
			}
			echo '<form action="' . $_SERVER['PHP_SELF'] . '?mod=' . $_GET['mod'] . '" method="post">';
			echo '<input type="hidden" name="new_end2" value="1" />';
			$table = new LSTable(1, 2, '100%', $null);
			$table->setTitle($language['tournament_jointeam']);
			$table->addCellAttribute(0, 0, 'width', '100%');
			$table->setText(0, 0, '<select size="1" name="tournamentA_jointeam" style="width: 500px;"' . $disabled . '>' . $options . '</select>');
			$table->addCellAttribute(0, 1, 'class', 'nowrap');
			$table->setText(0, 1, '<input type="submit" value="' . $language['common_send'] . '"' . $disabled . ' />');
			$table->draw();
			echo '</form>';
			echo '<br />';

			$c = count($tournament_team);
			$table = new LSTable(max($c, 1), 2, '100%', $null);
			$table->setTitle($language['tournament_teamsub']);
			for($i = 0; $i < $c; $i++) {
				$table->setText($i, 0, '<a href="../site/info.php?t=team&amp;id=' . $tournament_team[$i]->team_id . '">' . HelperDB::GetTeamName($tournament_team[$i]) . '</a>');
				$table->addCellAttribute($i, 1, 'width', '15');
				$table->setText($i, 1, '<a href="' . $_SERVER['PHP_SELF'] . '?mod=' . $id . '&amp;del_end2=' . $tournament_team[$i]->team_id . '"><img src="../images/x.gif" alt="X" /></a>');
			}
			if($c === 0) {
				$table->addCellAttribute(0, 0, 'align', 'center');
				$table->addCellAttribute(0, 0, 'colspan', '2');
				$table->setText(0, 0, $language['tournament_noteam']);
			}
			$table->draw();
			echo '<br />';
		}

		echo '<p><a class="blacktext" href="' . $_SERVER['PHP_SELF'] . '"><img src="../images/arrow2_left.gif" width="23" height="11" border="0" alt="&lt;" />' . $language['common_back'] . '</a></p>';
	}
} elseif(isset($_GET['del'])) {
	$tournaments_class = new db_tournaments();
	$tournaments_class->fill(array('tournament_id' => $_GET['del']));
	$error = $tournaments_class->delete();
	if ($error !== db_data::ERROR_NONE) {
		$dobject = display_error($tournaments_class, $error, $_SERVER['PHP_SELF']);
		$dobject->draw();
	} else {
		$dobject = display_updated($language['end_delete'], $_SERVER['PHP_SELF'], 2);
		$dobject->draw();
	}
} else {
	$tournaments_class = db_data::searchForClass('db_tournaments', '', array('status'=>'ASC', 'inserted'=>'DESC'), '', 'tournament_id');
	$line = count($tournaments_class);

	$table = new LSTable($line + 1, 4, '100%', $null);
	$table->setTitle($language['tournament_tournament']);
	for ($i = 0; $i < $line; $i++) {
		$ffa = '';
		if(intval($tournaments_class[$i]->single_user) === 1) {
			$ffa = ' (' . $language['tournament_singleuser'] . ')';
		}

		$template = array();
		$template['tournament_id'] = $tournaments_class[$i]->tournament_id;
		$template['name'] = HelperDB::GetTournamentName($tournaments_class[$i]->tournament_id) . $ffa;
		$template['game_id'] = $tournaments_class[$i]->game_id;
		$template['status'] = $language['tournament_statust'][$tournaments_class[$i]->status];

		$teams = HelperDB::GetTournamentTeam($tournaments_class[$i]->tournament_id);
		$c = count($teams);
		$combo = '';
		for($j = 0; $j < $c; $j++) {
			$combo .= '<option>' . HelperDB::GetTeamName($teams[$j]) . '</option>';
		}
		if($c === 0) {
			$combo .= '<option>' . $language['tournament_noteams'] . '</option>';
		}

		$table->addCellAttribute($i + 1, 0, 'style', 'width: 100%;');
		$table->setText($i + 1, 0, '<a href="?mod=' . $template['tournament_id'] . '">' . $template['name'] . '</a>');
		$table->addCellAttribute($i + 1, 1, 'class', 'nowrap');
		$table->setText($i + 1, 1, $template['status']);

		$table->addCellAttribute($i + 1, 2, 'align', 'center');
		$table->addCellAttribute($i + 1, 2, 'width', '165');
		$table->setText($i + 1, 2, '<select style="width: 165px;" size="1">' . $combo . '</select>');

		$table->addCellAttribute($i + 1, 3, 'align', 'center');
		$table->addCellAttribute($i + 1, 3, 'width', '15');
		$table->setText($i + 1, 3, '<a href="' . $_SERVER['PHP_SELF'] . '?del=' . $template['tournament_id'] . '"><img src="../images/x.gif" width="15" height="15" border="0" alt="X" /></a>');
	}
	if($line === 0) {
		$table->addCellAttribute(0, 0, 'align','center');
		$table->addCellAttribute(0, 0, 'colspan', '4');
		$table->setText(0, 0, $language['tournament_notournaments']);
	} else {
		$table->addRowAttribute(0, 'class', 'table_title');
		$table->addAllCellsInRowAttribute(0, 'align', 'center');
		$table->setText(0, 0, '<b>' . $language['common_name'] . '</b>');
		$table->setText(0, 1, '<b>' . $language['tournament_status'] . '</b>');
		$table->setText(0, 2, '<b>' . $language['tournament_inserted'] . '</b>');
	}
	$table->draw();
	echo '<br /><form action="' . $_SERVER['PHP_SELF'] . '?new=1" method="post"><div align="center"><input type="submit" value="' . $language['common_add'] . '" /></div></form>';
	echo '<p><a class="blacktext" href="index.php"><img src="../images/arrow2_left.gif" width="23" height="11" border="0" alt="&lt;" />' . $language['common_back'] . '</a></p>';
}

include('../modules/footer.php');
?>