<?php
/***********************************************************
 *			index.php
 *		    -------------------
 * Created		: Tue, May 4, 2004
 * Copyright		: (C) LookStrike Team
 * WebSite		: http://www.lookstrike.com
 *
 * $Id: index.php,v 1.12 2007/02/15 22:24:42 jsgoupil Exp $
 *
 ***********************************************************/
define('IN_LS', true);
define('NO_DB', false);
error_reporting(E_ALL); // Show all errors

define('INI_OK', 0);
define('INI_WARNING', 1);
define('INI_ERROR', 2);

$ini_color = array(
	INI_OK		=>'#00840c',
	INI_WARNING	=>'#818300',
	INI_ERROR	=>'#910000'
);

// Petite verification avant de commencer
$ini_req = array(	// ini_param => ini_val, error/warning, 1=problematic (auto)
	'register_globals'	=>		array(0,	INI_ERROR,	0),
	'display_errors'	=>		array(0,	INI_WARNING,	0),
	'magic_quotes_runtime'	=>		array(0,	INI_WARNING,	0),
	'magic_quotes_gpc'	=>		array(1,	INI_WARNING,	0),
	'magic_quotes_sybase'	=>		array(0,	INI_ERROR,	0),
	'allow_call_time_pass_reference'=>	array(0,	INI_WARNING,	0)
);

reset($ini_req);
$ini_state = INI_OK;
while((list($key,$val) = each($ini_req)) !== false) {
	if(intval(ini_get($key)) !== $val[0]) {
		$ini_req[$key][2] = 1;
		if($ini_state<$val[1]) {
			$ini_state = $val[1];
		}
	}
}

$gd2 = false; // Error with GD2 ?
if(function_exists('imagecreate') === false) {
	$gd2 = true;
	$ini_state = INI_ERROR;
}

if(isset($_POST['file_config']) && isset($_POST['file_name'])) {
	header('Content-Type: text/x-delimtext; name="'.$_POST['file_name'].'"');
	header('Content-disposition: attachment; filename="'.$_POST['file_name'].'"');
	echo stripslashes($_POST['file_config']);
	exit;
}

// # FUNCTIONS
function page_header() {
	global $language;

	echo '<?xml version="1.0" encoding="iso-8859-1"?>'."\n";
?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
<title>LookStrike L@N - <?php echo $language['title']; ?></title>
<meta name="Author" content="LookStrike Team" />
<link type="text/CSS" rel="stylesheet" href="../style.css" />
<script language="JavaScript" type="text/javascript">
window.name="lookstrike_local";
</script>
</head>
<body bgcolor="#045997" alink="#ff0000" link="#0000ff" vlink="#800080" text="#000000">
<table width="100%" border="0" cellpadding="0" cellspacing="0">
<tr><td align="center">
<img src="../images/blank.gif" width="1" height="10" border="0" alt="" />
<table width="98%" border="0" cellpadding="0" cellspacing="0" align="center" bgcolor="#074470" class="tableline"><tr><td>

<table width="100%" border="0" cellpadding="4" cellspacing="1" align="center">
<tr><td align="center">

<?php
}

function page_footer() {
?>
</td></tr></table>
</td></tr></table>

</td></tr>
</table>
</body>
</html><?php
}

function remove_lines($text,$line_start) {
	$line = split("\n", $text);
	$text = '';
	$c = count($line);
	for($i = 0; $i < $c; $i++) {
		if(substr(trim($line[$i]), 0, strlen($line_start)) !== $line_start) {
			$text .= $line[$i] . "\n";
		}
	}
	$text = trim($text);
	return $text;
}

function execute_query($sql,&$db) {
	$line = split(';', $sql);
	$c = count($line);
	for($i = 0; $i < $c; $i++) {
		if(trim($line[$i]) !== '') {
			$db->sql_query(trim($line[$i]));
		}
	}
}

// Same as funtion into function.php
function addSlash(&$table) {
	if(is_array($table)) {
		reset($table);
		while(list($key, $value) = each($table)) {
			if(is_array($table[$key])) {
				addSlash($table[$key]);
			} else {
				$table[$key] = addslashes($value);
			}
		}
		reset($table);
	}
}

// Adds \ if magic_quotes_gpc is off
if(!get_magic_quotes_gpc()) {
	addSlash($_GET);
	addSlash($_POST);
	addSlash($_COOKIE);
}

// Loading Language
// If we found a different language than english, we take it
include('../language/abbr.php');
$language_menu = array();
$handle=opendir('../language');
while (($file = readdir($handle)) !== false) {
	if(is_dir('../language/'.$file) && $file !== '.' && $file !== '..') {
		$language_menu[] = $file;
	}
}
closedir($handle);

$language_default='en';
$language_supported = array();
$c = count($language_menu);
for($i = 0; $i < $c; $i++) {
	if(array_key_exists($language_menu[$i],$language_lang_abbr)) {
		$language_supported[] = $language_menu[$i];
		if($language_menu[$i] !== 'en') {
			$language_default=$language_menu[$i];
		}
	}
}

$language_default = (isset($_POST['install_conf_language'])) ? $_POST['install_conf_language'] : ((isset($_GET['language'])) ? $_GET['language']:$language_default);
unset($language);	// for register_globals compatibility
if(!@include('../language/'.$language_default.'/language.php')) {
	die('The install language file cannot be read.');
}
if(file_exists('../modules/config.php') || file_exists('../modules/config.ini')) {
	die('LookStrike Lan is already installed !');
}
include('../language/'.$language_default.'/install.php');

// INI CHECK
if(isset($_GET['ini']) && intval($_GET['ini']) === 1) {
	page_header();
	echo '<h2>'.$language['phpini'].'</h2>';
	echo '<table width="95%" border="0" cellpadding="0" cellspacing="0" align="center" bgcolor="#074470" class="tableline"><tr><td>';
	echo '<table width="100%" border="0" cellpadding="4" cellspacing="1" align="center">';
	if($gd2 === false) {
		$c = $ini_color[INI_OK];
		$text2display = $language['loaded'];
	} else {
		$c = $ini_color[INI_ERROR];
		$text2display = $language['notloaded'];
	}
	echo '<tr bgcolor="#0369a1"><td><b><u><font style="background-color:'.$c.'">GD2 '.$language['library'].'</font></u></b></td><td align="right" width="100">'.$text2display.'</td></tr>';
	echo '<tr bgcolor="#0176b3"><td colspan="2">'.$language['ini']['gd2'].'</td></tr>';
	echo '</table>';
	echo '</td></tr></table>';

	reset($ini_req);
	while((list($key,$val) = each($ini_req)) !== false) {
		echo '<table width="95%" border="0" cellpadding="0" cellspacing="0" align="center" bgcolor="#074470" class="tableline"><tr><td>';
		echo '<table width="100%" border="0" cellpadding="4" cellspacing="1" align="center">';
		if($val[2] === 0) {
			$c = $ini_color[INI_OK];
		} else {
			$c = $ini_color[$val[1]];
		}
		echo '<tr bgcolor="#0369a1"><td><b><u><font style="background-color:'.$c.'">'.$key.'</font></u></b></td><td align="right" width="100">'.intval(ini_get($key)).'</td></tr>';
		echo '<tr bgcolor="#0176b3"><td colspan="2">'.$language['ini'][$key].'</td></tr>';
		echo '</table>';
		echo '</td></tr></table>';
	}
	echo '<p align="right">[ <a href="javascript:close();">'.$language['close'].'</a> ]</p>';
	page_footer();
	exit;
}

$install_value = array('db_hostname','db_username','db_password1','db_password2','db_database','db_tableprefix','db_file',/*'dbmaster_hostname','dbmaster_username','dbmaster_password1','dbmaster_password2','dbmaster_database','dbmaster_tableprefix','ini_checkmaster_nickname',*/'conf_path','conf_language','conf_session','ini_login_subscription','user_login','user_email','user_nickname','user_password1','user_password2');
$install_default = array('localhost','root','','','','ls_','',/*'localhost','root','','','','ls_','0',*/str_replace('install','',dirname($_SERVER['PHP_SELF'])),$language_default,'3600','allowed','admin','',$language['administrator'],'','','','','');
$install_required = array('db_hostname','db_username','db_database','conf_language','conf_session','user_login','user_email','user_nickname','user_password1');

// Checking SQL Files
$sql_menu = array();
$handle=opendir('../modules/db');
while (($file = readdir($handle)) !== false) {
	if(!is_dir('../modules/db/'.$file) && $file !== '.' && $file !== '..') {
		$sql_menu[$file] = '';
	}
}
closedir($handle);
// Checking Description in SQL Files
reset($sql_menu);
while (list($key, $val) = each($sql_menu)) {
	$fp = fopen('../modules/db/'.$key,'r');
	while(!feof($fp)) {
		$buffer = fgets($fp,255);
		if(substr($buffer,0,15) === '// Description:') {
			$sql_menu[$key] = substr($buffer,16);
			break;
		}
	}
	if($sql_menu[$key] === '') {
		$sql_menu[$key] = $key;
	}
}

$error_required = array();
if(isset($_POST['install_continue']) && $ini_state < INI_ERROR) {
	$c = count($install_required);
	for($i = 0; $i < $c; $i++) {
		if(!isset($_POST['install_'.$install_required[$i]]) || empty($_POST['install_'.$install_required[$i]])) {
			$error_required[] = $language[$install_required[$i]];
		}
	}
	if(count($error_required) === 0) {
		if($_POST['install_db_password1'] !== $_POST['install_db_password2']) {
			$error_required[] = 'SpecialError';
			$error_required[] = sprintf($language['wrong_password'],$language['abbr_db'],$language['abbr_db']);
			$_POST['install_db_password1'] = $_POST['install_db_password2']='';
		}
		if($_POST['install_user_password1'] !== $_POST['install_user_password2']) {
			$error_required[] = 'SpecialError';
			$error_required[] = sprintf($language['wrong_password'],$language['abbr_user'],$language['abbr_user']);
			$_POST['install_user_password1'] = $_POST['install_user_password2']='';
		}
		if(count($error_required) === 0) {
			if(!include('../modules/db/'.$_POST['install_db_file'])) {
				$error_required[] = 'SpecialError';
				$error_required[] = sprintf($language['db_file_error'],$_POST['install_db_file']);
			}
			if(count($error_required) === 0) {
				$db = new db($_POST['install_db_hostname'],$_POST['install_db_username'],$_POST['install_db_password1'],$_POST['install_db_database']);
				if(!$db->link) {
					$error_required[] = 'SpecialError';
					$error_required[] = sprintf($language['sql_says'],'Can\'t connect to SQL DataBase');
				} else {
					$temp_error = $db->sql_error();
					if(strcmp($temp_error['message'],'') !== 0) {
						$error_required[] = 'SpecialError';
						$error_required[] = sprintf($language['sql_says'],$temp_error['message']);
					}
				}

				if(count($error_required) === 0) {
					$install_database = array('admins','double','games','match_teams','matches','news','pages','platform','players','server_group','server_ip','sessions','team_players','teams','tournament_teams','tournaments','trees');
					$c = count($install_database);
					for($i = 0; $i < $c; $i++) {
						$install_database[$i] = $_POST['install_db_tableprefix'].$install_database[$i];
					}
					$tables_list = $db->sql_listtables($_POST['install_db_database']);
					$c = count($tables_list);
					for($i = 0; $i < $c; $i++) {
						if(in_array($tables_list[$i], $install_database)) {
							$error_required[] = 'SpecialError';
							$error_required[] = $language['table_error'];
							break;
						}
					}

					if(count($error_required) === 0) {
						// Testing if we have the right to create the table
						$db->sql_query('CREATE TABLE `'.$_POST['install_db_tableprefix'].'temp` (  `temp` int(11) NOT NULL default \'0\' ) TYPE=MyISAM DEFAULT CHARSET=latin1');
						$error_sql = $db->sql_error();
						$db->sql_query('DROP TABLE `'.$_POST['install_db_tableprefix'].'temp`');
						if($error_sql['message'] !== '') {
							$error_required[] = 'SpecialError';
							$error_required[] = $language['db_noright'];
						}

						if(count($error_required) === 0) {
							$ini_file = "[login]\n";
							$ini_file .= 'subscription='.$_POST['install_ini_login_subscription']."\n";
							$ini_file .= "[checkmaster]\n";
							//$ini_file .= 'nickname='.$_POST['install_ini_checkmaster_nickname']."\n";
							$handle = fopen('../modules/config.ini','w+');
							fwrite($handle,$ini_file,strlen($ini_file));
							fclose($handle);
							$_POST['install_conf_path'] = substr($_POST['install_conf_path'],0,strlen($_POST['install_conf_path'])-1);
							$file_prefix = substr($_POST['install_db_file'],0,strrpos($_POST['install_db_file'],'.'));
							$file_db_structure = 'schemas/'.$file_prefix.'_structure.sql';
							$file_db_data = 'schemas/'.$file_prefix.'_data.sql';
							$sql = @fread(@fopen($file_db_structure, 'r'), @filesize($file_db_structure));
							$sql = preg_replace('/ls_/', $_POST['install_db_tableprefix'], $sql);
							$sql = remove_lines($sql,'#');
							execute_query($sql,$db);
							$sql = @fread(@fopen($file_db_data, 'r'), @filesize($file_db_data));
							$sql = preg_replace('/ls_/', $_POST['install_db_tableprefix'], $sql);
							$sql = preg_replace('/INSTALL_USER_LOGIN/', $_POST['install_user_login'], $sql);
							$sql = preg_replace('/INSTALL_USER_EMAIL/', $_POST['install_user_email'], $sql);
							$sql = preg_replace('/INSTALL_USER_PASSWORD/', md5($_POST['install_user_password1']), $sql);
							$sql = preg_replace('/INSTALL_USER_NICKNAME/', $_POST['install_user_nickname'], $sql);
							$sql = preg_replace('/INSTALL_CONF_LANGUAGE/', $_POST['install_conf_language'], $sql);
							$sql = remove_lines($sql,'#');
							execute_query($sql,$db);
							//$_POST['install_dbmaster_hostname'] = (isset($_POST['install_dbmaster_hostname']))?$_POST['install_dbmaster_hostname']:'';
							$file_config = '<?php'."\n";
							$file_config .= '/***********************************************************'."\n";
							$file_config .= ' *			config.php'."\n";
							$file_config .= ' *		    ------------------'."\n";
							$file_config .= ' * File Automatically Generated by LookStrike Lan'."\n";
							$file_config .= ' * Do not change anything in this file'."\n";
							$file_config .= ' ***********************************************************/'."\n";
							$file_config .= 'if(!defined(\'IN_LS\'))die("You are not allowed to access to this page.");'."\n";
							$file_config .= '$sys_conf = array('."\n";
							$file_config .= '	"db" => array('."\n";
							$file_config .= '		"hostname"	=> \''.$_POST['install_db_hostname'].'\','."\n";
							$file_config .= '		"username"	=> \''.$_POST['install_db_username'].'\','."\n";
							$file_config .= '		"password"	=> \''.$_POST['install_db_password1'].'\','."\n";
							$file_config .= '		"database"	=> \''.$_POST['install_db_database'].'\','."\n";
							$file_config .= '		"table_prefix"	=> \''.$_POST['install_db_tableprefix'].'\','."\n";
							$file_config .= '		"file"		=> \''.$_POST['install_db_file'].'\','."\n";
							$file_config .= '	),'."\n\n";
							/*
							$file_config .= '	"dbmaster" => array('."\n";
							$file_config .= '		"hostname"	=> \''.$_POST['install_dbmaster_hostname'].'\','."\n";
							$file_config .= '		"username"	=> \''.$_POST['install_dbmaster_username'].'\','."\n";
							$file_config .= '		"password"	=> \''.$_POST['install_dbmaster_password1'].'\','."\n";
							$file_config .= '		"database"	=> \''.$_POST['install_dbmaster_database'].'\','."\n";
							$file_config .= '		"table_prefix"	=> \''.$_POST['install_dbmaster_tableprefix'].'\','."\n";
							$file_config .= '	),'."\n\n";
							*/
							$file_config .= '	"path" => array('."\n";
							$file_config .= '		"documentroot"	=> $temp_root,'."\n";
							$file_config .= '		"documentplus"	=> $temp_plus,'."\n";
							$file_config .= '		"real"		=> $temp_root.$temp_plus,'."\n";
							$file_config .= '		"relative_path"	=> \'\','."\n";
							$file_config .= '		"filename"	=> \'\','."\n";
							$file_config .= '		"extension"	=> \'\','."\n";
							$file_config .= '	),'."\n\n";
							$file_config .= '	"lang" => array('."\n";
							$file_config .= '		"default"	=> \''.$_POST['install_conf_language'].'\','."\n";
							$file_config .= '		"used"		=> \'\','."\n";
							$file_config .= '	),'."\n\n";
							$file_config .= '	"session" => array('."\n";
							$file_config .= '		"temps"		=> \''.$_POST['install_conf_session'].'\','."\n";
							$file_config .= '		"connected"	=> \'300\','."\n";
							$file_config .= '	),'."\n\n";
							$file_config .= '	"color" => array('."\n";
							$file_config .= '		"back"		=> \'#ffffff\','."\n";
							$file_config .= '		"border"	=> \'#004163\','."\n";
							$file_config .= '		"won"		=> \'#02cf02\','."\n";
							$file_config .= '		"lost"		=> \'#912323\','."\n";
							$file_config .= '		"tie"		=> \'#ffffff\','."\n";
							$file_config .= '		"red"		=> \'#e65050\','."\n";
							$file_config .= '	),'."\n";
							$file_config .= ');'."\n";
							$file_config .= '?>';

							page_header();
							echo '<img src="../images/ls_install.gif" width="541" height="74" border="0" alt="LookStrike Install" />';
							echo '<br /><table width="417" border="0" cellpadding="0" cellspacing="0" align="center" bgcolor="#074470" class="tableline"><tr><th><u>'.$language['install_over'].'</u>';
							echo '</th></tr><tr><td>';
							echo '<table width="100%" border="0" cellpadding="4" cellspacing="1" align="center">';
							echo '<tr bgcolor="#0369a1"><td>';

							if(($fp = @fopen('../modules/config.php','w')) !== false) {
								@fputs($fp, $file_config, strlen($file_config));
								@fclose($fp);
								echo $language['install_ok'];
							} else {
								echo $language['install_ok2'];
								echo '<br /><form action="'.$_SERVER['PHP_SELF'].'" method="post">';
								echo '<input type="hidden" name="file_name" value="config.php" />';
								echo '<input type="hidden" name="file_config" value="'.htmlspecialchars($file_config).'" />';
								echo '<div align="center"><input type="submit" value="'.$language['install_download'].'" /></div>';
								echo '</form>';
							}

							if($_POST['install_conf_path'] !== '') {
								$save_buffer='';
								$fp = @fopen('../modules/header.php','r')
									or die($language['cant_read']);
								while(!feof($fp)) {
									$buffer = @fgets($fp);
									if(trim($buffer) === '$temp_plus = \'\';') {
										$save_buffer .= '$temp_plus = \''.$_POST['install_conf_path'].'\';'."\n";
									} else {
										$save_buffer .= $buffer;
									}
								}
								@fclose($fp);
								if(($fp = @fopen('../modules/header.php','w')) !== false) {
									@fputs($fp, $save_buffer, strlen($save_buffer));
									@fclose($fp);
								} else {
									echo '<p>';
									echo $language['install_header'];
									echo '</p>';
									echo '<br /><form action="'.$_SERVER['PHP_SELF'].'" method="post">';
									echo '<input type="hidden" name="file_name" value="header.php" />';
									echo '<input type="hidden" name="file_config" value="'.htmlspecialchars($save_buffer).'" />';
									echo '<div align="center"><input type="submit" value="'.$language['install_download2'].'" /></div>';
									echo '</form>';
								}
							}

							echo '</td></tr>';
							echo '</table>';
							echo '</td></tr></table>';

							echo '<br /><table width="417" border="0" cellpadding="0" cellspacing="0" align="center" bgcolor="#074470" class="tableline"><tr><th><u>'.$language['reminder'].'</u>';
							echo '</th></tr><tr><td>';
							echo '<table width="100%" border="0" cellpadding="4" cellspacing="1" align="center">';
							echo '<tr bgcolor="#0369a1"><td>';
							echo $language['reminder_text'];
							echo '</td></tr>';
							echo '</table>';
							echo '</td></tr></table>';
							echo '<br />';
							page_footer();
							exit;
						}
					}
				}
			}
		}
	}
}

page_header();

if(!isset($_POST['install_continue']) || count($error_required) >= 1 || $ini_state !== INI_OK) {
	$c = count($install_value);
	for($i = 0; $i < $c; $i++) {
		${'install_'.$install_value[$i]} = (isset($_POST['install_'.$install_value[$i]]))?$_POST['install_'.$install_value[$i]]:$install_default[$i];
		${'install_'.$install_value[$i]} = stripslashes(${'install_'.$install_value[$i]}); // We remove \' added
	}
?>
<img src="../images/ls_install.gif" width="541" height="74" border="0" alt="LookStrike Install" />
<table width="90%" border="0" align="center">
<tr><td height="40"><?php echo $language['explanation']; ?></td></tr>
<tr><td height="30"><?php echo $language['phpini']; ?> : <b><font color="#ffffff" style="background-color:<?php echo $ini_color[$ini_state]; ?>"><?php echo $language['phpini_code'][$ini_state]; ?></font> <a href="javascript:;" onclick="window.open('index.php?language=<?php echo $language_default; ?>&amp;ini=1','ini_val','toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=yes,resizable=no,width=470,height=350,left=50,top=200')" style="text-decoration: none;"><font class="littletext">(<?php echo $language['phpini_click']; ?>)</font></a></b></td></tr>
<tr><td><?php echo $language['select_language']; ?> <?php
	$c = count($language_supported);
	for($i = 0; $i < $c; $i++) {
		echo '<a href="'.$_SERVER['PHP_SELF'].'?language='.$language_supported[$i].'">';
		echo '<img src="../language/'.$language_supported[$i].'/images/flag.gif" width="12" height="9" border="0" hspace="2" alt="'.$language_lang[$language_lang_abbr[$language_supported[$i]]].'" />';
		echo '</a> ';
	}
?></td></tr>
</table>

<?php
	if(count($error_required) >= 1) {
?>
<br />
<table width="60%" border="0" cellpadding="0" cellspacing="0" align="center" bgcolor="#074470" class="tableline"><tr><th><u><?php echo $language['error']; ?></u>
</th></tr><tr><td>
<table width="100%" border="0" cellpadding="4" cellspacing="1" align="center">
<tr bgcolor="#0369a1"><td>
<?php
		// We display only one error if the password is not correct
		if($error_required[0] === 'SpecialError') {
			echo $error_required[1];
		} else {
			if(count($error_required) === 1) {
				echo $language['info_missing'];
			} else {
				echo $language['info_missings'];
			}
			$c = count($error_required);
			for($i = 0; $i < $c; $i++) {
				echo '<br /> - '.$error_required[$i];
			}
		}
?>
</td></tr>
</table>
</td></tr></table><br />
<?php
	}
?>

<form action="<?php echo $_SERVER['PHP_SELF']; ?>?language=<?php echo $language_default; ?>" method="post">
<input type="hidden" name="install_continue" value="1" />
<table width="90%" border="0" cellpadding="0" cellspacing="0" align="center" bgcolor="#074470" class="tableline"><tr><th><u><?php echo $language['step1_t1']; ?></u>
</th></tr><tr><td>
<table width="100%" border="0" cellpadding="4" cellspacing="1" align="center">
<tr bgcolor="#004e7a"><td colspan="2" align="center"><b><?php echo $language['step1_d1']; ?></b></td></tr>
<tr bgcolor="#0369a1"><td align="right" width="40%"><?php echo $language['db_hostname']; ?></td><td><input type="text" name="install_db_hostname" size="20" style="width:180px" value="<?php echo $install_db_hostname; ?>" /></td></tr>
<tr bgcolor="#0176b3"><td align="right"><?php echo $language['db_username']; ?></td><td><input type="text" name="install_db_username" size="20" style="width:180px" value="<?php echo $install_db_username; ?>" /></td></tr>
<tr bgcolor="#0369a1"><td align="right"><?php echo $language['password']; ?></td><td><input type="password" name="install_db_password1" size="20" style="width:180px" value="<?php echo $install_db_password1; ?>" /></td></tr>
<tr bgcolor="#0176b3"><td align="right"><?php echo $language['password1']; ?></td><td><input type="password" name="install_db_password2" size="20" style="width:180px" value="<?php echo $install_db_password2; ?>" /></td></tr>
<tr bgcolor="#0369a1"><td align="right"><?php echo $language['db_database']; ?></td><td><input type="text" name="install_db_database" size="20" style="width:180px" value="<?php echo $install_db_database; ?>" /></td></tr>
<tr bgcolor="#0176b3"><td align="right"><?php echo $language['db_tableprefix']; ?></td><td><input type="text" name="install_db_tableprefix" size="20" style="width:180px" value="<?php echo $install_db_tableprefix; ?>" /></td></tr>
<tr bgcolor="#0176b3"><td align="right"><?php echo $language['db_file']; ?></td><td><select name="install_db_file" size="1" style="width:180px">
<?php
	reset($sql_menu);
	while (list($key, $val) = each($sql_menu)) {
		echo '<option value="'.$key.'"';
		if($key === $install_db_file) { echo' selected="selected"'; }
		echo '> '.$val.'</option>';;
	}
?>
</select></td></tr><?php /*
<tr bgcolor="#004e7a"><td colspan="2" align="center"><b><?php echo $language['step1_d2']; ?></b></td></tr>
<tr bgcolor="#0369a1"><td align="right" width="40%"><?php echo $language['db_hostname']; ?></td><td><input type="text" name="install_db_hostname" size="20" style="width:180px" value="<?php echo $install_db_hostname; ?>" /></td></tr>
<tr bgcolor="#0176b3"><td align="right"><?php echo $language['db_username']; ?></td><td><input type="text" name="install_dbmaster_username" size="20" style="width:180px" value="<?php echo $install_db_username; ?>" /></td></tr>
<tr bgcolor="#0369a1"><td align="right"><?php echo $language['password']; ?></td><td><input type="password" name="install_dbmaster_password1" size="20" style="width:180px" value="<?php echo $install_db_password1; ?>" /></td></tr>
<tr bgcolor="#0176b3"><td align="right"><?php echo $language['password1']; ?></td><td><input type="password" name="install_dbmaster_password2" size="20" style="width:180px" value="<?php echo $install_db_password2; ?>" /></td></tr>
<tr bgcolor="#0369a1"><td align="right"><?php echo $language['db_database']; ?></td><td><input type="text" name="install_dbmaster_database" size="20" style="width:180px" value="<?php echo $install_db_database; ?>" /></td></tr>
<tr bgcolor="#0176b3"><td align="right"><?php echo $language['db_tableprefix']; ?></td><td><input type="text" name="install_dbmaster_tableprefix" size="20" style="width:180px" value="<?php echo $install_db_tableprefix; ?>" /></td></tr>
<tr bgcolor="#0176b3"><td align="right"><?php echo $language['db_checkmaster']; ?></td><td><select name="install_ini_checkmaster_nickname" /><option value="0"<?php if(intval($install_ini_checkmaster_nickname) === 0) { echo ' selected="selected"'; } ?>><?php echo $language['no']; ?></option><option value="1"<?php if(intval($install_ini_checkmaster_nickname) === 1) { echo ' selected="selected"'; } ?>><?php echo $language['yes']; ?></option></td></tr>
			 */?>
<tr bgcolor="#004e7a"><td colspan="2" align="center"><b><?php echo $language['step1_t2']; ?></b></td></tr>
<tr bgcolor="#0369a1"><td align="right"><?php echo $language['conf_path']; ?></td><td><input type="hidden" name="install_conf_path" value="<?php echo $install_conf_path; ?>" /><?php echo $install_conf_path; ?></td></tr>
<tr bgcolor="#0176b3"><td align="right"><?php echo $language['conf_language']; ?></td><td><select name="install_conf_language" size="1" style="width:180px">
<?php
	$c = count($language_supported);
	for($i = 0; $i < $c; $i++) {
		echo '<option value="'.$language_supported[$i].'"';
		if($language_supported[$i] === $language_default) { echo' selected="selected"'; }
		echo '> '.$language_lang[$language_lang_abbr[$language_supported[$i]]].'</option>';
	}
?>
</select></td></tr>
<tr bgcolor="#0369a1"><td align="right"><?php echo $language['conf_session']; ?></td><td><input type="text" name="install_conf_session" size="20" style="width:180px" value="<?php echo $install_conf_session; ?>" /></td></tr>
<tr bgcolor="#004e7a"><td colspan="2" align="center"><b><?php echo $language['step1_t3']; ?></b></td></tr>
<tr bgcolor="#0369a1"><td align="right"><?php echo $language['user_subscription']; ?></td><td><select name="install_ini_login_subscription"  style="width:180px"><option value="allowed"<?php if($install_ini_login_subscription === 'allowed') { echo ' selected="selected"'; } ?>><?php echo $language['user_allowed']; ?></option><option value="supervised"<?php if($install_ini_login_subscription === 'supervised') { echo ' selected="selected"'; } ?>><?php echo $language['user_supervised']; ?></option></select></td></tr>
<tr bgcolor="#0369a1"><td align="right"><?php echo $language['user_login']; ?></td><td><input type="text" name="install_user_login" size="20" style="width:180px" value="<?php echo $install_user_login; ?>" /></td></tr>
<tr bgcolor="#0369a1"><td align="right"><?php echo $language['user_email']; ?></td><td><input type="text" name="install_user_email" size="20" style="width:180px" value="<?php echo $install_user_email; ?>" /></td></tr>
<tr bgcolor="#0176b3"><td align="right"><?php echo $language['user_nickname']; ?></td><td><input type="text" name="install_user_nickname" size="20" style="width:180px" value="<?php echo $install_user_nickname; ?>" /></td></tr>
<tr bgcolor="#0369a1"><td align="right"><?php echo $language['password']; ?></td><td><input type="password" name="install_user_password1" size="20" style="width:180px" value="<?php echo $install_user_password1; ?>" /></td></tr>
<tr bgcolor="#0176b3"><td align="right"><?php echo $language['password1']; ?></td><td><input type="password" name="install_user_password2" size="20" style="width:180px" value="<?php echo $install_user_password2; ?>" /></td></tr>
<tr bgcolor="#0369a1"><td colspan="2" align="center"><input type="submit" value="<?php echo $language['start']; ?>"<?php if($ini_state === INI_ERROR) { echo ' disabled="disabled'; } ?> /></td></tr>
</table>
</td></tr></table>
</form>

<?php
}
page_footer();
?>