--
-- LookStrike Lan Structure
--
-- $Id: mysql_structure.sql,v 1.9 2008/01/27 01:58:48 jsgoupil Exp $
--
-- --------------------------------------------------------

--
-- Table structure for table `ls_admins`
--

CREATE TABLE `ls_admins` (
  `player_id` int(11) NOT NULL default '0',
  `level` int(11) unsigned NOT NULL default '0',
  UNIQUE KEY `admin_mid` (`player_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `ls_alert`
--

CREATE TABLE `ls_alert` (
  `name` varchar(255) NOT NULL default '',
  `value` varchar(255) NOT NULL default '',
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `ls_double`
--

CREATE TABLE `ls_double` (
  `team_id` int(11) NOT NULL default '0',
  `tree_id` int(11) NOT NULL default '0',
  `position` int(11) NOT NULL default '0',
  PRIMARY KEY  (`team_id`,`tree_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `ls_games`
--

CREATE TABLE `ls_games` (
  `game_id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `description` text,
  `platform_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`game_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `ls_match_teams`
--

CREATE TABLE `ls_match_teams` (
  `match_id` int(11) NOT NULL default '0',
  `team_id` int(11) NOT NULL default '0',
  `score` int(11) NOT NULL default '0',
  PRIMARY KEY  (`match_id`,`team_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `ls_matches`
--

CREATE TABLE `ls_matches` (
  `match_id` int(11) NOT NULL auto_increment,
  `tournament_id` int(11) NOT NULL default '0',
  `comment` varchar(255) default NULL,
  `start_time` timestamp NOT NULL default '0000-00-00 00:00:00',
  `end_time` timestamp NOT NULL default '0000-00-00 00:00:00',
  `tree_id` int(11) NOT NULL default '0',
  `node` int(11) default NULL,
  `server_id` int(11) default NULL,
  PRIMARY KEY  (`match_id`),
  UNIQUE KEY `server_id` (`server_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `ls_news`
--

CREATE TABLE `ls_news` (
  `news_id` int(11) NOT NULL auto_increment,
  `player_id` int(11) NOT NULL default '0',
  `subject` varchar(255) NOT NULL default '',
  `texte` text NOT NULL,
  `inserted` timestamp NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`news_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `ls_pages`
--

CREATE TABLE `ls_pages` (
  `page_id` int(11) NOT NULL auto_increment,
  `path` varchar(255) NOT NULL default '',
  `level` int(11) unsigned NOT NULL default '0',
  `hits` int(11) unsigned NOT NULL default '0',
  `connected` int(11) unsigned NOT NULL default '0',
  `time_inserted` timestamp NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`page_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `ls_platform`
--

CREATE TABLE `ls_platform` (
  `platform_id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `tag` varchar(255) NOT NULL default '',
  `image` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`platform_id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `ls_players`
--

CREATE TABLE `ls_players` (
  `player_id` int(11) NOT NULL auto_increment,
  `login` varchar(15) default NULL,
  `password` varchar(32) NOT NULL default 'd41d8cd98f00b204e9800998ecf8427e',
  `nickname` varchar(50) default NULL,
  `lastname` varchar(50) NOT NULL default '',
  `firstname` varchar(50) NOT NULL default '',
  `email` varchar(70) NOT NULL default '',
  `address1` varchar(255) NOT NULL default '',
  `address2` varchar(255) default NULL,
  `city` varchar(50) NOT NULL default '',
  `state` varchar(50) NOT NULL default '',
  `country` varchar(50) NOT NULL default '',
  `postal_code` varchar(50) NOT NULL default '',
  `phone` varchar(50) NOT NULL default '',
  `birthday` date NOT NULL default '0000-00-00',
  `warn_user` tinyint(1) NOT NULL default '0',
  `allow_change` tinyint(1) NOT NULL default '1',
  `checked` tinyint(1) NOT NULL default '0',
  `language` char(2) NOT NULL default 'fr',
  `cost` decimal(5,2) NOT NULL default '0.00',
  `msn` varchar(255) NOT NULL default '',
  `activated` tinyint(1) NOT NULL default '0',
  `subscribed` timestamp NOT NULL default '0000-00-00 00:00:00',
  `last_move` timestamp NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`player_id`),
  UNIQUE KEY `login` (`login`),
  UNIQUE KEY `nickname` (`nickname`),
  UNIQUE KEY `email` (`email`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=2;

-- --------------------------------------------------------

--
-- Table structure for table `ls_server_group`
--

CREATE TABLE `ls_server_group` (
  `group_id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `ls_server_ip`
--

CREATE TABLE `ls_server_ip` (
  `server_id` int(11) NOT NULL auto_increment,
  `group_id` int(11) NOT NULL default '0',
  `ip` varchar(8) NOT NULL default '',
  `port` int(5) NOT NULL default '0',
  `password` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`server_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `ls_sessions`
--

CREATE TABLE `ls_sessions` (
  `player_id` int(11) NOT NULL default '0',
  `started` timestamp NOT NULL default '0000-00-00 00:00:00',
  `last_move` timestamp NOT NULL default '0000-00-00 00:00:00',
  `ip` varchar(8) NOT NULL default '',
  `name` varchar(32) NOT NULL default '',
  `emplacement` int(11) NOT NULL default '0',
  `language` char(2) NOT NULL default 'en'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `ls_team_players`
--

CREATE TABLE `ls_team_players` (
  `team_id` int(11) NOT NULL default '0',
  `player_id` int(11) NOT NULL default '0',
  `level` tinyint(1) NOT NULL default '0',
  `subscribed` timestamp NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`team_id`,`player_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `ls_teams`
--

CREATE TABLE `ls_teams` (
  `team_id` int(11) NOT NULL auto_increment,
  `name` varchar(50) default NULL,
  `password` varchar(32) default NULL,
  `single_user` tinyint(1) NOT NULL default '1',
  `subscribed` timestamp NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`team_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=2;

-- --------------------------------------------------------

--
-- Table structure for table `ls_tournament_teams`
--

CREATE TABLE `ls_tournament_teams` (
  `tournament_id` int(11) NOT NULL default '0',
  `team_id` int(11) NOT NULL default '0',
  `subscribed` timestamp NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`tournament_id`,`team_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `ls_tournaments`
--

CREATE TABLE `ls_tournaments` (
  `tournament_id` int(11) NOT NULL auto_increment,
  `game_id` int(11) NOT NULL default '0',
  `description` text,
  `price` decimal(5,2) unsigned NOT NULL default '0.00',
  `minimal_player` tinyint(1) unsigned NOT NULL default '0',
  `single_user` tinyint(1) NOT NULL default '0',
  `status` tinyint(1) NOT NULL default '0',
  `itselfsub` tinyint(1) NOT NULL default '0',
  `server_group` int(11) default NULL,
  `inserted` timestamp NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`tournament_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `ls_trees`
--

CREATE TABLE `ls_trees` (
  `tree_id` int(11) NOT NULL auto_increment,
  `tournament_id` int(11) NOT NULL default '0',
  `previous` int(11) NOT NULL default '0',
  `tree_type` tinyint(1) NOT NULL default '0',
  `tie` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`tree_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;