<?php
/***********************************************************
 *			account.php
 *		    -------------------
 * Created		: Fri, Dec 12, 2003
 * Copyright		: (C) LookStrike Team
 * WebSite		: http://www.lookstrike.com
 *
 * $Id: account.php,v 1.8 2008/02/02 20:07:39 jsgoupil Exp $
 *
 ***********************************************************/
define('IN_LS', true);
define('MEMBER', true);
include('../modules/header.php');

$type = $ini->getVal('login', 'type');
$nickname = (bool)$ini->getVal('checkmaster', 'nickname');

// FOR HTML FORM
$value = format_html($_POST, $member_data, 'modify_', 'login', 'nickname', 'lastname', 'firstname', 'email', 'address1', 'address2', 'city', 'state', 'country', 'postal_code', 'phone', 'birthday', 'warn_user');
$required = check_required($_POST, 'modify_', 'login', 'nickname', 'lastname', 'firstname', 'email'); // birthday is special and we don't put it there...

$allow_write = array('login'=>'0', 'nickname'=>'0', 'lastname'=>'0', 'firstname'=>'0', 'email'=>'0', 'address1'=>'0', 'address2'=>'0', 'city'=>'0', 'state'=>'0', 'country'=>'0', 'postal_code'=>'0', 'phone'=>'0', 'birthday'=>'0');

reset($allow_write);
while(list($key) = each($allow_write)) {
	$allow_write[$key] = intval($member_data['allow_change']);
}
// Sauf le nom d'utilisateur
$allow_write['login'] = 0;

$modify_birthday_year = intval((isset($_POST['modify_birthday_year'])) ? $_POST['modify_birthday_year'] : substr($value['modify_birthday'], 0, 4));
$modify_birthday_month = intval((isset($_POST['modify_birthday_month'])) ? $_POST['modify_birthday_month'] : substr($value['modify_birthday'], 5, 2));
$modify_birthday_day = intval((isset($_POST['modify_birthday_day'])) ? $_POST['modify_birthday_day'] : substr($value['modify_birthday'], 8, 2));

$display_error = NULL;

if (isset($_POST['modify'])) {
	format_to_screen($value, false);

	// On verifie si on avait dit qu'on ne voulait pas ces valeurs
	reset($required);
	$count = 0;
	while(list(, $val) = each($required)) {
		if ((bool)$allow_write[$val] === false) {
			array_splice($required, $count, 1);
			$count--;
		}
		$count++;
	}

	if (count($required) >= 1) {
		$display_error = 1;
		$text2display = '';
		if (count($required) > 1) {
			$text2display .= $language['common_missings'];
		} else {
			$text2display .= $language['common_missing'];
		}
		$c = count($required);
		for($i = 0; $i < $c; $i++) {
			$text2display .= '<br /> - ' . $language['account_' . $required[$i]] . "\n";
		}
		$dobject = display_error($text2display, NULL);
		$dobject->draw();
		echo '<br />';
	}
	if (!(checkdate($modify_birthday_month, $modify_birthday_day, $modify_birthday_year)) && $display_error === NULL) {
		$display_error = 1;
		$dobject = display_error($language['account_errorbirth'], NULL);
		$dobject->draw();
		echo '<br />';
	}

	if ($display_error === NULL) {
		if ($nickname === true) {
			$nickname_result = $dbmaster->sql_query('SELECT player_id FROM ' . $sys_conf['dbmaster']['table_prefix'] . 'players WHERE nickname=\'' . $value['modify_nickname'] . '\'');
			$nickname_line = $dbmaster->sql_numrows($nickname_result);
			$player_result = $db->sql_query('SELECT nickname FROM ' . $sys_conf['db']['table_prefix'] . 'players WHERE player_id=\'' . $session_data['player_id'] . '\'');
			$player_data = $db->sql_fetchrow($player_result);
		}
		$nick_result = $db->sql_query('SELECT nickname FROM ' . $sys_conf['db']['table_prefix'] . 'players WHERE nickname=\'' . $value['modify_nickname'] . '\'');
		$nick_line = $db->sql_numrows($nick_result);
		$nick_data = $db->sql_fetchrow($nick_result);
		if (($nick_line > 0 && $value['modify_nickname'] !== $nick_data['nickname']) || ($nickname === true && $nickname_line > 0 && $value['modify_nickname'] !== $player_data['nickname'])) {
			$display_error = 1;
			$dobject = display_error($language['account_alreadynick'], NULL);
			$dobject->draw();
			echo '<br />';
		}
	}

	if ($display_error === NULL) {
		// Verification Si nickname already used
		if ($member_data['nickname'] === $value['modify_nickname']) { // On n'a pas chang... on a gard l'ancien
			$player_line = 0;
		} else {
			$player_result = $db->sql_query('SELECT player_id FROM ' . $sys_conf['db']['table_prefix'] . 'players WHERE nickname=\'' . $value['modify_nickname'] . '\'');
			$player_line = $db->sql_numrows($player_result);
		}
		if ($player_line >= 1) {
			$dobject = display_error($language['account_alreadynick']);
			$dobject->draw();
			echo '<br />';
		} else {
			// Verification Si email est dj pris
			if ($member_data['email'] === $value['modify_email']) { // On n'a pas chang... on a gard l'ancien
				$player_line = 0;
			} else {
				$player_result = $db->sql_query('SELECT player_id FROM ' . $sys_conf['db']['table_prefix'] . 'players WHERE email=\'' . $value['modify_email'] . '\'');
				$player_line = $db->sql_numrows($player_result);
			}
			if ($player_line >= 1) {
				$dobject = display_error($language['account_alreadymail']);
				$dobject->draw();
				echo '<br />';
			} else {
				$to_update = to_update($value, 'modify_', 'nickname', 'lastname', 'firstname', 'email', 'address1', 'address2', 'city', 'state', 'country', 'postal_code', 'phone');
				$to_update .= ', birthday=\'' . $modify_birthday_year . '-' . $modify_birthday_month . '-' . $modify_birthday_day . '\', checked=\'0\', allow_change=\'0\', subscribed=subscribed, last_move=last_move';

				// On fait les remplacements par val=val si l'utilisateur n'avait pas le droit de modifier une information pour une meilleure protection
				reset($allow_write);
				while(list($key, $val) = each($allow_write)){
					if ((bool)$val === false) {		// On n'avait pas le droit de modifier
						$to_update = str_replace($key . '=\'' . $value['modify_' . $key] . '\'', $key . '=' . $key, $to_update);
					}
				}

				$db->sql_query('UPDATE ' . $sys_conf['db']['table_prefix'] . 'players SET ' . $to_update . ' WHERE player_id=\'' . $session_data['player_id'] . '\' AND allow_change=\'1\'');
				$dobject = display_updated($language['ended_insert'], 'index.php', 2);
				$dobject->draw();
				echo '<br />';
			}
		}
	}
	format_to_screen($value, true);
}

if (!isset($_POST['modify']) || ($display_error !== NULL && isset($_POST['modify']))) {
	$table = new LSTable(1, 1, '60%', $null);
	$table->setTitle($language['account_note']);
	$table->setText(0, 0, $language['account_explain']);
	$table->draw();
	echo '<br />';

	if (intval($value['modify_warn_user']) === 1) {
		$table = new LSTable(1, 1, '60%', $null);
		$table->setTitle('</u>*** <u>' . $language['common_error'] . '</u> ***<u>');
		$table->setText(0, 0, '<b>' . $language['account_warnuser'] . '</b>');
		$table->draw();
		echo '<br />';
	}
	$send_button = 0;
	if (intval($member_data['allow_change']) === 1) {
		echo '<form action="' . $_SERVER['PHP_SELF'] . '" method="post">';
		echo '<input type="hidden" name="modify" value="1" />';
		$send_button = 1;
	}
	$num2 = ($type === 'card') ? 1 : 0;
	$table = new LSTable(14 + $num2 + $send_button, 2, '100%', $null);
	$table->setTitle($language['title']);
	$table->addRowAttribute(0, 'class', 'table_title');
	$table->addCellAttribute(0, 0, 'colspan', '2');
	$table->setText(0, 0, '<b>' . $language['account_title1'] . '</b>');
	$table->addCellAttribute(1, 0, 'width', '50%');
	if ($type === 'card') {
		$table->setText(1, 0, $language['account_login']);
		$table->setText(1, 1, ((bool)$allow_write['login'] === true)
			? '<input type="text" name="modify_login" value="' . $value['modify_login'] . '" style="width:135px" maxlength="15" />'
			: ((empty($value['modify_login'])) ? '&nbsp;' : $value['modify_login'])
		);
	}
	$table->setText(1 + $num2, 0, $language['account_nickname'] . ' *');
	$table->setText(1 + $num2, 1, ((bool)$allow_write['lastname'] === true)
		? '<input type="text" name="modify_nickname" value="' . $value['modify_nickname'] . '" style="width:135px" maxlength="50" />'
		: ((empty($value['modify_nickname'])) ? '&nbsp;' : $value['modify_nickname'])
	);
	$table->addRowAttribute(2+$num2, 'class', 'table_title');
	$table->addCellAttribute(2+$num2, 0, 'colspan', '2');
	$table->setText(2 + $num2, 0, '<b>' . $language['account_title2'] . ' <font class="littletext">(' . $language['account_required'] . ')</font></b>');
	$table->setText(3 + $num2, 0, $language['account_lastname'] . ' *');
	$table->setText(3 + $num2, 1, ((bool)$allow_write['lastname'] === true)
		? '<input type="text" name="modify_lastname" value="' . $value['modify_lastname'] . '" style="width:135px" maxlength="50" />'
		: ((empty($value['modify_lastname'])) ? '&nbsp;' : $value['modify_lastname'])
	);
	$table->setText(4 + $num2, 0, $language['account_firstname'] . ' *');
	$table->setText(4 + $num2, 1, ((bool)$allow_write['firstname'] === true)
		? '<input type="text" name="modify_firstname" value="' . $value['modify_firstname'] . '" style="width:135px" maxlength="50" />'
		: ((empty($value['modify_firstname'])) ? '&nbsp;' : $value['modify_firstname'])
	);
	$table->setText(5 + $num2, 0, $language['account_email'] . ' *');
	$table->setText(5 + $num2, 1, ((bool)$allow_write['email'] === true)
		? '<input type="text" name="modify_email" value="' . $value['modify_email'] . '" style="width:135px" maxlength="70" />'
		: ((empty($value['modify_email'])) ? '&nbsp;' : $value['modify_email'])
	);
	$table->setText(6 + $num2, 0, $language['account_address1']);
	$table->setText(6 + $num2, 1, ((bool)$allow_write['address1'] === true)
		? '<input type="text" name="modify_address1" value="' . $value['modify_address1'] . '" style="width:135px" maxlength="255" />'
		: ((empty($value['modify_address1'])) ? '&nbsp;' : $value['modify_address1'])
	);
	$table->setText(7 + $num2, 0, $language['account_address2']);
	$table->setText(7 + $num2, 1, ((bool)$allow_write['address2'] === true)
		? '<input type="text" name="modify_address2" value="' . $value['modify_address2'] . '" style="width:135px" maxlength="255" />'
		: ((empty($value['modify_address2'])) ? '&nbsp;' : $value['modify_address2'])
	);
	$table->setText(8 + $num2, 0, $language['account_city']);
	$table->setText(8 + $num2, 1, ((bool)$allow_write['city'] === true)
		? '<input type="text" name="modify_city" value="' . $value['modify_city'] . '" style="width:135px" maxlength="50" />'
		: ((empty($value['modify_city'])) ? '&nbsp;' : $value['modify_city'])
	);
	$table->setText(9 + $num2, 0, $language['account_state']);
	$table->setText(9 + $num2, 1, ((bool)$allow_write['state'] == true)
		? '<input type="text" name="modify_state" value="' . $value['modify_state'] . '" style="width:135px" maxlength="30" />'
		: ((empty($value['modify_state'])) ? '&nbsp;' : $value['modify_state'])
	);
	$table->setText(10 + $num2, 0, $language['account_country']);
	$table->setText(10 + $num2, 1, ((bool)$allow_write['country'] == true)
		? '<input type="text" name="modify_country" value="' . $value['modify_country'] . '" style="width:135px" maxlength="25" />'
		: ((empty($value['modify_country'])) ? '&nbsp;' : $value['modify_country'])
	);
	$table->setText(11 + $num2, 0, $language['account_postal_code']);
	$table->setText(11 + $num2, 1, ((bool)$allow_write['postal_code'] === true)
		? '<input type="text" name="modify_postal_code" value="' . $value['modify_postal_code'] . '" style="width:135px" maxlength="6" />'
		: ((empty($value['modify_postal_code'])) ? '&nbsp;' : $value['modify_postal_code'])
	);
	$table->setText(12 + $num2, 0, $language['account_phone']);
	$table->setText(12 + $num2, 1, ((bool)$allow_write['phone'] === true)
		? '<input type="text" name="modify_phone" value="' . $value['modify_phone'] . '" style="width:135px" maxlength="50" />'
		: ((empty($value['modify_phone'])) ? '&nbsp;' : $value['modify_phone'])
	);
	$table->setText(13 + $num2, 0, $language['account_birthday'] . ' *');
	if ((bool)$allow_write['birthday'] === true) {
		$cell_val = '<select name="modify_birthday_day" size="1" style="width:45px"><option value="0">' . $language['account_birthd'] . '</option>';
		for($i = 1; $i <= 31; $i++) {
			$cell_val .= '<option value="' . $i . '"';
			if ($modify_birthday_day === $i) {
				$cell_val .= ' selected="selected"';
			}
			$cell_val .= '>' . $i . '</option>';
		}
		$cell_val .= '</select><select name="modify_birthday_month" size="1" style="width:50px"><option value="0">' . $language['account_birthm'] . '</option>';
		for($i = 1; $i <= 12; $i++) {
			$cell_val .= '<option value="' . $i . '"';
			if ($modify_birthday_month === $i) {
				$cell_val .= ' selected="selected"';
			}
			$cell_val .= '>' . $language['common_date2_' . $i] . '</option>';
		}
		$cell_val .= '</select><select name="modify_birthday_year" size="1" style="width:65px"><option value="0">' . $language['account_birthy'] . '</option>';
		for($i = date('Y'); $i >= 1901; $i--) {
			$cell_val .= '<option value="' . $i . '"';
			if ($modify_birthday_year === $i) {
				$cell_val .= ' selected="selected"';
			}
			$cell_val .= '>' . $i . '</option>';
		}
		$cell_val .= '</select>';
	} else {
		$cell_val = $modify_birthday_day . '-' . $language['common_date2_' . $modify_birthday_month] . '-' . $modify_birthday_year;
	}
	$table->setText(13 + $num2, 1, $cell_val);
	if (intval($member_data['allow_change']) === 1) {
		$table->addCellAttribute(14 + $num2, 0, 'align', 'center');
		$table->addCellAttribute(14 + $num2, 0, 'colspan', '2');
		$table->setText(14+$num2, 0, '<input type="submit" value="' . $language['common_send'] . '" />');
	}
	$table->draw();
	if (intval($member_data['allow_change']) === 1) {
		echo '</form>';
	}

	echo '<p><a class="blacktext" href="index.php"><img src="../images/arrow2_left.gif" width="23" height="11" border="0" alt="&lt;" />' . $language['common_back'] . '</a></p>';
}

include('../modules/footer.php');
?>