<?php
/***********************************************************
 *			register.php
 *		    --------------------
 * Created		: Mon, Aou 9, 2004
 * Copyright		: (C) LookStrike Team
 * WebSite		: http://www.lookstrike.com
 *
 * $Id: register.php,v 1.10 2008/02/09 20:34:57 jsgoupil Exp $
 *
 ***********************************************************/
define('IN_LS', true);
define('NO_MEMBER', true);
include('../modules/header.php');
include_once('../modules/class/HelperDB.php');
include_once('../modules/class/ComponentHelpers.php');

if ($ini->getVal('login', 'subscription') === 'supervised') {
	$dobject = display_error($language['register_supervised'], '../index.php');
	$dobject->draw();
} else {
	// Do we display the form add/edit ?
	$fDisplayForm = true;

	// Get the instance correctly filled (data from db and $_POST)
	$players_class = HelperDB::GetInstance('db_players', 0, 'player_', isset($_POST['new_end']));

	$noerror = true;
	// Specific : password
	// Reset ?
	if(isset($_POST['playerS_passwordreset']) && intval($_POST['playerS_passwordreset']) === 1) {
		$players_class->password = '';
	} elseif (isset($_POST['playerS_password1'], $_POST['playerS_password2']) && $_POST['playerS_password1'] !== $_POST['playerS_password2']) {
		// Error !
		$dobject = display_error($language['player_errorpassword'], NULL);
		$dobject->draw();
		echo '<br />';
		$noerror = false;
	} elseif (isset($_POST['playerS_password1']) && !empty($_POST['playerS_password1'])) {
		$players_class->password = $_POST['playerS_password1'];
	}
	// Specific : birthday
	if(isset($_POST['playerS_birthday_d'], $_POST['playerS_birthday_m'], $_POST['playerS_birthday_Y'])) {
		// Padding
		$_POST['playerS_birthday_d'] = str_pad($_POST['playerS_birthday_d'], 2, '0', STR_PAD_LEFT);
		$_POST['playerS_birthday_m'] = str_pad($_POST['playerS_birthday_m'], 2, '0', STR_PAD_LEFT);
		$_POST['playerS_birthday_Y'] = str_pad($_POST['playerS_birthday_Y'], 2, '0', STR_PAD_LEFT);
		if(checkdate($_POST['playerS_birthday_m'], $_POST['playerS_birthday_d'], $_POST['playerS_birthday_Y'])) {
			$players_class->birthday = $_POST['playerS_birthday_Y'] . '-' . $_POST['playerS_birthday_m'] . '-' . $_POST['playerS_birthday_d'];
		} else {
			// Error !
			$dobject = display_error($language['player_errorbirthday'], NULL);
			$dobject->draw();
			echo '<br />';
			$noerror = false;
		}
	}

	// We are finished entering data
	if (isset($_POST['new_end']) && $noerror === true) {
		$error = $players_class->insert();
		$display = $language['end_insert'];
		if ($error !== db_data::ERROR_NONE) {				// An error occured
			$dobject = display_error($players_class, $error);
			$dobject->draw();
			echo '<br />';
		} else {							// No error
			$dobject = display_updated($display, $_SERVER['PHP_SELF'], 2);
			$dobject->draw();
			$fDisplayForm = false;
		}
	}

	if ($fDisplayForm === true) {						// Display Form ?
		$template = array();
		$template['login']		= $players_class->login;
		$template['nickname']		= $players_class->nickname;
		$template['lastname']		= $players_class->lastname;
		$template['firstname']		= $players_class->firstname;
		$template['email']		= $players_class->email;
		$template['address1']		= $players_class->address1;
		$template['address2']		= $players_class->address2;
		$template['city']		= $players_class->city;
		$template['state']		= $players_class->state;
		$template['country']		= $players_class->country;
		$template['postal_code']	= $players_class->postal_code;
		$template['phone']		= $players_class->phone;
		$template['birthday']		= $players_class->birthday;

		echo '<form method="post" action="' . $_SERVER['PHP_SELF'] . '">';
		echo '<input type="hidden" name="new_end" value="1" />';
		$table_cols = array('#', 'login', 'nickname', 'password', 'password', '#', 'lastname', 'firstname', 'email', 'address1', 'address2', 'city', 'state', 'country', 'postal_code', 'phone', 'birthday');
		$table = new LSTable(18, 2, '100%', $null);
		$table->setTitle($language['title']);
		$table->addCellAttribute(0, 0, 'width', '150');
		$table->addRowAttribute(0, 'class', 'table_title');
		$table->addCellAttribute(0, 0, 'colspan', '2');
		$table->setText(0, 0, '<b>' . $language['register_title1'] . '</b>');
		$table->setText(1, 0, $language['common_login']);
		$table->setText(2, 0, $language['common_nickname']);
		$table->setText(3, 0, $language['common_password']);
		$table->setText(4, 0, $language['player_confirmation']);
		$table->addRowAttribute(5, 'class', 'table_title');
		$table->addCellAttribute(5, 0, 'colspan', '2');
		$table->setText(5, 0, '<b>' . $language['register_title2'] . ' <font class="littletext">(' . $language['register_required'] . ')</font></b>');
		$table->setText(6, 0, $language['player_lastname'] . ' *');
		$table->setText(7, 0, $language['player_firstname'] . ' *');
		$table->setText(8, 0, $language['player_email'] . ' *');
		$table->setText(9, 0, $language['player_address1']);
		$table->setText(10, 0, $language['player_address2']);
		$table->setText(11, 0, $language['player_city']);
		$table->setText(12, 0, $language['player_state']);
		$table->setText(13, 0, $language['player_country']);
		$table->setText(14, 0, $language['player_postal_code']);
		$table->setText(15, 0, $language['player_phone']);
		$table->setText(16, 0, $language['player_birthday'] . ' *');

		$table->setText(1, 1, '<input type="text" name="player_login" size="30" style="width:400px" value="' . $template['login'] . '" />');
		$table->setText(2, 1, '<input type="text" name="player_nickname" size="30" style="width:400px" value="' . $template['nickname'] . '" />');
		$table->setText(3, 1, '<input type="password" name="playerS_password1" size="30" style="width:400px" value="" />'); // Not count by HelperDB::GetInstance
		$table->setText(4, 1, '<input type="password" name="playerS_password2" size="30" style="width:400px" value="" />'); // Not count by HelperDB::GetInstance
		$table->setText(6, 1, '<input type="text" name="player_lastname" size="30" style="width:400px" value="' . $template['lastname'] . '" />');
		$table->setText(7, 1, '<input type="text" name="player_firstname" size="30" style="width:400px" value="' . $template['firstname'] . '" />');
		$table->setText(8, 1, '<input type="text" name="player_email" size="30" style="width:400px" value="' . $template['email'] . '" />');
		$table->setText(9, 1, '<input type="text" name="player_address1" size="30" style="width:400px" value="' . $template['address1'] . '" />');
		$table->setText(10, 1, '<input type="text" name="player_address2" size="30" style="width:400px" value="' . $template['address2'] . '" />');
		$table->setText(11, 1, '<input type="text" name="player_city" size="30" style="width:400px" value="' . $template['city'] . '" />');
		$table->setText(12, 1, '<input type="text" name="player_state" size="30" style="width:400px" value="' . $template['state'] . '" />');
		$table->setText(13, 1, '<input type="text" name="player_country" size="30" style="width:400px" value="' . $template['country'] . '" />');
		$table->setText(14, 1, '<input type="text" name="player_postal_code" size="30" style="width:400px" value="' . $template['postal_code'] . '" />');
		$table->setText(15, 1, '<input type="text" name="player_phone" size="30" style="width:400px" value="' . $template['phone'] . '" />');
		$table->setText(16, 1, ComponentHelpers::ComponentDate('playerS_birthday', $template['birthday'])); // Not count by HelperDB::GetInstance
		$table->addCellAttribute(17, 0, 'colspan', '2');
		$table->addCellAttribute(17, 0, 'align', 'center');
		$table->setText(17, 0, '<input type="submit" value="' . $language['common_send'] . '" />');
		colorError($table, $table_cols, $players_class->getError());
		$table->draw();
		echo '</form>';
		echo '<p><a class="blacktext" href="index.php"><img src="../images/arrow2_left.gif" width="23" height="11" border="0" alt="&lt;" />' . $language['common_back'] . '</a></p>';
	}
}
include('../modules/footer.php');
?>