<?php
/***********************************************************
 *			HandleINI.php
 *		    ---------------------
 * Created		: Mon, Mar 28, 2005
 * Copyright		: (C) LookStrike Team
 * WebSite		: http://www.lookstrike.com
 *
 * $Id: HandleINI.php,v 1.2 2006/01/22 23:54:24 jsgoupil Exp $
 *
 ***********************************************************/
if (!defined('IN_LS')) die('You are not allowed to access to this page.');

class HandleINI {
	private $file	= NULL;
	public $map	= array();

	public function __construct($file) {
		$this->setFile($file);
	}

	public function setFile($file) {
		$this->file = $file;
	}

	public function readINI() {
		$fp = NULL;
		try {
			if (!empty($this->file)) {
				$fp = fopen($this->file, 'r');

				$currentCategory = '';
				while (!feof($fp)) {
					$line = trim(fgets($fp, 255));
					if (substr($line, 0, 1) === ';') {
						continue;			// There is a comment
					}
					if (preg_match('/^\[([A-Za-z0-9_-]+)\]$/', $line, $match) === 1) {		// New category
						$currentCategory = $match[1];
					} elseif (!empty($currentCategory)) {
						if (preg_match('/([A-Za-z0-9_-]+)\s*=\s*([A-Za-z0-9_-]+)/', $line, $match)) {
							$this->setVal($currentCategory, $match[1], $match[2]);
						}
					}
				}
				fclose($fp);
			}
		}
		catch (Exception $e) { @fclose($fp); }
	}

	public function writeINI() {
		$fp = NULL;
		try {
			if (!empty($this->file)) {
				$fp = fopen($this->file, 'w');
				foreach ($this->map as $category => $val) {
					fwrite($fp, '[' . $category . ']' . "\n");
					foreach ( $val as $key => $value) {
						fwrite($fp, $key . '=' . $value . "\n");
					}
				}
				fclose($fp);
			}
		}
		catch (Exception $e) { @fclose($fp); }
	}

	public function getVal($category, $key) {
		if (isset($this->map[$category][$key])) {
			return $this->map[$category][$key];
		} else {
			return NULL;
		}
	}

	public function setVal($category, $key, $value) {
		if (!isset($this->map[$category])) {
			$this->map[$category] = array();
		}
		$this->map[$category][$key] = $value;
	}

	public function removeVal($category, $key) {
		unset($this->map[$category][$key]);
		if (count($this->map[$category]) === 0) {
			unset($this->map[$category]);
		}
	}
};
?>