<?php
/***********************************************************
 *			Msn.php
 *		    ---------------
 * Created		: Sun, Oct 11, 2005
 * Copyright		: (C) LookStrike Team
 * WebSite		: http://www.lookstrike.com 
 *
 * $Id: Msn.php,v 1.1.1.1 2006/01/07 21:26:46 jsgoupil Exp $
 *
 ***********************************************************/
class LSAlert {
	const TIMEOUT = 5;
	private $fp;
	private $errno;
	private $errstr;
	private $address;
	private $port;
	private $password;
	private $privkey;

	function __construct($address,$port,$password) {
		$this->address = $address;
		$this->port = $port;
		$this->password = $password;

		if($this->Connect() === false || $this->Login() === false){
			return false;
		}

		return true;
	}

	private function sendCommand($command) {
		return fwrite($this->fp, $command."\r\n", strlen($command)+2);
	}

	private function receiveCommand() {
		$read = fread($this->fp, 1024);
		$meta = stream_get_meta_data($this->fp);
		if($meta['timed_out'] === true) {
			return false;
		} else {
			$arr = array();
			$arr[0] = substr($read, 0, 3);
			if(strlen($read) >= 4) {
				$arr[1] = trim(substr($read, 4));
			} else {
				$arr[1] = false;
			}
			return $arr;
		}
	}

	private function Connect() {
		// Open the socket
		if(($this->fp = fsockopen($this->address,$this->port,$this->errno,$this->errstr)) === false){
			return false;
		}
		
		// Set timeout
		stream_set_timeout($this->fp, self::TIMEOUT);

		// Start communication with LookStrike Alert Java applet
		if($this->sendCommand('HEY') === false){
			return false;
		}

		// Read the private key
		if(($read = $this->receiveCommand($this->fp)) === false){
			return false;
		}
		$this->privkey = $read[1];
		
		return true;
	}

	private function Login() {
		// Make the MD5 password
		$password = md5($this->password.$this->privkey);

		// Send the password information
		if($this->sendCommand('LOG '.$password) === false){
			return false;
		}

		// Verify if the password works
		if(($read = $this->receiveCommand()) === false || $read === 'WTF'){
			return false;
		}

		return true;
	}

	private function SendMessage($msg) {
		// Send the message
		if($this->sendCommand($msg) === false){
			return false;
		}

		// Verify if it's worked
		if(($read = $this->receiveCommand()) === false || $read === 'ERR') {
			return false;
		}

		return true;
	}

	public function Add($email) {
		// Add an email to contact list
		return $this->SendMessage('ADD '.$email);
	}

	public function Del($email) {
		// Delete an email to contact list
		return $this->SendMessage('DEL '.$email);
	}

	public function Msg($email,$msg) {
		// Send a message to an email
		return $this->SendMessage('MSG '.$email.' '.$msg);
	}

	public function Msn($email) {
		// Check if he's in the contact list
		return $this->SendMessage('MSN '.$email);
	}
}
?>