<?php
/***********************************************************
 *			db_admins.php
 *		    ---------------------
 * Created		: Wed, Feb 1, 2006
 * Copyright		: (C) LookStrike Team
 * WebSite		: http://www.lookstrike.com
 *
 * $Id: db_admins.php,v 1.4 2007/06/18 01:31:01 jsgoupil Exp $
 *
 ***********************************************************/
include_once($sys_conf['path']['real'] . '/modules/class/db/db_data.php');
include_once($sys_conf['path']['real'] . '/modules/class/db/CheckDB.php');

class db_admins extends db_data {
	const ERROR_USER_NOTFOUND	= 1;
	const ERROR_INCORRECTLEVEL	= 2;

	public $player_id;		// int(11) -> players.player_id
	public $level;			// int(11)

	protected $_ERROR_LANGUAGE = array(
		self::ERROR_USER_NOTFOUND	=> 'USER_NOTFOUND',
		self::ERROR_INCORRECTLEVEL	=> 'ADMIN_INCORRECTLEVEL'
	);
	
	protected $_primary = 'player_id';
	protected $_unique = array(
		'player_id'
	);
	protected $_required_admin = array(
		'player_id',
		'level'
	);
	protected $_required = array();
	protected $_filter = array();

	public function __construct() {
		$this->player_id	 = 0;
		$this->level		 = 0;
	}

	public function insert() {
		global $sys_conf, $db;

		$error = $this->checkData(db_data::OPERATION_INSERT);
		$level = intval($this->level);
		if (intval($level) < 0) {
			$error = self::ERROR_INCORRECTLEVEL;
		}
		if ($error !== db_data::ERROR_NONE) {
			return $error;
		}

		if(CheckDB::isUser($this->player_id) === false) {
			return self::ERROR_USER_NOTFOUND;
		}

		$table = $this->getTableName($this);
		$data_insert = db_data::generateInsert('player_id', 'level');
		$db->sql_query('INSERT INTO ' . $table . ' ' . $data_insert);
		if ($db->sql_goterror() === true) {
			return db_data::ERROR_SQL;
		}

		return db_data::ERROR_NONE;
	}

	public function modify() {
		global $db;
		
		if ($this->exists() === false) {
			return self::ERROR_USER_NOTFOUND;
		}

		$error = $this->checkData(db_data::OPERATION_MODIFY);
		if ($this->level < 0) {
			$error = self::ADMIN_INCORRECTLEVEL;
		}
		if ($error !== db_data::ERROR_NONE) {
			return $error;
		}

		if(CheckDB::isUser($this->player_id) === false) {
			return self::ERROR_USER_NOTFOUND;
		}

		$table = $this->getTableName($this);
		$data_modify = db_data::generateModify('level');
		$db->sql_query('UPDATE ' . $table . ' SET ' . $data_modify . ' WHERE ' . $this->_primary.'=\'' . $this->{$this->_primary} . '\'');
		if ($db->sql_goterror() === true) {
			return db_data::ERROR_SQL;
		}

		return db_data::ERROR_NONE;
	}

	public function delete() {
		global $db;

		if ($this->exists() === false) {
			return self::ERROR_USER_NOTFOUND;
		}

		$table = $this->getTableName($this);
		$db->sql_query('DELETE FROM ' . $table . ' WHERE ' . $this->_primary . '=\'' . $this->{$this->_primary} . '\'');
		if ($db->sql_goterror() === true) {
			return db_data::ERROR_SQL;
		}

		return db_data::ERROR_NONE;
	}
};
?>