<?php
/***********************************************************
 *			db_alert.php
 *		    --------------------
 * Created		: Wed, Feb 1, 2006
 * Copyright		: (C) LookStrike Team
 * WebSite		: http://www.lookstrike.com
 *
 * $Id: db_alert.php,v 1.5 2007/06/18 01:31:01 jsgoupil Exp $
 *
 ***********************************************************/
include_once($sys_conf['path']['real'] . '/modules/class/db/db_data.php');

class db_alert extends db_data {
	const ERROR_ALERT_NOTFOUND	= 1;

	public $name;			// varchar(255)
	public $value;			// varchar(255)

	protected $_ERROR_LANGUAGE = array(
		self::ERROR_ALERT_NOTFOUND	=> 'ALERT_NOTFOUND'
	);

	protected $_primary = 'name';
	protected $_unique = array(
		'name'
	);
	protected $_required_admin = array(
		'name',
		'value'
	);
	protected $_required = array();
	protected $_filter = array();

	public function __construct() {
		$this->name		= '';
		$this->value		= '';
	}

	public function insert() {
		global $db;

		$error = $this->checkData(db_data::OPERATION_INSERT);
		if ($error !== db_data::ERROR_NONE) {
			return $error;
		}

		$data_insert = db_data::generateInsert('name', 'value');
		$table = $this->getTableName($this);
		$db->sql_query('INSERT INTO ' . $table . ' ' . $data_insert);
		if ($db->sql_goterror() === true) {
			return db_data::ERROR_SQL;
		}

		return db_data::ERROR_NONE;
	}

	public function modify() {
		global $db;

		if ($this->exists() === false) {
			$this->insert();
		}

		$error = $this->checkData(db_data::OPERATION_MODIFY);
		if ($error !== db_data::ERROR_NONE) {
			return $error;
		}

		$data_modify = db_data::generateModify('value');
		$table = $this->getTableName($this);
		$db->sql_query('UPDATE ' . $table . ' SET ' . $data_modify . ' WHERE name=\'' . addslashes($this->name) . '\'');
		if ($db->sql_goterror() === true) {
			return db_data::ERROR_SQL;
		}

		return db_data::ERROR_NONE;
	}

	// Useless for this table
	public function delete() {
		global $db;

		if ($this->exists() === false) {
			return self::ERROR_ALERT_NOTFOUND;
		}

		$table = $this->getTableName($this);
		$db->sql_query('DELETE FROM ' . $table . ' WHERE ' . $this->_primary . '=\'' . addslashes($this->{$this->_primary}) . '\'');
		if ($db->sql_goterror() === true) {
			return db_data::ERROR_SQL;
		}

		return db_data::ERROR_NONE;
	}
}
?>