<?php
/***********************************************************
 *			db_news.php
 *		    -------------------
 * Created		: Wed, Feb 1, 2006
 * Copyright		: (C) LookStrike Team
 * WebSite		: http://www.lookstrike.com
 *
 * $Id: db_news.php,v 1.5 2007/06/18 07:22:55 jsgoupil Exp $
 *
 ***********************************************************/
include_once($sys_conf['path']['real'] . '/modules/class/db/db_data.php');
include_once($sys_conf['path']['real'] . '/modules/class/db/CheckDB.php');

class db_news extends db_data {
	const ERROR_USER_NOTFOUND	= 1;
	const ERROR_NEWS_NOTFOUND	= 2;

	public $news_id;		// int(11)
	public $player_id;		// int(11) -> players.player_id
	public $subject;		// varchar(255)
	public $texte;			// text
	public $inserted;		// timestamp

	protected $_ERROR_LANGUAGE = array(
		self::ERROR_USER_NOTFOUND	=> 'USER_NOTFOUND',
		self::ERROR_NEWS_NOTFOUND	=> 'NEWS_NOTFOUND'
	);

	protected $_primary = 'news_id';
	protected $_unique = array();
	protected $_required_admin		= array(
		'player_id',
		'subject',
		'texte',
		'inserted'
	);
	protected $_required = array();
	protected $_filter = array();

	public function __construct() {
		$this->news_id		= 0;
		$this->player_id	= 0;
		$this->subject		= '';
		$this->texte		= '';
		$this->inserted		= date('Y-m-d H:i:s');
	}

	public function insert() {
		global $sys_conf, $db;

		$error = $this->checkData(db_data::OPERATION_INSERT);
		if ($error !== db_data::ERROR_NONE) {
			return $error;
		}

		if(CheckDB::isUser($this->player_id) === false) {
			return self::ERROR_USER_NOTFOUND;
		}

		$this->{$this->_primary} = 0;
		$table = $this->getTableName($this);
		$data_insert = db_data::generateInsert('player_id', 'subject', 'texte', array('inserted' => 'now'));
		$db->sql_query('INSERT INTO ' . $table . ' ' . $data_insert);
		if ($db->sql_goterror() === true) {
			return db_data::ERROR_SQL;
		}
		$this->{$this->_primary} = $db->sql_insertid();

		return db_data::ERROR_NONE;
	}

	public function modify() {
		global $db;

		if ($this->exists() === false) {
			return self::ERROR_NEWS_NOTFOUND;
		}

		$error = $this->checkData(db_data::OPERATION_MODIFY);
		if ($error !== db_data::ERROR_NONE) {
			return $error;
		}

		if(CheckDB::isUser($this->player_id) === false) {
			return self::ERROR_USER_NOTFOUND;
		}

		$table = $this->getTableName($this);
		$data_modify = db_data::generateModify('player_id', 'subject', 'texte', array('inserted' => 'now'));
		$db->sql_query('UPDATE ' . $table . ' SET ' . $data_modify  . ' WHERE ' . $this->_primary . '=\'' . $this->{$this->_primary} . '\'');
		if ($db->sql_goterror() === true) {
			return db_data::ERROR_SQL;
		}

		return db_data::ERROR_NONE;
	}

	public function delete() {
		global $sys_conf, $db;

		if ($this->exists() === false) {
			return self::ERROR_NEWS_NOTFOUND;
		}

		// Rule to follow before deleting a match :
		//  - No rules

		$table = $this->getTableName($this);
		$db->sql_query('DELETE FROM ' . $table . ' WHERE ' . $this->_primary . '=\'' . $this->{$this->_primary} . '\'');
		if ($db->sql_goterror() === true) {
			return db_data::ERROR_SQL;
		}

		return db_data::ERROR_NONE;
	}
};
?>