<?php
/***********************************************************
 *			Box.php
 *		    ---------------
 * Created		: Tue, Oct 19, 2004
 * Copyright		: (C) LookStrike Team
 * WebSite		: http://www.lookstrike.com
 *
 * $Id: Box.php,v 1.3 2008/01/24 16:34:30 jsgoupil Exp $
 *
 ***********************************************************/
if (!defined('IN_LS')) die('You are not allowed to access to this page.');
include_once($sys_conf['path']['real'] . '/modules/class/draw/Position.php');
include_once($sys_conf['path']['real'] . '/modules/class/draw/Dimension.php');
include_once($sys_conf['path']['real'] . '/modules/class/draw/Color.php');
include_once($sys_conf['path']['real'] . '/modules/class/draw/interface.php');

class TBox implements Drawable {
	protected $position = NULL;		// TPosition
	protected $dimension = NULL;		// TDimension
	protected $color = NULL;		// TColor (border color)
	protected $border = true;		// Boolean

	public function __construct(TPosition $position, TDimension $dimension, TColor $color) {
		$this->setPosition($position);
		$this->setDimension($dimension);
		$this->setBorderColor($color);
		$this->setBorderVisible(true);
	}

	public function setPosition(TPosition $position) {
		$this->position = $position;
	}

	public function setDimension(TDimension $dimension) {
		$this->dimension = $dimension;
	}

	public function setBorderVisible($a1) {
		$this->border = (bool)$a1;
	}

	public function setBorderColor(TColor $color) {
		$this->color = $color;
	}

	public function getPosition() {
		if ($this->position === NULL) {
			return new TPosition(0, 0);
		} else {
			return $this->position;
		}
	}

	public function getDimension() {
		if ($this->dimension === NULL) {
			return new TDimension(0, 0);
		} else {
			return $this->dimension;
		}
	}

	public function getBorderVisible() {
		return $this->border;
	}

	public function getBorderColor() {
		if ($this->color === NULL) {
			return new TColor(0, 0, 0);
		} else {
			return $this->color;
		}
	}

	public function draw($im) {
		if ($this->getBorderVisible() === true) {
			imagerectangle(
				$im,
				$this->getPosition()->getPosX(),
				$this->getPosition()->getPosY(),
				$this->getPosition()->getPosX() + $this->getDimension()->getWidth(),
				$this->getPosition()->getPosY() + $this->getDimension()->getHeight(),
				$this->getBorderColor()->allocate($im)
			);
		}
	}
};
?>