<?php
/***********************************************************
 *			DrawPool.php
 *		    --------------------
 * Created		: Tue, Oct 19, 2004
 * Copyright		: (C) LookStrike Team
 * WebSite		: http://www.lookstrike.com
 *
 * $Id: DrawPool.php,v 1.3 2008/01/24 16:34:30 jsgoupil Exp $
 *
 ***********************************************************/
if (!defined('IN_LS')) die('You are not allowed to access to this page.');
include_once($sys_conf['path']['real'] . '/modules/class/draw/DrawRule.php');

class TDrawPool extends TDrawRule {
	public function __construct() {
		parent::__construct();
	}

	/**
	 * Draws Pool
	 */
	public function draw() {
		$c = count($this->components);
		if ($c > 0) {
			/* DEFINITION GRANDEUR IMAGE */
			$temp_val = ceil(sqrt($c)); // We try to make a square display
			$pool_width = $this->countWidth($temp_val) + (($temp_val - 1) * $this->getSpace()->getWidth()) + $this->getPosition()->getPosX() + 1;
			$pool_height = $this->countHeight($temp_val) + ((ceil($c / $temp_val) - 1) * $this->getSpace()->getHeight()) + $this->getPosition()->getPosY() + 1;
			$this->im = imagecreatetruecolor($pool_width, $pool_height);

			$colorWhite = new TColor('white');
			imagefill($this->im, 0, 0, $colorWhite->allocate($this->im));

			/* AFFICHAGE DES INFORMATIONS */
			$posX = $this->getPosition()->getPosX();
			$posY = 0;
			$lastHeight = 0;
			$maxHeight = $this->getPosition()->getPosY();
			$offsetY = 0;

			for ($i = 0; $i < $c; $i++) {
				if (($i % $temp_val) === 0) {
					$posX = $this->getPosition()->getPosX();
					$posY += $maxHeight + ($this->getSpace()->getHeight() * $offsetY);
					$offsetY = 1;
					$maxHeight = 0;
				}
				$height = $this->get($i)->getMaxHeight();
				if ($height > $maxHeight) {
					$maxHeight = $height;
				}

				$this->get($i)->setPosition(new TPosition($posX, $posY));
				if($this->strBackground !== NULL) {
					$this->get($i)->getTitle()->setBackgroundImage($this->strBackground);
				}
				$this->get($i)->draw($this->im);

				$posX += $this->get($i)->getMaxWidth() + $this->getSpace()->getWidth();
			}

			/* AJOUT SUPERFICIEL */
			$this->drawTitle($this->im, $pool_width);
			$this->drawBorder($this->im, $pool_width, $pool_height);

			return $this->im;
		} else {
			return false;
		}
	}
	
	/**
	 * Counts width took by putting every matchbox in line (with $a1
	 * by line maximum)
	 */
	protected function countWidth( $a1 ) {
		$sizeMax = 0;
		$size = 0;
		$c = count($this->components);
		for ($i = 0; $i < $c; $i++) {
			if (($i % $a1) === 0) {
				if ($size > $sizeMax) {
					$sizeMax = $size;
				}
				$size = 0;
			}
			$size += $this->get($i)->getMaxWidth();
		}
		if ($size > $sizeMax) {
			$sizeMax = $size;
		}
		return $sizeMax;
	}

	/**
	 * Counts height took by putting every matchbox in column (with $a1
	 * by column maximum)
	 */
	protected function countHeight( $a1 ) {
		$size = array();
		$currentLine = -1;
		$c = count($this->components);
		for ($i = 0; $i < $c; $i++) {
			$currentLine += (($i % $a1) === 0) ? 1 : 0;
			if (!isset($size[$currentLine])) {
				$size[$currentLine] = 0;
			}

			if ($size[$currentLine] < $this->get($i)->getMaxHeight()) {
				$size[$currentLine] = $this->get($i)->getMaxHeight();
			}
		}
		return array_sum($size);
	}
};
?>