<?php
/***********************************************************
 *			DrawRule.php
 *		    --------------------
 * Created		: Tue, Oct 19, 2004
 * Copyright		: (C) LookStrike Team
 * WebSite		: http://www.lookstrike.com
 *
 * $Id: DrawRule.php,v 1.2 2008/01/24 16:34:30 jsgoupil Exp $
 *
 ***********************************************************/
if (!defined('IN_LS')) die('You are not allowed to access to this page.');
include_once($sys_conf['path']['real'] . '/modules/class/draw/DocumentGraphic.php');
include_once($sys_conf['path']['real'] . '/modules/class/draw/MatchBox.php');
include_once($sys_conf['path']['real'] . '/modules/class/draw/Winner.php');
include_once($sys_conf['path']['real'] . '/modules/class/draw/Font.php');
include_once($sys_conf['path']['real'] . '/modules/class/draw/interface.php');
include_once($sys_conf['path']['real'] . '/modules/class/db/db_players.php');
include_once($sys_conf['path']['real'] . '/modules/class/db/db_team_players.php');
include_once($sys_conf['path']['real'] . '/modules/class/db/db_teams.php');
include_once($sys_conf['path']['real'] . '/modules/class/HelperDB.php');

class TDrawRule extends TDocumentGraphic {
	protected $pRule;		// TRule
	protected $strBackground;	// String

	public function __construct() {
		parent::__construct();

		$this->pRule = NULL;
		$this->strBackground = NULL;
	}

	public function setBackground( $strBackground ) {
		$this->strBackground = $strBackground;
	}

	/**
	 * Loads a pool/tree into the class
	 */
	public function load( TRule $pRule ) {
		global $db, $sys_conf;

		$this->setRule( $pRule );

		$pTree = $this->pRule->getTree();
		$this->setTitle('Pool/Tree' . ' #' . $pTree->Get()->tree_id); # TODO

		$matches = $pTree->getMatches();
		$c1 = count($matches);
		for($i = 0; $i < $c1; $i++) {
			$match = new TMatchBox('Match' . ' #' . $matches[$i]->Get()->match_id);
			$match->setId( $matches[$i]->Get()->match_id );
			$matchTeams = $matches[$i]->getMatchTeams();
			$c2 = count($matchTeams);
			for($j = 0; $j < $c2; $j++) {
				$match->add( new TScoreBox( HelperDB::GetTeamName($matchTeams[$j]->Get()->team_id), $matchTeams[$j]->Get()->score ) );
			}
			// Fill with empty boxes
			for(; $j < 1; $j++) {
				$match->add( new TScoreBox( '', '' ) );
			}
			$this->add( $match, $matches[$i]->Get()->node );
		}
	}

	/**
	 * Sets optional ID to the graphic
	 */
	public function setId( $a1 ) {
		$this->id = (int)$a1;
	}

	/**
	 * Gets optional ID
	 */
	public function getId() {
		return $this->id;
	}

	/**
	 * Sets Winner callback
	 * It will raise with color winners and loosers
	 */
	public function setWinner( ColorMatchBox $callback ) {
		$c = count( $this->components );
		for ($i = 0; $i < $c; $i++) {
			$this->get( $i )->setWinner( $callback ); # We know that the component is a TMatchBox
		}
	}

	/**
	 * Clear Winner
	 * Clear color of texboxes
	 */
	public function unsetWinner( ColorMatchBox $callback ) {
		$c = count( $this->components );
		for ($i = 0; $i < $c; $i++) {
			$this->get( $i )->unsetWinner( $callback ); # We know that the component is a MatchBox
		}
	}

	/**
	 * Draws
	 */
	public function draw() { }

	public function setRule( TRule $pRule ) {
		$this->pRule = $pRule;
	}

	/**
	 * Draws the Title
	 */
	protected function drawTitle($im, $width) {
		if ($this->getTitle() !== '') {
			$colorBlack = new TColor(0, 0, 0);
			if($this->font instanceof TFont) {
				$this->font->setText($this->getTitle());
				$this->font->draw($this->im, $colorBlack->allocate($im), $this->font->getWidth() / 2, 5);
			} else {
				imagestring(
					$this->im,
					$this->getFont(),
					$width / 2 - (ImageFontWidth($this->getFont()) * strlen($this->getTitle())) / 2,
					5,
					$this->getTitle(),
					$colorBlack->allocate($im)
				);
			}
		}
	}

	/**
	 * Draws Border
	 */
	protected function drawBorder($im, $width, $height) {
		if ($this->getBorder()) {
			$colorBlack = new TColor(0, 0, 0);
			imagerectangle(
				$im,
				0,
				0,
				$width - 1,
				$height - 1,
				$colorBlack->allocate($im)
			);
		}
	}
};
?>