<?php
/***********************************************************
 *			ScoreBox.php
 *		    --------------------
 * Created		: Tue, Oct 19, 2004
 * Copyright		: (C) LookStrike Team
 * WebSite		: http://www.lookstrike.com
 *
 * $Id: ScoreBox.php,v 1.2 2008/01/24 16:34:30 jsgoupil Exp $
 *
 ***********************************************************/
if (!defined('IN_LS')) die('You are not allowed to access to this page.');
include_once($sys_conf['path']['real'] . '/modules/class/draw/TextBox.php');
include_once($sys_conf['path']['real'] . '/modules/class/draw/interface.php');

class TScoreBox implements Drawable {
	const DEFAULT_WIDTH_TEAM = 125;
	const DEFAULT_WIDTH_SCORE = 25;
	const DEFAULT_HEIGHT = 20;

	private $id;			// Int : Optional
	private $team;			// TextBox
	private $score;			// TextBox

	public function __construct($a1, $a2) {
		$this->setTeam($a1);
		$this->setScore($a2);
	}

	public function setId($a1) {
		$this->id = (int)$a1;
	}

	public function setTeam($a1) {
		if ($a1 instanceof TTextBox) {
			$this->team = $a1;
		} else {
			$this->team = new TTextBox($a1);
			$this->setTeamDefault($this->team);
		}
	}

	public function setScore($a1) {
		if ($a1 instanceof TTextBox) {
			$this->score = $a1;
		} else {
			$this->score = new TTextBox($a1);
			$this->setScoreDefault($this->score);
		}
	}

	public function setPosition(TPosition $a1) {
		$this->getTeam()->setPosition($a1);
		$w = $this->getTeam()->getDimension()->getWidth();
		$h = $this->getTeam()->getDimension()->getHeight();
		$this->getScore()->setPosition(new TPosition($a1->getPosX() + $w, $a1->getPosY()));
	}

	/**
	 * No getter since we set on two different controls.
	 */
	public function setBorderColor(TColor $a1) {
		$this->getTeam()->setBorderColor($a1);
		$this->getScore()->setBorderColor($a1);
	}

	public function getId() {
		return $this->id;
	}

	public function getTeam() {
		if ($this->team === NULL) {
			return new TTextBox('');
		} else {
			return $this->team;
		}
	}

	public function getScore() {
		if ($this->score === NULL) {
			return new TTextBox('');
		} else {
			return $this->score;
		}
	}

	public function getPosition() {
		return $this->getTeam()->getPosition();
	}

	public function draw($im) {
		$this->getTeam()->draw($im);
		$this->getScore()->draw($im);
	}

	private function setDefault(TTextBox $a1) {
		$a1->setBorderColor(new TColor(0, 0, 0));
		$a1->setForegroundColor(new TColor(0, 0, 0));
		$a1->setBackgroundColor(new TColor(255, 255, 255));
		$a1->setFont(2);
	}

	private function setTeamDefault(TTextBox $a1) {
		$this->setDefault($a1);
		$a1->setPosition(new TPosition(0, 0));
		$a1->setDimension(new TDimension(self::DEFAULT_WIDTH_TEAM, self::DEFAULT_HEIGHT));
	}

	private function setScoreDefault(TTextBox $a1) {
		$this->setDefault($a1);
		$a1->setPosition(new TPosition(self::DEFAULT_WIDTH_TEAM, 0));
		$a1->setDimension(new TDimension(self::DEFAULT_WIDTH_SCORE, self::DEFAULT_HEIGHT));
	}
};
?>