<?php
/***********************************************************
 *			TreeNode.php
 *		    --------------------
 * Created		: Thr, Oct 21, 2004
 * Copyright		: (C) LookStrike Team
 * WebSite		: http://www.lookstrike.com
 *
 * $Id: TreeNode.php,v 1.4 2008/02/02 01:25:30 jsgoupil Exp $
 *
 ***********************************************************/
if(!defined('IN_LS')) die('You are not allowed to access to this page.');
///include_once($sys_conf['path']['real'] . '/modules/class/draw/Server.php');

class TTreeNode {
	public $left = NULL;			// TTreeNode
	public $right = NULL;			// TTreeNode

	public function __construct() { }

	/**
	 * Finds a specific node with its number $n
	 *
	 * @param int $n
	 * @param int $number Counter
	 * @return TTreeNode
	 */
	public function findNode($n, &$number) {
		if( $number === $n ) {
			return $this;
		}
		$number++;
		if( $this->left !== NULL ) {
			$left_value = $this->left->findNode( $n, $number );
			if( $left_value !== NULL ) {
				return $left_value;
			}
		}
		if( $this->right !== NULL ) {
			$right_value = $this->right->findNode( $n, $number );
			if( $right_value !== NULL ) {
				return $right_value;
			}
		}
		return NULL;
	}

	/**
	 * Finds the number depending on the TreeNode specified in $n
	 *
	 * @param TTreeNode $n
	 * @param int $number Counter
	 * @return int
	 */
	public function findPrefix( $n, &$number ) {
		if( $this === $n ) {
			return $number;
		}
		$number++;
		if( $this->left !== NULL ) {
			$left_value = $this->left->findPrefix( $n, $number );
			if( $left_value !== 0 ) {
				return $left_value;
			}
		}
		if( $this->right !== NULL ) {
			$right_value = $this->right->findPrefix( $n, $number );
			if( $right_value !== 0 ) {
				return $right_value;
			}
		}
		return 0;
	}

	/**
	 * Finds the father of the TTreeNode $n
	 *
	 * @param TTreeNode $n
	 * @return TTreeNode
	 */
	public function findFather( $n ) {
		if( $this->left === $n || $this->right === $n ) {
			return $this;
		}

		if( $this->left !== NULL ) {
			$left_value = $this->left->findFather( $n );
			if($left_value !== NULL ) {
				return $left_value;
			}
		}
		if( $this->right !== NULL ) {
			$right_value = $this->right->findFather( $n );
			if( $right_value !== NULL ) {
				return $right_value;
			}
		}
		return NULL;
	}

	/**
	 * Finds the Node who is our immediate brother of the TTreeNode $n
	 *
	 * @param TTreeNode $n
	 * @return TTreeNode
	 */
	public function findVS($n) {
		$father = $this->findFather($n);
		if($father !== NULL && $father->left === $n) {
			return $father->right;
		} elseif($father !== NULL && $father->right === $n) {
			return $father->left;
		} else {
			return NULL;
		}
	}
};
?>