<?php
/***********************************************************
 *			MatchTeam.php
 *		    ---------------------
 * Created		: Thu, Mar 9, 2006
 * Copyright		: (C) LookStrike Team
 * WebSite		: http://www.lookstrike.com
 *
 * $Id: MatchTeam.php,v 1.1 2007/02/15 15:04:42 jsgoupil Exp $
 *
 ***********************************************************/
include_once($sys_conf['path']['real'] . '/modules/class/db/db_match_teams.php');

interface IMatchTeamListener {
}

class TMatchTeam {
	private $pMatchTeamListener;
	private $pMatchTeam;

	public function __construct( $pMatchTeamListener = NULL ) {
		$this->pMatchTeamListener = $pMatchTeamListener;
	}

	/**
	 * Loads a match Team.
	 * $pMatchTeam must be a db_match_teams
	 * Returns true on success
	 *
	 * @param mixed $pMatchTeam
	 * @return bool
	 */
	public function Load( db_match_teams $pMatchTeam ) {
		$this->pMatchTeam = $pMatchTeam;

		if( !$this->pMatchTeam->IsLoaded() ) {
			return false;
		}

		return true;
	}

	/**
	 * Throw an exception is the matchTeam is not loaded
	 */
	public function Loaded() {
		if( $this->pMatchTeam === NULL || !$this->pMatchTeam->IsLoaded() ) {
			throw new Exception('Match Team is not loaded.');
		}
	}

	/**
	 * Nothing
	 */
	public function Build() {
		$this->Loaded();
	}

	/**
	 * Returns the match Team.
	 *
	 * @return db_match_teams
	 */
	public function Get() {
		return $this->pMatchTeam;
	}

	public function _Debug( $code ) {
		$strFirst = str_repeat( '>', $code );

		echo $strFirst . 'MatchTeam.team_id = ' . $this->pMatchTeam->team_id . '<br />';
	}

	public function getMatchTeam() {
		$this->Loaded();

		return $this->pMatchTeam;
	}
};
?>