<?php
/***********************************************************
 *			RuleBuilder.php
 *		    -----------------------
 * Created		: Sat, Mar 11, 2006
 * Copyright		: (C) LookStrike Team
 * WebSite		: http://www.lookstrike.com
 *
 * $Id: RuleBuilder.php,v 1.2 2008/01/27 01:58:49 jsgoupil Exp $
 *
 ***********************************************************/
include_once($sys_conf['path']['real'] . '/modules/class/db/db_tournaments.php');
include_once($sys_conf['path']['real'] . '/modules/class/tournament/Rule.php');
include_once($sys_conf['path']['real'] . '/modules/class/tournament/RulePool.php');
include_once($sys_conf['path']['real'] . '/modules/class/tournament/RuleTree.php');
include_once($sys_conf['path']['real'] . '/modules/class/tournament/RuleSingle.php');

class TRuleBuilder {
	private $pTournament;

	public function __construct() {
	}

	/**
	 * Returns the Rule associatd with the tree.
	 * Returns false in case of error.
	 *
	 * @param int $nTreeId
	 * @return TRule
	 */
	public static function BuildRule( $nTreeId ) {
		// Rule Single Match?
		if( intval($nTreeId) === 0 ) {
			$rule = new TRuleSingle();
			$rule->Load( $nTreeId );
			return $rule;
		}

		$tree = new db_trees();
		$tree->fill( array( 'tree_id' => $nTreeId ) );

		if( !$tree->IsLoaded() ) {
			return false;
		}

		if(intval($tree->tree_type) === 0) {
			$rule = new TRulePool();
		} else {
			$rule = new TRuleTree();
		}
		$rule->Load( $nTreeId );

		return $rule;
	}
}