<?php
/***********************************************************
 *			RuleSingle.php
 *		    ----------------------
 * Created		: Sat, Jan 26, 2008
 * Copyright		: (C) LookStrike Team
 * WebSite		: http://www.lookstrike.com
 *
 * $Id: RuleSingle.php,v 1.1 2008/02/02 01:25:30 jsgoupil Exp $
 *
 ***********************************************************/
include_once($sys_conf['path']['real'] . '/modules/class/db/db_trees.php');
include_once($sys_conf['path']['real'] . '/modules/class/tournament/Rule.php');
include_once($sys_conf['path']['real'] . '/modules/class/tournament/TreeSingle.php');
include_once($sys_conf['path']['real'] . '/modules/class/draw/DrawPool.php');

class TRuleSingle extends TRule {
	/**
	 * Constructor
	 */
	public function __construct() {
		parent::__construct();
	}

	/**
	 * Creates the pool.
	 * Returns $error
	 *
	 * @param int $nTournament
	 * @param int $nPrevious
	 * @return int
	 */
	protected function _CreateRule( $nTournament, $nPrevious ) {
		$error = db_data::ERROR_NONE;

		return $error;
	}

	/**
	 * Creates the match.
	 * Returns [0]->db_matches, [1]->$error
	 *
	 * @param mixed $tournament_teams
	 * @param int $i Current Team
	 * @return mixed
	 */
	protected function _CreateMatch( $tournament_teams, $i ) {
		$match = new db_matches();
		$match->tournament_id = $this->pTree->GetTournament()->tournament_id;
		$match->tree_id = $this->pTree->Get()->tree_id;
		if( !$this->bFake ) {
			$error = $match->insert();
		} else {
			$error = db_data::ERROR_NONE;
		}

		return array( $match, $error );
	}

	/**
	 * Creates the Pool and its matches.
	 * $nPrevious is the previous tree_id
	 * Returns an array with [0]->db_data, [1]->error_number on error
	 * Or returns true on no error.
	 *
	 * @param int $nTournament
	 * @param int $nPrevious
	 * @return mixed
	 */
	public function Create( $nTournament, $nPrevious ) {
		return TRule::Create( $nTournament, $nPrevious );
	}

	/**
	 * Loads the tree.
	 * $pTree can be db_trees or an integer.
	 *
	 * @param mixed $pTree
	 * @param bool $bBuild
	 */
	public function Load( $pTree, $bBuild = true ) {
		$this->pTree = new TTreeSingle( $this, $this );
		$this->pTree->Load( $pTree );
		if( $bBuild ) {
			$this->pTree->Build( $this, $this, $this );
		}
	}

	/**
	 * Draws the pool in an image.
	 *
	 * @param string $pathToRoot
	 * @return bool
	 */
	public function draw( $pathToRoot = '.' ) {
		return true;
	}

	public function _Debug( $code ) {
		$strFirst = str_repeat( '>', $code );

		echo $strFirst . 'RuleSingle<br />';
		$this->pTree->_Debug( $code + 1 );
	}
};
?>