<?php
/***********************************************************
 *			TournamentTeam.php
 *		    --------------------------
 * Created		: Mon, Apr 17, 2006
 * Copyright		: (C) LookStrike Team
 * WebSite		: http://www.lookstrike.com
 *
 * $Id: TournamentTeam.php,v 1.1 2007/02/15 15:04:42 jsgoupil Exp $
 *
 ***********************************************************/
include_once($sys_conf['path']['real'] . '/modules/class/db/db_tournament_teams.php');

interface ITournamentTeamListener {
}

class TTournamentTeam {
	private $pTournamentTeamListener;
	private $pTournamentTeam;

	public function __construct( $pTournamentTeamListener = NULL ) {
		$this->pTournamentTeamListener = $pTournamentTeamListener;
	}

	/**
	 * Loads a tournament Team.
	 * $pTournamentTeam must be a db_tournament_teams
	 * Returns true on success
	 *
	 * @param mixed $pTournamentTeam
	 * @return bool
	 */
	public function Load( db_tournament_teams $pTournamentTeam ) {
		$this->pTournamentTeam = $pTournamentTeam;

		if( !$this->pTournamentTeam->IsLoaded() ) {
			return false;
		}

		return true;
	}

	/**
	 * Throw an exception is the tournamentTeam is not loaded
	 */
	public function Loaded() {
		if( $this->pTournamentTeam === NULL || !$this->pTournamentTeam->IsLoaded() ) {
			throw new Exception('Tournament Team is not loaded.');
		}
	}

	/**
	 * Nothing
	 */
	public function Build() {
		$this->Loaded();
	}

	/**
	 * Returns the tournament Team.
	 *
	 * @return db_tournament_teams
	 */
	public function Get() {
		return $this->pTournamentTeam;
	}

	public function _Debug( $code ) {
		$strFirst = str_repeat( '>', $code );

		echo $strFirst . 'TournamentTeam.team_id = ' . $this->pTournamentTeam->team_id . '<br />';
	}

	public function getTournamentTeam() {
		$this->Loaded();

		return $this->pTournamentTeam;
	}
};
?>