<?php
/***********************************************************
 *			TreeSingle.php
 *		    ----------------------
 * Created		: Sat, Jan 26, 2008
 * Copyright		: (C) LookStrike Team
 * WebSite		: http://www.lookstrike.com
 *
 * $Id: TreeSingle.php,v 1.1 2008/02/02 01:25:30 jsgoupil Exp $
 *
 ***********************************************************/
include_once($sys_conf['path']['real'] . '/modules/class/tournament/Tournament.php');
include_once($sys_conf['path']['real'] . '/modules/class/db/db_trees.php');

class TTreeSingle extends TTree {
	public function __construct( $pTreeListener = NULL, $pTournamentListener = NULL ) {
		parent::__construct( $pTournamentListener );
	}

	/**
	 * Loads a tree.
	 * $pTree can be a db_trees or an integer.
	 * Returns true on success
	 *
	 * @param mixed $pTree
	 * @return bool
	 */
	public function Load( $pTree ) {
		if( intval( $pTree ) !== 0 ) {
			throw new Exception('Tree not single.');
		}

		return true;
	}

	public function LoadTournament( $tournamentId ) {
		Tournament::Load( $tournamentId );
	}

	/**
	 * Throw an exception is the tree and tournament are not loaded
	 */
	public function Loaded() {
		return true;
	}

	/**
	 * Builds Matches into the class.
	 *
	 * @param IMatchtListener $pMatchListener
	 * @param ITournamentTeamListener $pTournamentTeamListener
	 * @param IMatchTeamListener $pMatchTeamListener
	 */
	public function Build( $pMatchListener = NULL, $pTournamentTeamListener = NULL, $pMatchTeamListener = NULL ) {
		$this->Loaded();

		$match = new db_matches();
		$matches = db_data::searchForClass( 'db_matches', array( 'tree_id' => 0 ), '', '', $match->getPrimary() );

		$c = count( $matches );
		for( $i = 0; $i < $c; $i++ ) {
			$oMatch = new TMatch( $pMatchListener );
			$oMatch->Load( $matches[$i] );
			$oMatch->Build();
			$this->AttachMatch( $oMatch );
		}

		// No team attached
	}

	/**
	 * Returns the tournament
	 *
	 * @return db_tournaments
	 */
	public function GetTournament() {
		return parent::Get();
	}

	public function _Debug( $code ) {
		$strFirst = str_repeat( '>', $code );

		echo $strFirst . 'Tree.id = ' . $this->pTree->tree_id . '<br />';

		parent::_Debug( $code );
	}
};
?>