<?php
/***********************************************************
 *			mysqli.php
 *		    ------------------
 * Created		: Sun, May 6, 2003
 * Copyright		: (C) LookStrike Team
 * WebSite		: http://www.lookstrike.com
 *
 * $Id: mysqli.php,v 1.5 2007/06/18 01:31:08 jsgoupil Exp $
 *
 ***********************************************************/
if(!defined('IN_LS'))die('You are not allowed to access to this page.');
// Description: mySQL4.1.2 (mySQLi)
class db {
	var $link = 0;
	var $num_queries = 0;
	var $query_result;

	function db($db_host, $db_user, $db_pass, $db_name) {
		if(constant('NO_DB') === false) {
			$this->link = @mysqli_connect($db_host, $db_user, $db_pass, $db_name);
		}
	}

	function sql_close() {
		if($this->link) {
			return mysqli_close($this->link);
		} else {
			return false;
		}
	}

	function sql_query($query) {
		if( isset($GLOBALS['DEBUG_SQL']) && intval($GLOBALS['DEBUG_SQL']) === 1 ) {
			echo $query;
		}

		unset($this->query_result);
		$this->num_queries++;
		$this->query_result = mysqli_query($this->link, $query);
		if($this->query_result) {
			return $this->query_result;
		} else {
			return false;
		}
	}

	function sql_numrows($query_id = 0) {
		if(!$query_id) {
			$query_id = $this->query_result;
		}
		return ($query_id) ? mysqli_num_rows($query_id) : false;
	}

	function sql_affected() {
		return ($this->link) ? mysqli_affected_rows($this->link) : false;
	}

	function sql_dataseek($query_id = 0, $num_row = 0) {
		if(!$query_id) {
			$query_id = $this->query_result;
		}

		if($query_id && $this->sql_numrows($query_id) >= 1) {
			return mysqli_data_seek($query_id, $num_row);
		} else {
			return false;
		}
	}

	function sql_fetchrow($query_id = 0, $special = false) {
		if(!$query_id) {
			$query_id = $this->query_result;
		}

		if($query_id) {
			$result = mysqli_fetch_array($query_id, MYSQLI_ASSOC);
			if((bool)$special === true) {
				transform_specialchars($result);
			}
			return $result;
		} else {
			return false;
		}
	}

	function sql_fetchrowset($query_id = 0, $special = false) {
		if(!$query_id) {
			$query_id = $this->query_result;
		}

		if($query_id) {
			$temp = 0;
			$result = array();
			$this->sql_dataseek($query_id, 0);
			while(($temp = mysqli_fetch_array($query_id, MYSQLI_ASSOC)) !== NULL) {
				$result[] = $temp;
			}
			if((bool)$special === true) {
				transform_specialchars($result);
			}
			$this->sql_dataseek($query_id, 0);
			return $result;
		} else {
			return false;
		}
	}

	function sql_insertid() {
		return ($this->link) ? mysqli_insert_id($this->link) : false;
	}

	function sql_listtables($db_name) {
		$tables_list = array();
		$temp_result = mysqli_query($this->link,'SHOW TABLES FROM ' . $db_name);
		while(($temp_data = mysqli_fetch_row($temp_result)) !== NULL) {
			$tables_list[] = $temp_data[0];
		}
		return $tables_list;
	}

	function sql_error() {
		$result['message'] = mysqli_error($this->link);
		$result['code'] = mysqli_errno($this->link);

		return $result;
	}

	function get_version() {
		$version_result = $this->sql_query('SELECT VERSION() AS version');
		$version_data = $this->sql_fetchrow($version_result);
		return $version_data['version'];
	}

	function sql_goterror() {
		return (mysqli_errno($this->link) === 0) ? false : true;
	}
}
?>