<?php
/***********************************************************
 *			function_local.php
 *		    --------------------------
 * Created		: Sat, Feb 28, 2004
 * Copyright		: (C) LookStrike Team
 * WebSite		: http://www.lookstrike.com
 *
 * $Id: function_local.php,v 1.9 2008/01/29 20:48:53 jsgoupil Exp $
 *
 ***********************************************************/
if(!defined('IN_LS'))die('You are not allowed to access to this page.');
include_once($sys_conf['path']['real'] . '/modules/class/db/db_tournaments.php');
include_once($sys_conf['path']['real'] . '/modules/class/db/db_match_teams.php');
include_once($sys_conf['path']['real'] . '/modules/class/db/db_teams.php');
include_once($sys_conf['path']['real'] . '/modules/class/db/db_players.php');
include_once($sys_conf['path']['real'] . '/modules/class/db/db_team_players.php');

/**
 * En fournissant le id du tournoi et du jeu
 * La fonction retourne le numro du tournoi
 * Si le tournoi n'est pas trouv, return -1.
 *
 * @param int $tournament_id
 * @param int $game_id
 * @return int
 */
function gamenumber($tournament_id, $game_id) {
	$db_tournaments = new db_tournaments();
	$tournaments = db_data::searchForClass('db_tournaments', array('game_id'=>$game_id), 'tournament_id ASC', '', $db_tournaments->getPrimary());
	$c = count($tournaments);
	for($i = 0; $i < $c; $i++) {
		if(intval($tournaments[$i]->tournament_id) === intval($tournament_id)) {
			return ++$i;
		}
	}
	return -1;
}


/**
 * En fournissant le id du match et le id de la team
 * La fonction retourne le rank de la team
 * Si le match ou la team n'est pas trouve, return -1.
 *
 * @param int $match_id
 * @param int $team_id
 * @return int
 */
function showrank($team_id, $match_id) {
	$db_match_teams = new db_match_teams();
	$matches = db_data::searchForClass('db_match_teams', array('match_id'=>$match_id), 'score DESC', '', $db_match_teams->getPrimary());
	$c = count($matches);
	for($i = 0; $i < $c; $i++) {
		if(intval($matches[$i]->team_id) === intval($team_id)) {
			return ++$i;
		}
	}
	return -1;
}

/**
 * En fournissant le id d'une quipe
 * En sortie on obtient le nom de l'quipe
 * On le nickname du joueur si l'quipe est single_user
 * 0 si la team n'existe pas
 *
 * @param int $id
 * @return string
 */
function getTeamName($id) {
	$team = new db_teams();
	$team->fill(array('team_id'=>$id));
	if(intval($team->team_id) !== 0) {
		if(intval($team->single_user) === 1) {
			$team_player = new db_team_players();
			$team_player->fill(array('team_id'=>$team->team_id));
			$player = new db_players();
			$player->fill(array('player_id'=>$team_player->player_id));
			return $player->nickname;
		} else {
			return $team->name;
		}
	} else {
		return '_';
	}
}


/**
 * En fournissant le id d'une quipe
 * En sortie on obtient le link correspondant
 * a une quipe ou un joueur
 *
 * @param int $id
 * @return string
 */
function getTeamLink($id) {
	$team = new db_teams();
	$team->fill(array('team_id'=>$id));
	if(intval($team->team_id) !== 0) {
		if(intval($team->single_user) === 1) {
			$team_player = new db_team_players();
			$team_player->fill(array('team_id'=>$team->team_id));
			return 't=player&amp;id=' . $team_player->player_id;
		} else {
			return 't=team&amp;id=' . $id;
		}
	} else {
		return '0';
	}
}


/**
 * Insre le "Commentaire" dans un tableau prdfini
 * pour les matchs.
 *
 * @param LSTable $table Tableau  modifier
 * @param int $i Index de la ligne  crire
 * @param int $colspan Index de la colonne  crire
 * @param mixed $data Valeur  crire (Commentaire)
 * @param string $lang_add Langue si le commentaire n'existe pas
 */
function dp_match_comment(&$table, $i, &$colspan, $data, $lang_add) {
	$table->addCellAttribute($i, $colspan, 'align', 'center');
	if($data === NULL || $data === '') {
		$table->setText($i, $colspan, $lang_add);
	} else {
		$table->setText($i, $colspan, $data);
	}
	$colspan++;
}


/**
 * Insre le "Serveur" dans un tableau prdfini
 * pour les matchs.
 *
 * @param LSTable $table Tableau  modifier
 * @param int $i Index de la ligne  crire
 * @param int $colspan Index de la colonne  crire
 * @param mixed $data Valeur  crire (IP+Port)
 * @param mixed $data2 Valeur  crire (Password)
 * @param string $lang_add1 Langue si le serveur n'existe pas
 * @param string $lang_add2 Langue password
 * @param string $lang_add3 Langue si le password n'existe pas
 */
function dp_match_server(&$table, $i, &$colspan, $data, $data2, $lang_add1, $lang_add2, $lang_add3) {
	$table->addCellAttribute($i, $colspan, 'align', 'center');
	if($data === NULL || $data === '') {
		$table->setText($i, $colspan, $lang_add1);
	} else {
		if($data2 === '') {
			$data2 = '<i>' . $lang_add3 . '</i>';
		}
		$table->setText($i, $colspan, decode_ip($data) . ' <font class="littletext">(' . $lang_add2 . ' : <u>' . $data2 . '</u>)</font>');
	}
	$colspan++;
}
?>