<?php
/***********************************************************
 *			info.php
 *		    ----------------
 * Created		: Sat, Apr 18, 2004
 * Copyright		: (C) LookStrike Team
 * WebSite		: http://www.lookstrike.com
 *
 * $Id: info.php,v 1.6 2008/02/02 20:07:41 jsgoupil Exp $
 *
 ***********************************************************/
define('IN_LS', true);

// Si il manque des informations
if(!isset($_GET['t']) || !isset($_GET['id'])) {
	header('Location: ../index.php');
	exit;
}

include('../modules/header.php');
include_once('../modules/class/db/db_team_players.php');
include_once('../modules/class/db/db_teams.php');
include_once('../modules/class/db/db_players.php');

if($_GET['t'] === 'match') {
	$tourn_result = $db->sql_query('SELECT a.tournament_id,a.start_time,a.end_time,b.game_id,b.single_user,c.name,a.comment,IF(a.server_id IS NULL, NULL, CONCAT(d.ip,\':\',d.port)) AS server_ip FROM ' . $sys_conf['db']['table_prefix'] . 'tournaments b, ' . $sys_conf['db']['table_prefix'] . 'games c JOIN ' . $sys_conf['db']['table_prefix'] . 'matches a LEFT JOIN ' . $sys_conf['db']['table_prefix'] . 'server_ip d ON a.server_id=d.server_id WHERE a.match_id=\'' . $_GET['id'] . '\' AND a.tournament_id=b.tournament_id AND b.game_id=c.game_id');
	$tourn_line = $db->sql_numrows($tourn_result);
	if($tourn_line === 1) {
		$tourn_data = $db->sql_fetchrow($tourn_result);
		$match_result = $db->sql_query('SELECT b.team_id,b.name,a.score FROM ' . $sys_conf['db']['table_prefix'] . 'match_teams a, ' . $sys_conf['db']['table_prefix'] . 'teams b WHERE a.match_id=\'' . $_GET['id'] . '\' AND a.team_id=b.team_id ORDER BY a.score DESC');
		$match_line = $db->sql_numrows($match_result);
		$match_data = $db->sql_fetchrowset($match_result);

		if($tourn_data['end_time'] === '' || $tourn_data['end_time']<=$tourn_data['start_time']) {
			$time_display = $language['info_notplayed'];
		} else {
			$second_time = transform_timestamp($tourn_data['end_time'], 'U') - transform_timestamp($tourn_data['start_time'], 'U');
			$hour_time = intval($second_time / 3600);
			$second_time -= ($hour_time * 3600);
			$minute_time = intval($second_time / 60);
			$second_time -= ($minute_time * 60);
			$time_display = str_pad($hour_time, 2, '0', STR_PAD_LEFT) . ':' . str_pad($minute_time, 2, '0', STR_PAD_LEFT) . ':' . str_pad($second_time, 2, '0', STR_PAD_LEFT);
		}

		$table = new LSTable(3, 2, '60%', $null);
		$table->setTitle($language['common_match'] . ' #' . $_GET['id']);
		$table->addCellAttribute(0, 0, 'width', '50%');
		$table->setText(0, 0, $language['info_tournament']);
		$table->setText(0, 1, $tourn_data['name'] . ' #' . gamenumber($tourn_data['tournament_id'], $tourn_data['game_id']));
		$table->setText(1, 0, $language['info_duration']);
		$table->setText(1, 1, $time_display);
		$table->setText(2, 0, $language['common_server']);
		if($tourn_data['server_ip'] !== NULL) {
			$table->setText(2, 1, decode_ip($tourn_data['server_ip']));
		} else {
			$table->setText(2, 1, $language['common_noserver']);
		}
		$table->draw();

		if(isset($_GET['team'])) {
			$my_team = intval($_GET['team']);
		} else {
			$my_team = NULL;
		}

		next_color(1);
		next_color();
		echo '<br />';
		$table = new LSTable($match_line + 1, 2, '60%', $null);
		$table->addRowAttribute(0, 'class', 'table_title');
		$table->addCellAttribute(0, 0, 'align', 'center');
		$table->addCellAttribute(0, 1, 'align', 'center');
		$table->addCellAttribute(0, 1, 'width', '40');
		$table->setText(0, 1, '<b>' . $language['info_score'] . '</b>');

		if(intval($tourn_data['single_user']) === 1) {
			$table->setTitle($language['info_playermatch']);
			$table->setText(0, 0, '<b>' . $language['info_player'] . '</b>');
		} else {
			$table->setTitle($language['info_teammatch']);
			$table->setText(0, 0, '<b>' . $language['info_team'] . '</b>');
		}
		for($i = 0; $i < $match_line; $i++) {
			$text2display = '';
			$bIsMyTeam = ($my_team === intval($match_data[$i]['team_id']));
			if($bIsMyTeam) $text2display .= '<b>';
			$text2display .= ($i + 1) . '. <a href="info.php?' . getTeamLink($match_data[$i]['team_id']) . '">' . getTeamName($match_data[$i]['team_id']) . '</a>';
			if($bIsMyTeam) $text2display .= '</b>';
			$table->setText($i + 1, 0, $text2display);
			$table->addCellAttribute($i + 1, 1, 'align', 'center');
			$text2display = '';
			if($bIsMyTeam) $text2display .= '<b>';
			$text2display .= $match_data[$i]['score'];
			if($bIsMyTeam) $text2display .= '</b>';
			$table->setText($i + 1, 1, $text2display);
		}
		$table->draw();
		echo '<p><a class="blacktext" href="javascript:history.back(1);"><img src="../images/arrow2_left.gif" width="23" height="11" border="0" alt="&lt;" />' . $language['common_back'] . '</a></p>';
	} else {
		$dobject = display_error($language['info_nomatch']);
		$dobject->draw();
	}
}
elseif($_GET['t'] === 'team') {
	$team = new db_teams();
	$team->fill(array('team_id'=>$_GET['id']));
	if(intval($team->team_id) !== 0) {
		// if we have a single user we move to player
		if(intval($team->single_user) === 1) {
			// Search db_team_players
			$team_player = new db_team_players();
			$team_player->fill(array('team_id'=>$team->team_id));
			header('Location: info.php?t=player&id=' . $team_player->player_id);
			exit;
		}

		$db_team_players = new db_team_players();
		$team_players = db_data::searchForClass('db_team_players', array('team_id'=>$team->team_id), '', '', $db_team_players->getPrimary());
		$c = count($team_players);

		$table = new LSTable(2, 2, '60%', $null);
		$table->setTitle($language['info_team'] . ' #' . $_GET['id']);
		$table->addCellAttribute(0, 0, 'width', '50%');
		$table->setText(0, 0, $language['info_teamname']);
		$table->setText(0, 1, $team->name);
		$table->setText(1, 0, $language['info_subscribed']);
		$table->setText(1, 1, transform_timestamp($team->subscribed));
		$table->draw();

		echo '<br />';
		$table = new LSTable($c, 2, '60%', $null);
		$table->setTitle($language['info_teammember']);
		for($i = 0; $i < $c; $i++) {
			$player = new db_players();
			$player->fill(array('player_id'=>$team_players[$i]->player_id));

			$table->addCellAttribute($i, 0, 'width', '70%');
			$table->setText($i, 0, '<a href="?t=player&amp;id=' . $player->player_id . '">' . $player->nickname . '</a>');
			$table->addCellAttribute($i, 1, 'align', 'center');
			$table->setText($i, 1, $language['info_level'][$team_players[$i]->level]);
		}
		if($c === 0) {
			$table->setNumCols(1);
			$table->insertRows(0, 1);
			$table->addCellAttribute(0, 0, 'align', 'center');
			$table->setText(0, 0, $language['info_noplayerinteam']);
		}
		$table->draw();

		next_color(1);
		next_color();
		$last_tournament = 0;
		$sql = '(SELECT a.tournament_id,b.match_id,b.score,a.end_time,a.start_time,d.name,d.game_id FROM ' . $sys_conf['db']['table_prefix'] . 'matches a, ' . $sys_conf['db']['table_prefix'] . 'match_teams b, ' . $sys_conf['db']['table_prefix'] . 'tournaments c, ' . $sys_conf['db']['table_prefix'] . 'games d WHERE a.match_id=b.match_id AND b.team_id=\'' . $_GET['id'] . '\' AND a.tournament_id=c.tournament_id AND c.game_id=d.game_id AND (a.end_time IS NULL OR a.end_time<=a.start_time) ORDER BY a.tournament_id DESC)';
		$sql .= ' UNION ';
		$sql .= '(SELECT a.tournament_id,b.match_id,b.score,a.end_time,a.start_time,d.name,d.game_id FROM ' . $sys_conf['db']['table_prefix'] . 'matches a, ' . $sys_conf['db']['table_prefix'] . 'match_teams b, ' . $sys_conf['db']['table_prefix'] . 'tournaments c, ' . $sys_conf['db']['table_prefix'] . 'games d WHERE a.match_id=b.match_id AND b.team_id=\'' . $_GET['id'] . '\' AND a.tournament_id=c.tournament_id AND c.game_id=d.game_id AND (a.end_time IS NOT NULL OR a.end_time>a.start_time) ORDER BY a.tournament_id DESC, a.end_time DESC)';
		$match_result = $db->sql_query($sql);
		$match_line = $db->sql_numrows($match_result);
		$match_data = $db->sql_fetchrowset($match_result);
		echo '<br />';
		$table = new LSTable($match_line, 3, '60%', $null);
		$table->setTitle($language['info_teammatch']);
		$display_comment = false; // Var for display_match.php
		$display_server = false; // Var for display_match.php
		$line_added = 0;
		for($i = 0; $i < $match_line; $i++) {
			if($last_tournament !== intval($match_data[$i]['tournament_id'])) {
				$table->addRowAttribute($i + $line_added, 'class', 'table_title');
				$table->addCellAttribute($i + $line_added, 0, 'align', 'center');
				$table->addCellAttribute($i + $line_added, 0, 'colspan', '3');
				$table->setText($i + $line_added, 0, '<b>' . $language['info_tournament'] . ' <a href="../site/tournament.php?id=' . $match_data[$i]['tournament_id'] . '">' . $match_data[$i]['name'] . ' #' . gamenumber($match_data[$i]['tournament_id'], $match_data[$i]['game_id']) . '</a></b>');
				$line_added++;
				$table->insertRows($i + $line_added, 1);
			}
			include('../modules/display_match.php');
			$last_tournament = intval($match_data[$i]['tournament_id']);
		}
		if($match_line === 0) {
			$table->setNumCols(1);
			$table->insertRows(0, 1);
			$table->addCellAttribute(0, 0, 'align', 'center');
			$table->setText(0, 0, $language['info_nomatchp']);
		}
		$table->draw();
		echo '<p><a class="blacktext" href="javascript:history.back(1);"><img src="../images/arrow2_left.gif" width="23" height="11" border="0" alt="&lt;" />' . $language['common_back'] . '</a></p>';
	} else{
		$dobject = display_error($language['info_noteam']);
		$dobject->draw();
	}
} else {
	$player = new db_players();
	$player->fill(array('player_id'=>$_GET['id']));
	if(intval($player->player_id) !== 0) {
		$table = new LSTable(2, 2, '60%', $null);
		$table->setTitle($language['info_player'] . ' #' . $_GET['id']);
		$table->addCellAttribute(0, 0, 'width', '50%');
		$table->setText(0, 0, $language['common_login']);
		$table->setText(0, 1, $player->login);
		$table->setText(1, 0, $language['common_nickname']);
		$table->setText(1, 1, $player->nickname);
		$table->draw();

		next_color(1);
		next_color();
		$db_team_players = new db_team_players();
		$team_players = db_data::searchForClass('db_team_players', array('player_id'=>$_GET['id']), '', '', $db_team_players->getPrimary());
		$c = count($team_players);

		$single_user_line = 0;
		echo '<br />';
		$table = new LSTable($c, 2, '60%', $null);
		$table->setTitle($language['info_playerteam']);
		for($i = 0; $i < $c; $i++) {
			$team = new db_teams();
			$team->fill(array('team_id'=>$team_players[$i]->team_id));

			if(intval($team->single_user) === 1) {
				// We don't display it
				$single_user_line += 1;
				continue;
			}

			$table->addCellAttribute($i - $single_user_line, 0, 'width', '70%');
			$table->setText($i - $single_user_line, 0, '<a href="?t=team&amp;id=' . $team->team_id . '">' . $team->name . '</a>');
			$table->addCellAttribute($i - $single_user_line, 1, 'align', 'center');
			$table->setText($i - $single_user_line, 1, $language['info_level'][$team_players[$i]->level]);
		}
		if(($c - $single_user_line) === 0) {
			$single_user_line = 0;
			$table->setNumCols(1);
			$table->insertRows(0, 1);
			$table->addCellAttribute(0, 0, 'align', 'center');
			$table->setText(0, 0, $language['info_teamnfound']);
		}
		$table->setNumRows($c - $single_user_line); 
		$table->draw();

		next_color(1);
		next_color();
		$last_tournament = 0;
		$sql =  '(SELECT a.tournament_id,b.match_id,b.score,a.end_time,a.start_time,d.name,d.game_id FROM ' . $sys_conf['db']['table_prefix'] . 'matches a, ' . $sys_conf['db']['table_prefix'] . 'match_teams b, ' . $sys_conf['db']['table_prefix'] . 'tournaments c, ' . $sys_conf['db']['table_prefix'] . 'games d, ' . $sys_conf['db']['table_prefix'] . 'team_players e, ' . $sys_conf['db']['table_prefix'] . 'teams f';
		$sql .= ' WHERE a.match_id=b.match_id AND a.tournament_id=c.tournament_id AND c.game_id=d.game_id AND b.team_id=e.team_id AND e.team_id=f.team_id AND e.player_id=\'' . $_GET['id'] . '\' AND f.single_user=\'1\' AND (a.end_time IS NULL OR a.end_time<=a.start_time) ORDER BY a.tournament_id DESC)';
		$sql .= ' UNION';
		$sql .= '(SELECT a.tournament_id,b.match_id,b.score,a.end_time,a.start_time,d.name,d.game_id FROM ' . $sys_conf['db']['table_prefix'] . 'matches a, ' . $sys_conf['db']['table_prefix'] . 'match_teams b, ' . $sys_conf['db']['table_prefix'] . 'tournaments c, ' . $sys_conf['db']['table_prefix'] . 'games d, ' . $sys_conf['db']['table_prefix'] . 'team_players e, ' . $sys_conf['db']['table_prefix'] . 'teams f';
		$sql .= ' WHERE a.match_id=b.match_id AND a.tournament_id=c.tournament_id AND c.game_id=d.game_id AND b.team_id=e.team_id AND e.team_id=f.team_id AND e.player_id=\'' . $_GET['id'] . '\' AND f.single_user=\'1\' AND (a.end_time IS NOT NULL OR a.end_time>a.start_time) ORDER BY a.tournament_id DESC, a.end_time DESC)';
		$match_result = $db->sql_query($sql);
		$match_line = $db->sql_numrows($match_result);
		$match_data = $db->sql_fetchrowset($match_result);

		// On replace le id pour celui de la team en single pour compatibilit avec le fichier display_match
		$temp_result = $db->sql_query('SELECT a.team_id FROM ' . $sys_conf['db']['table_prefix'] . 'team_players a, ' . $sys_conf['db']['table_prefix'] . 'teams b WHERE a.team_id=b.team_id AND a.player_id=\'' . $_GET['id'] . '\' AND b.single_user=\'1\'');
		$temp_data = $db->sql_fetchrow($temp_result);
		$_GET['id'] = $temp_data['team_id'];

		echo '<br />';
		$table = new LSTable($match_line, 3, '60%', $null);
		$table->setTitle($language['info_playermatch']);
		$display_comment = false; // Var for display_match.php
		$display_server = false; // Var for display_match.php
		$line_added = 0;
		for($i = 0; $i < $match_line; $i++) {
			if($last_tournament !== intval($match_data[$i]['tournament_id'])) {
				$table->addRowAttribute($i + $line_added, 'class', 'table_title');
				$table->addCellAttribute($i + $line_added, 0, 'align', 'center');
				$table->addCellAttribute($i + $line_added, 0, 'colspan', '3');
				$table->setText($i + $line_added, 0, '<b>' . $language['info_tournament'] . ' <a href="../site/tournament.php?id=' . $match_data[$i]['tournament_id'] . '">' . $match_data[$i]['name'] . ' #' . gamenumber($match_data[$i]['tournament_id'], $match_data[$i]['game_id']) . '</a></b>');
				$line_added++;
				$table->insertRows($i + $line_added, 1);
			}
			include('../modules/display_match.php');
			$last_tournament = intval($match_data[$i]['tournament_id']);
		}
		if($match_line === 0) {
			$table->setNumCols(1);
			$table->insertRows(0, 1);
			$table->addCellAttribute(0, 0, 'align', 'center');
			$table->setText(0, 0, $language['info_nomatchp']);
		}
		$table->draw();
		echo '<p><a class="blacktext" href="javascript:history.back(1);"><img src="../images/arrow2_left.gif" width="23" height="11" border="0" alt="&lt" />' . $language['common_back'] . '</a></p>';
	} else {
		$dobject = display_error($language['info_noplayer']);
		$dobject->draw();
	}
}

include('../modules/footer.php');
?>