<?php
/***********************************************************
 *			tournament.php
 *		    ----------------------
 * Created		: Wed, Mar 03, 2004
 * Copyright		: (C) LookStrike Team
 * WebSite		: http://www.lookstrike.com
 *
 * $Id: tournament.php,v 1.7 2008/02/03 21:08:23 jsgoupil Exp $
 *
 ***********************************************************/
define('IN_LS', true);
include('../modules/header.php');
include_once('../modules/class/db/db_tournaments.php');
include_once('../modules/class/db/db_games.php');

function order_by_score($a, $b) {
	if($a['won'] === $b['won']) {
		if($a['tie'] === $b['tie']) {
			if($a['lost'] === $b['lost']) {
				return 0;
			} elseif($a['lost'] > $b['lost']) {
				return 1;
			} else {
				return -1;
			}
		} elseif($a['tie'] > $b['tie']) {
			return -1;
		} else {
			return 1;
		}
	} elseif($a['won'] > $b['won']) {
		return -1;
	} else {
		return 1;
	}
}

if(isset($_GET['id'])) {
	$tournament = new db_tournaments();
	$tournament->fill(array('tournament_id'=>$_GET['id']));
	if(intval($tournament->tournament_id) !== 0) {
		$game = new db_games();
		$game->fill(array('game_id'=>$tournament->game_id));

		if(intval($tournament->minimal_player) === 0 && intval($tournament->single_user) === 1) {
			$tournament_player = $language['tournament_noteam'];
		} elseif(intval($tournament->minimal_player) === 0) {
			$tournament_player = $language['tournament_nolimit'];
		} else {
			$tournament_player = $language['tournament_teamof'] . $tournament->minimal_player;
		}
		$table = new LSTable(7, 2, '80%', $null);
		$table->setTitle($language['tournament_info']);
		$table->setText(0, 0, $language['tournament_name']);
		$table->setText(0, 1, $game->name . ' #' . gamenumber($tournament->tournament_id, $tournament->game_id));
		$table->setText(1, 0, $language['tournament_gamename']);
		$table->setText(1, 1, '<a href="game.php?id=' . $game->game_id . '">' . $game->name . '</a>');
		$table->setText(2, 0, $language['common_description']);
		$table->setText(2, 1, nl2br($tournament->description));
		$table->setText(3, 0, $language['tournament_price']);
		$table->setText(3, 1, $tournament->price . ' $');
		$table->setText(4, 0, $language['tournament_type']);
		$table->setText(4, 1, $tournament_player);
		$table->setText(5, 0, $language['tournament_status']);
		$table->setText(5, 1, $language['tournament_statust'][$tournament->status]);
		$table->setText(6, 0, $language['tournament_inserted']);
		$table->setText(6, 1, transform_timestamp($tournament->inserted));
		$table->draw();
		echo '<p align="center"><font class="blacktext">' . $language['tournament_tosubscribe'] . '</font></p>';

		$db_match_teams = new db_match_teams();
		$db_tournament_teams = new db_tournament_teams();
		$teams = db_data::searchForClass('db_tournament_teams', array('tournament_id'=>$_GET['id']), '', '', $db_tournament_teams->getPrimary());
		$c = count($teams);
		$team_table = array();
		for($i = 0; $i < $c; $i++) {
			$team_table[$teams[$i]->team_id] = array('won'=>0, 'lost'=>0, 'tie'=>0);
		}
		// Get the matches
		$db_matches = new db_matches();
		$matches = db_data::searchForClass('db_matches', array('AND'=>array('tournament_id'=>$_GET['id'], '!end_time'=>'0000-00-00 00:00:00')), '', '', $db_matches->getPrimary());
		$c = count($matches);
		for($i = 0; $i < $c; $i++) {
			$scores = db_data::searchForClass('db_match_teams', array('match_id'=>$matches[$i]->match_id), 'score DESC', '', $db_match_teams->getPrimary());
			$c2 = count($scores);
			if($c2 > 1) {
				// Is the score all equals?
				$tie = true;
				$checkScore = $scores[0]->score;
				for($j = 1; $j < $c2; $j++) {
					if($checkScore != $scores[$j]->score) {
						$tie = false;
					}
				}

				if($tie === true) {
					for($j = 0; $j < $c2; $j++) {
						$team_table[$scores[$j]->team_id]['tie']++;
					}
				} else {
					// One winner, all losers :)
					$team_table[$scores[0]->team_id]['won']++;
					for($j = 1; $j < $c2; $j++) {
						$team_table[$scores[$j]->team_id]['lost']++;
					}
				}
			}
		}
		uasort($team_table, 'order_by_score');

		next_color(1);
		next_color();
		echo '<br />';
		$table = new LSTable(((count($team_table) === 0) ? 1 : count($team_table) + 1), 1, '60%', $null);
		$table->setTitle($language['tournament_rank']);
		$table->addCellAttribute(0, 0, 'align', 'center');
		$starting_count = 0;
		$other_count = 0;
		$nrow = 1;
		$lastscore = array('won'=>NULL, 'tie'=>NULL, 'lost'=>NULL);
		while (list($key, $val) = each($team_table)) {
			if($val['won'] !== $lastscore['won'] || $val['tie'] !== $lastscore['tie'] || $val['lost'] !== $lastscore['lost']) {
				$starting_count += $other_count + 1;
				$other_count=0;
			} else {
				$other_count++;
			}
			$lastscore = $val;
			$table->setText($nrow, 0, $starting_count . '. <a href="info.php?' . getTeamLink($key) . '">' . getTeamNamE($key) . '</a> <font class="littletext">(' . $val['won'] . ':' . $val['tie'] . ':' . $val['lost'] . ')</font>');
			$nrow++;
		}
		if(count($team_table) === 0) {
			$table->addCellAttribute(0, 0, 'align', 'center');
			$table->addCellAttribute(0, 0, 'colspan', '2');
			$table->setText(0, 0, $language['tournament_noteam']);
		} else {
			$table->addRowAttribute(0, 'class', 'table_title');
			$table->setText(0, 0, '<b>' . $language['tournament_teamname'] . ' <font class="littletext">' . $language['tournament_codescore'] . '</font></b>');
		}
		$table->draw();

		$db_trees = new db_trees();
		$trees = db_data::searchForClass('db_trees', array('tournament_id'=>$_GET['id']), 'tree_id DESC', '', $db_trees->getPrimary());
		$c = count($trees);
		if($c >= 1) {
			next_color(1);
			next_color();
			echo '<br />';
			$table = new LSTable($c, 1, '60%', $null);
			$table->setTitle($language['tournament_pooltree']);
			for($i = 0; $i < $c; $i++) {
				$text2send = (intval($trees[$i]->tree_type) === 0) ? $language['common_pool'] : $language['common_tree'];
				$table->setText($i, 0, '<a href="javascript:;" onclick="window.open(\'../site/picture.php?to=/generated/' . $trees[$i]->tree_id . '.png&amp;page=1\',\'search_mini\',\'toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=400,height=350,left=35,top=35\')">' . $text2send . ' #' . $trees[$i]->tree_id . '</a>');
			}
			$table->draw();
		}

		next_color(1);
		next_color();
		$sql =  '(SELECT a.match_id,b.team_id,b.score,a.end_time,a.start_time,c.name,c.single_user,a.comment FROM ' . $sys_conf['db']['table_prefix'] . 'matches a, ' . $sys_conf['db']['table_prefix'] . 'match_teams b, ' . $sys_conf['db']['table_prefix'] . 'teams c WHERE a.match_id=b.match_id AND a.tournament_id=\'' . $_GET['id'] . '\' AND b.team_id=c.team_id AND (a.end_time IS NULL OR a.end_time<=a.start_time) ORDER BY a.match_id DESC) ';
		$sql .= 'UNION ';
		$sql .= '(SELECT a.match_id,b.team_id,b.score,a.end_time,a.start_time,c.name,c.single_user,a.comment FROM ' . $sys_conf['db']['table_prefix'] . 'matches a, ' . $sys_conf['db']['table_prefix'] . 'match_teams b, ' . $sys_conf['db']['table_prefix'] . 'teams c WHERE a.match_id=b.match_id AND a.tournament_id=\'' . $_GET['id'] . '\' AND b.team_id=c.team_id AND (a.end_time IS NOT NULL OR a.end_time>a.start_time) ORDER BY a.end_time DESC, a.match_id ASC)';
		$match_result = $db->sql_query($sql);
		$match_line = $db->sql_numrows($match_result);
		$match_data = $db->sql_fetchrowset($match_result);

		echo '<br />';
		$table = new LSTable($match_line + 1, 5, '100%', $null);
		$table->setTitle($language['tournament_matches']);

		if($match_line === 0) {
			$table->addCellAttribute(0, 0, 'align', 'center');
			$table->addCellAttribute(0, 0, 'colspan', '5');
			$table->setText(0,0,$language['tournament_nomatchp']);
		} else {
			$table->addRowAttribute(0, 'class', 'table_title');
			$table->addCellAttribute(0, 0, 'align', 'center');
			$table->addCellAttribute(0, 0, 'colspan', '2');
			$table->addCellAttribute(0, 0, 'width', '60%');
			$table->setText(0, 0, '<b>' . $language['tournament_teams'] . '</b>');
			$table->addCellAttribute(0, 2, 'align', 'center');
			$table->addCellAttribute(0, 2, 'width', '24%');
			$table->setText(0, 2, '<b>' . $language['common_comment'] . '</b>');
			$table->addCellAttribute(0, 3, 'align', 'center');
			$table->addCellAttribute(0, 3, 'colspan', '2');
			$table->addCellAttribute(0, 3, 'width', '16%');
			$table->setText(0, 3, '<b>' . $language['tournament_scores'] . '</b>');
		}

		for($i = 0, $nrow = 1; $i < $match_line; $i++, $nrow++) {
			$match_teams = db_data::searchForClass('db_match_teams', array('match_id'=>$match_data[$i]['match_id']), '', '', $db_match_teams->getPrimary());
			$c = count($match_teams);
			if($c === 2) {	// 1 vs 1
				if(intval($match_data[$i]['score']) > intval($match_data[$i + 1]['score'])) {
					$link_color1 = $sys_conf['color']['won'];
					$link_color2 = $sys_conf['color']['lost'];
				} elseif(intval($match_data[$i]['score']) < intval($match_data[$i + 1]['score'])) {
					$link_color1 = $sys_conf['color']['lost'];
					$link_color2 = $sys_conf['color']['won'];
				} else {
					$link_color1 = $sys_conf['color']['tie'];
					$link_color2 = $sys_conf['color']['tie'];
				}
				$table->addCellAttribute($nrow, 0, 'width', '30%');
				$table->setText($nrow, 0, '<a href="info.php?' . getTeamLink($match_data[$i]['team_id']) . '" style="color:' . $link_color1 . '">' . getTeamName($match_data[$i]['team_id']) . '</a>');
				$table->setText($nrow, 1, '<a href="info.php?' . getTeamLink($match_data[$i + 1]['team_id']) . '" style="color:' . $link_color2 . '">' . getTeamName($match_data[$i + 1]['team_id']) . '</a>');
				$table->addCellAttribute($nrow, 2, 'align', 'center');
				$text2display = '';
				if($match_data[$i]['comment'] === NULL || $match_data[$i]['comment'] === '') {
					$text2display .= $language['common_nocomment'];
				} else {
					$text2display .= $match_data[$i]['comment'];
				}
				$table->setText($nrow, 2, $text2display);
				if(transform_timestamp($match_data[$i]['end_time'], 'U') <= transform_timestamp($match_data[$i]['start_time'], 'U')) {
					$table->addCellAttribute($nrow, 3, 'align', 'center');
					$table->addCellAttribute($nrow, 3, 'colspan', '2');
					$table->addCellAttribute($nrow, 3, 'width', '16%');
					$table->setText($nrow, 3, $language['common_notplayed']);
				} else {
					$table->addCellAttribute($nrow, 3, 'align', 'center');
					$table->addCellAttribute($nrow, 3, 'width', '8%');
					$table->setText($nrow, 3, $match_data[$i]['score']);
					$table->addCellAttribute($nrow, 4, 'align', 'center');
					$table->setText($nrow, 4, $match_data[$i+1]['score']);;
				}
			} elseif($c === 1) {	// Auto Win accorde
				$table->addCellAttribute($nrow, 0, 'colspan', '3');
				$table->setText($nrow, 0, $language['common_autowin'] . ' - <a href="info.php?' . getTeamLink($match_data[$i]['team_id']) . '">' . getTeamName($match_data[$i]['team_id']) . '</a>');
				$table->addCellAttribute($nrow, 1, 'align', 'center');
				$table->addCellAttribute($nrow, 1, 'colspan', '2');
				$table->setText($nrow, 1, '---');
			} else {			// MultiTeam
				if(transform_timestamp($match_data[$i]['end_time'], 'U') <= transform_timestamp($match_data[$i]['start_time'], 'U')) {
					$score = $language['common_notplayed'];
				} else {
					$score = '---';
				}
				$table->addCellAttribute($nrow, 0, 'colspan', '2');
				$table->setText($nrow, 0, '<a href="info.php?t=match&amp;id=' . $match_data[$i]['match_id'] . '&amp;team=' . $_GET['id'] . '">' . $language['common_match'] . ' #' . $match_data[$i]['match_id'] . ' - ' . $language['common_multiteam'] . '</a>');
				$table->addCellAttribute($nrow, 1, 'align', 'center');
				if($match_data[$i]['comment'] === NULL || $match_data[$i]['comment'] === '') {
					$table->setText($nrow, 1, $language['common_nocomment']);
				} else {
					$table->setText($nrow, 1, $match_data[$i]['comment']);
				}
				$table->addCellAttribute($nrow, 2, 'align', 'center');
				$table->addCellAttribute($nrow, 2, 'colspan', '2');
				$table->setText($nrow, 2, $score);
			}
			$i += ($c - 1);
		}
		$table->setNumRows($nrow);
		$table->draw();

		echo '<p><a class="blacktext" href="' . $_SERVER['PHP_SELF'] . '"><img src="../images/arrow2_left.gif" width="23" height="11" border="0" alt="&lt;" />' . $language['common_back'] . '</a></p>';
	} else {
		$dobject = display_error($language['tournament_notourn'], $_SERVER['PHP_SELF']);
		$dobject->draw();
	}
} else{
	for($i = 0; $i <= 2; $i++) {
		// On remet les couleurs  0
		next_color(1);
		next_color();
		$db_tournaments = new db_tournaments();
		$tournaments = db_data::searchForClass('db_tournaments', array('status'=>$i), '', '', $db_tournaments->getPrimary());
		$c = count($tournaments);

		$table = new LSTable((($c === 0) ? 1 : $c + 1), 3, '100%', $null);
		$table->setTitle($language['tournament_statusts'][$i]);
		if($c === 0) {
			$table->addCellAttribute(0, 0, 'align', 'center');
			$table->addCellAttribute(0, 0, 'colspan', '3');
			$table->setText(0, 0, $language['tournament_notournament']);
		} else {
			$table->addRowAttribute(0, 'class', 'table_title');
			$table->addCellAttribute(0, 0, 'align', 'center');
			$table->setText(0, 0, '<b>' . $language['tournament_name'] . '</b>');
			$table->addCellAttribute(0, 1, 'align', 'center');
			$table->setText(0, 1, '<b>' . $language['tournament_gamename'] . '</b>');
			$table->addCellAttribute(0, 2, 'align', 'center');
			$table->setText(0, 2, '<b>' . $language['tournament_type'] . '</b>');
			for($j = 0; $j < $c; $j++) {
				$game = new db_games();
				$game->fill(array('game_id'=>$tournaments[$j]->game_id));

				if(intval($tournaments[$j]->minimal_player) === 0 && intval($tournaments[$j]->single_user) === 1) {
					$tournament_player = $language['tournament_noteam'];
				} elseif(intval($tournaments[$j]->minimal_player) === 0) {
					$tournament_player = $language['tournament_nolimit'];
				} else {
					$tournament_player = $language['tournament_teamof'] . $tournaments[$j]->minimal_player;
				}
				$table->setText($j + 1, 0, '<a href="?id=' . $tournaments[$j]->tournament_id . '">' . $game->name.' #' . gamenumber($tournaments[$j]->tournament_id, $tournaments[$j]->game_id) . '</a>');
				$table->setText($j + 1, 1, '<a href="game.php?id=' . $tournaments[$j]->game_id . '">' . $game->name . '</a>');
				$table->addCellAttribute($j + 1, 2, 'align', 'center');
				$table->setText($j + 1, 2, $tournament_player);
			}
		}
		$table->draw();
		echo '<br />';
	}
}
include('../modules/footer.php');
?>